SystemOrganization addCategory: #'Smallapack-External'!

CMathLibrary subclass: #ArrayLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!ArrayLibrary commentStamp: '<historical>' prior: 0!
ArrayLibrary implement arithmetic functions on arrays of number!

ArrayLibrary subclass: #ArrayCLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!ArrayCLibrary methodsFor: 'procedures' stamp: ''!
arraystodWithn: n source: source result: result 
	^ArraySLibrary new 
		arraystodWithn: 2 * n
		source: source
		result: result! !

ArrayLibrary subclass: #ArrayDLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!ArrayDLibrary methodsFor: 'procedures' stamp: ''!
arraydtosWithn: n source: source result: result 
	<cdecl: void 'array_dtos'( long double * float * )>
	^self externalCallFailed! !

!ArrayLibrary class methodsFor: 'accessing' stamp: 'nice 8/7/2016 01:43'!
moduleName
	"Library is not yet implemented"
	^nil! !

ArrayLibrary subclass: #ArraySLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!ArraySLibrary methodsFor: 'procedures' stamp: ''!
arraystodWithn: n source: source result: result 
	<cdecl: void 'array_stod'( long float * double * )>
	^self externalCallFailed! !

ArrayLibrary subclass: #ArrayZLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!ArrayZLibrary methodsFor: 'procedures' stamp: ''!
arraydtosWithn: n source: source result: result 
	^ArrayDLibrary new 
		arraydtosWithn: 2 * n
		source: source
		result: result! !

CMathLibrary subclass: #BlasLibrary
	instanceVariableNames: ''
	classVariableNames: 'CompiledWithF2Cconventions MacOsxModuleName UnixModuleName Win32ModuleName'
	poolDictionaries: ''
	category: 'Smallapack-External'!

!BlasLibrary commentStamp: '<historical>' prior: 0!
Interface to BLAS library!

BlasLibrary subclass: #BlasCLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!BlasCLibrary commentStamp: '<historical>' prior: 0!
BlasCLibrary holds BLAS functions for the single precision complex arithmetic!

!BlasCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:25'!
asumF2CWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: double 'scasum_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:42'!
asumWithN: N X: X incX: incX 
	| cARGn cARGincx |
	self class isCompiledWithF2Cconventions ifFalse: [^super asumWithN: N X: X incX: incX].
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	^self 
		asumF2CWithn: cARGn
		x: X
		incx: cARGincx! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: float 'scasum_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'caxpy_'( long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!BlasCLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!BlasCLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'ccopy_'( long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:58'!
dotcF2Cret: retval Withn: n x: x incx: incx y: y incy: incy
	"^transposeConjugate(x)*y"

	<cdecl: void 'cdotc_'( "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:51'!
dotcWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn retval |
	self class isCompiledWithF2Cconventions ifFalse: [^self dotcWithN: N X: X incX: incX Y: Y incY: incY].
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	retval := self allocateFloatComplexArraySize: 1.
	self 
		dotcF2Cret: retval arrayPointer
		Withn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy.
	^retval at: 1! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
dotcWithn: n x: x incx: incx y: y incy: incy
	"^transposeConjugate(x)*y"

	<cdecl: ExternalFloatComplex 'cdotc_'( long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 23:10'!
dotuF2Cret: retval Withn: n x: x incx: incx y: y incy: incy
	"^transpose(x)*y"

	<cdecl: void 'cdotu_'( "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:51'!
dotuWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn retval |
	self class isCompiledWithF2Cconventions ifFalse: [^self dotuWithN: N X: X incX: incX Y: Y incY: incY].
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	retval := self allocateFloatComplexArraySize: 1.
	self 
		dotuF2Cret: retval arrayPointer
		Withn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy.
	^retval at: 1! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
dotuWithn: n x: x incx: incx y: y incy: incy
	"^transpose(x)*y"

	<cdecl: ExternalFloatComplex 'cdotu_'( long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
gemmWithtransa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: ltransa length: ltransb 
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'cgemm_'( char * char * long * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
gemvWithtrans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: ltrans
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cgemv_'( char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
gercWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugate(y)+A"

	<cdecl: void 'cgerc_'( long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
geruWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'cgeru_'( long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
hemmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: lside length: luplo 
	"C=alpha*A*B+beta*C"

	<cdecl: void 'chemm_'( char * char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
hemvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: luplo
	"y=alpha*X+beta*y"

	<cdecl: void 'chemv_'( char * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
hpmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	<cdecl: void 'chpmv_'( char * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'icamax_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:28'!
nrm2F2CWithn: n x: x incx: incx
	"||x||_2"

	<cdecl: double 'scnrm2_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: float 'scnrm2_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
realScalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'csscal_'( long * float * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cscal_'( long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'cswap_'( long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
tpmvWithuplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx length: uploLength length: transLength length: diagLength 
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'ctpmv_'( char * char * char * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long long long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
trmmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'ctrmm_'( char * char * char * char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long long long long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: ''!
trmvWithuplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx length: uploLength length: transLength length: diagLength
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'ctrmv_'( char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long long long )>
	^self externalCallFailed! !

!BlasCLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:02'!
trsmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'ctrsm_'( char * char * char * char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long long long long )>
	^self externalCallFailed! !

BlasLibrary subclass: #BlasDLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!BlasDLibrary commentStamp: '<historical>' prior: 0!
BlasDLibrary holds BLAS functions for the double precision real arithmetic!

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: double 'dasum_'( long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'daxpy_'( long * double * double * long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!BlasDLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aDouble 
	^self cRealPointerOn: aDouble! !

!BlasDLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'dcopy_'( long * double * long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
dotWithn: n x: x incx: incx y: y incy: incy
	<cdecl: double 'ddot_'( long * double * long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
dotcWithn: n x: x incx: incx y: y incy: incy
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
dotuWithn: n x: x incx: incx y: y incy: incy
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!BlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/27/2006 17:12'!
gemmWithtransa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: ltransa length: ltransb
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'dgemm_'( char * char * long* long* long* double * double * long* double * long* double * double * long* long long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: 'nice 5/20/2006 02:21'!
gemvWithtrans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: l
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugate"

	<cdecl: void 'dgemv_'( char* long* long* double* double* long* double* long* double* double* long* long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/27/2006 17:12'!
gerWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'dger_'(long* long* double * double * long* double * long* double * long*)>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
gercWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugated(y)+A"

	^self 
		gerWithm: m
		n: n
		alpha: alpha
		x: x
		incx: incx
		y: y
		incy: incy
		a: a
		lda: lda! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
geruWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	^self 
		gerWithm: m
		n: n
		alpha: alpha
		x: x
		incx: incx
		y: y
		incy: incy
		a: a
		lda: lda! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
hemmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: lside length: luplo 
	"C=alpha*A*B+beta*C"

	^self 
		symmWithside: side
		uplo: uplo
		m: m
		n: n
		alpha: alpha
		a: a
		lda: lda
		b: b
		ldb: ldb
		beta: beta
		c: c
		ldc: ldc
		length: lside
		length: luplo! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
hemvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	^self 
		symvWithuplo: uplo
		n: n
		alpha: alpha
		n: a
		lda: lda
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy
		length: luplo! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
hpmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	^self 
		spmvWithuplo: uplo
		n: n
		alpha: alpha
		ap: ap
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy
		length: luplo! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'idamax_'( long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: double 'dnrm2_'( long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
realScalWithn: n alpha: alpha x: x incx: incx
	^self scalWithn: n alpha: alpha x: x incx: incx! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
rotWithn: n x: x incx: incx y: y incy: incy c: c s: s
	<cdecl: void 'drot_'( long * double * long * double * long * double * double * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
rotgWitha: a b: b c: c s: s
	<cdecl: void 'drotg_'( double * double * double * double * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'dscal_'( long * double * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
spmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	<cdecl: void 'dspmv_'( char * long * double * double * double * long * double * double * long * long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'dswap_'( long * double * long * double * long * )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
symmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: lside length: luplo 
	"C=alpha*A*B+beta*C"

	<cdecl: void 'dsymm_'( char * char * long * long * double * double * long * double * long * double * double * long * long long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
symvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: luplo
	"y=alpha*X+beta*y"

	<cdecl: void 'dsymv_'( char * long * double * double * long * double * long * double * double * long * long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
tpmvWithuplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx length: uploLength length: transLength length: diagLength 
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'dtpmv_'( char * char * char * long * double * double * long * long long long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
trmmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'dtrmm_'( char * char * char * char * long * long * double * double * long * double * long * long long long long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: ''!
trmvWithuplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx length: uploLength length: transLength length: diagLength
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'dtrmv_'( char * char * char * long * double * long * double * long * long long long )>
	^self externalCallFailed! !

!BlasDLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:02'!
trsmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'dtrsm_'( char * char * char * char * long * long * double * double * long * double * long * long long long long )>
	^self externalCallFailed! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/27/2017 22:14'!
isCompiledWithF2Cconventions
	<preference: 'Whether BLAS is compiled with F2C conventions or not'
	category: 'Smallapack'
	description: 'When compiled with F2C conventions, single precision float results are promoted to double precision.'
	type: #Boolean>
	^CompiledWithF2Cconventions ifNil: [ false ]! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/27/2017 22:35'!
isCompiledWithF2Cconventions: aBoolean
	CompiledWithF2Cconventions := aBoolean! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:18'!
macOsxModuleName
	<preference: 'The name of the FORTRAN BLAS library on MacOSX'
	category: 'Smallapack'
	description: 'You might want to pick the veclib version from Accelerated.framework'
	type: #String>
	^MacOsxModuleName ifNil: [ 'libBlas.dylib' ]! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
macOsxModuleName: aString
	MacOsxModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:18'!
unixModuleName
	<preference: 'The name of the FORTRAN BLAS library on Unix'
	category: 'Smallapack'
	description: 'The blas library usually comes with lapack. Check for existing liblapack-dev package.'
	type: #String>
	^UnixModuleName ifNil: [ 'libblas.so' ]! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
unixModuleName: aString
	UnixModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:18'!
win32ModuleName
	<preference: 'The name of the FORTRAN BLAS library on Win32'
	category: 'Smallapack'
	description: 'The blas library usually comes with lapack. Check on http://www.netlib.org.'
	type: #String>
	^Win32ModuleName ifNil: [ 'blas' ]! !

!BlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
win32ModuleName: aString
	Win32ModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:39'!
asumWithN: N X: X incX: incX 
	| cARGn cARGincx |
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	^self 
		asumWithn: cARGn
		x: X
		incx: cARGincx! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
asumWithn: n x: x incx: incx 
	"||real(x)||_1 + ||imag(x)||_1"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:39'!
axpyWithN: N alpha: alpha X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn cARGalpha |
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		axpyWithn: cARGn
		alpha: cARGalpha
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy 
	"y := alpha*x+y"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self subclassResponsibility! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self subclassResponsibility! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aComplex 
	^self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:39'!
copyWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGn cARGincx cARGincy |
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	^self 
		copyWithn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
copyWithn: n x: x incx: incx y: y incy: incy 
	"y := x"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:49'!
dotWithN: N X: X incX: incX Y: Y incY: incY 
	^self dotuWithN: N X: X incX: incX Y: Y incY: incY ! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:38'!
dotcWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn |
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	^self 
		dotcWithn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
dotcWithn: n x: x incx: incx y: y incy: incy 
	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:38'!
dotuWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn |
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	^self 
		dotuWithn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
dotuWithn: n x: x incx: incx y: y incy: incy 
	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 3' stamp: 'nice 6/3/2011 20:38'!
gemmWithTransA: TransA TransB: TransB M: M N: N K: K alpha: alpha A: A lda: lda B: B ldb: ldb beta: beta C: C ldc: ldc 
	| cARGtransa cARGtransb cARGm cARGn cARGk cARGalpha cARGbeta cARGldc cARGlda cARGldb |
	cARGm := self cIntegerPointerOn: M.
	cARGk := self cIntegerPointerOn: K.
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGldb := self cIntegerPointerOn: ldb.
	cARGldc := self cIntegerPointerOn: ldc.
	cARGtransa := self cCharPointerOn: TransA.
	cARGtransb := self cCharPointerOn: TransB.
	cARGalpha := self cElementPointerOn: alpha.
	cARGbeta := self cElementPointerOn: beta.
	^self 
		gemmWithtransa: cARGtransa
		transb: cARGtransb
		m: cARGm
		n: cARGn
		k: cARGk
		alpha: cARGalpha
		a: A
		lda: cARGlda
		b: B
		ldb: cARGldb
		beta: cARGbeta
		c: C
		ldc: cARGldc
		length: 1
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
gemmWithtransa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: ltransa length: ltransb 
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:38'!
gemvWithTransA: TransA M: M N: N alpha: alpha A: A lda: lda X: X incX: incX beta: beta Y: Y incY: incY 
	| cARGtransa cARGm cARGn cARGincx cARGincy cARGalpha cARGbeta cARGlda |
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGtransa := self cCharPointerOn: TransA.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGalpha := self cElementPointerOn: alpha.
	cARGbeta := self cElementPointerOn: beta.
	^self 
		gemvWithtrans: cARGtransa
		m: cARGm
		n: cARGn
		alpha: cARGalpha
		a: A
		lda: cARGlda
		x: X
		incx: cARGincx
		beta: cARGbeta
		y: Y
		incy: cARGincy
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
gemvWithtrans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: l 
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugated"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:37'!
gerWithM: M N: N alpha: alpha X: X incX: incX Y: Y incY: incY A: A lda: lda 
	| cARGm cARGn cARGalpha cARGlda cARGincx cARGincy |
	cARGlda := self cIntegerPointerOn: lda.
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		geruWithm: cARGm
		n: cARGn
		alpha: cARGalpha
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy
		a: A
		lda: cARGlda! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:37'!
gercWithM: M N: N alpha: alpha X: X incX: incX Y: Y incY: incY A: A lda: lda 
	| cARGm cARGn cARGalpha cARGlda cARGincx cARGincy |
	cARGlda := self cIntegerPointerOn: lda.
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		gercWithm: cARGm
		n: cARGn
		alpha: cARGalpha
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy
		a: A
		lda: cARGlda! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
gercWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugated(y)+A"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:37'!
geruWithM: M N: N alpha: alpha X: X incX: incX Y: Y incY: incY A: A lda: lda 
	| cARGm cARGn cARGalpha cARGlda cARGincx cARGincy |
	cARGlda := self cIntegerPointerOn: lda.
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		geruWithm: cARGm
		n: cARGn
		alpha: cARGalpha
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy
		a: A
		lda: cARGlda! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
geruWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 3' stamp: 'nice 6/3/2011 20:37'!
hemmWithSide: Side Uplo: Uplo M: M N: N alpha: alpha A: A lda: lda B: B ldb: ldb beta: beta C: C ldc: ldc 
	| cARGm cARGn cARGalpha cARGbeta cARGldc cARGlda cARGldb cARGside cARGuplo |
	cARGside := self cCharPointerOn: Side.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGldb := self cIntegerPointerOn: ldb.
	cARGldc := self cIntegerPointerOn: ldc.
	cARGalpha := self cElementPointerOn: alpha.
	cARGbeta := self cElementPointerOn: beta.
	^self 
		hemmWithside: cARGside
		uplo: cARGuplo
		m: cARGm
		n: cARGn
		alpha: cARGalpha
		a: A
		lda: cARGlda
		b: B
		ldb: cARGldb
		beta: cARGbeta
		c: C
		ldc: cARGldc
		length: 1
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
hemmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: sideLength length: uploLength 
	"C=alpha*A*B+beta*C"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:36'!
hemvWithUplo: Uplo N: N alpha: alpha A: A lda: lda X: X incX: incX beta: beta Y: Y incY: incY 
	| cARGuplo cARGn cARGincx cARGincy cARGalpha cARGbeta cARGlda |
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGalpha := self cElementPointerOn: alpha.
	cARGbeta := self cElementPointerOn: beta.
	^self 
		hemvWithuplo: cARGuplo
		n: cARGn
		alpha: cARGalpha
		n: A
		lda: cARGlda
		x: X
		incx: cARGincx
		beta: cARGbeta
		y: Y
		incy: cARGincy
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
hemvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: uploLength
	"y=alpha*X+beta*y"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:36'!
hpmvWithUplo: Uplo N: N alpha: alpha Ap: Ap X: X incX: incX beta: beta Y: Y incY: incY 
	| cARGuplo cARGn cARGincx cARGincy cARGalpha cARGbeta |
	cARGn := self cIntegerPointerOn: N.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGalpha := self cElementPointerOn: alpha.
	cARGbeta := self cElementPointerOn: beta.
	^self 
		hpmvWithuplo: cARGuplo
		n: cARGn
		alpha: cARGalpha
		ap: Ap
		x: X
		incx: cARGincx
		beta: cARGbeta
		y: Y
		incy: cARGincy
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
hpmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: uploLength 
	"y=alpha*X+beta*y"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
left
	^$L! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
lower

	^$L! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
nonUnit
	^$N! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
notTransposed
	^$N! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:36'!
realScalWithN: N alpha: alpha X: X incX: incX 
	| cARGn cARGincx cARGalpha |
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGalpha := self cRealPointerOn: alpha.
	^self 
		realScalWithn: cARGn
		alpha: cARGalpha
		x: X
		incx: cARGincx! !

!BlasLibrary methodsFor: 'procedures' stamp: 'nice 2/15/2006 23:23'!
realScalWithn: n alpha: alpha x: x incx: incx
	self subclassResponsibility! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
right
	^$R! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:36'!
scalWithN: N alpha: alpha X: X incX: incX 
	| cARGn cARGincx cARGalpha |
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		scalWithn: cARGn
		alpha: cARGalpha
		x: X
		incx: cARGincx! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
scalWithn: n alpha: alpha x: x incx: incx
	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 20:35'!
swapWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGn cARGincx cARGincy |
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	^self 
		swapWithn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
swapWithn: n x: x incx: incx y: y incy: incy 
	"x <-> y"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:35'!
tpmvWithUplo: Uplo TransA: TransA Diag: Diag N: N Ap: A X: X incX: incX 
	| cARGtransa cARGn cARGincx cARGuplo cARGdiag |
	cARGn := self cIntegerPointerOn: N.
	cARGtransa := self cCharPointerOn: TransA.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGdiag := self cCharPointerOn: Diag.
	cARGincx := self cIntegerPointerOn: incX.
	^self 
		tpmvWithuplo: cARGuplo
		trans: cARGtransa
		diag: cARGdiag
		n: cARGn
		ap: A
		x: X
		incx: cARGincx
		length: 1
		length: 1
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
tpmvWithuplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx length: uploLength length: transLength length: diagLength 
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
transposeConjugated

	^$C! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
transposed
	^$T! !

!BlasLibrary methodsFor: 'blas level 3' stamp: 'nice 6/3/2011 20:35'!
trmmWithSide: Side Uplo: Uplo TransA: TransA Diag: Diag M: M N: N alpha: alpha A: A lda: lda B: B ldb: ldb 
	| cARGm cARGn cARGalpha cARGlda cARGldb cARGside cARGuplo cARGtransa cARGdiag |
	cARGside := self cCharPointerOn: Side.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGtransa := self cCharPointerOn: TransA.
	cARGdiag := self cCharPointerOn: Diag.
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGldb := self cIntegerPointerOn: ldb.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		trmmWithside: cARGside
		uplo: cARGuplo
		trans: cARGtransa
		diag: cARGdiag
		m: cARGm
		n: cARGn
		alpha: cARGalpha
		a: A
		lda: cARGlda
		b: B
		ldb: cARGldb
		length: 1
		length: 1
		length: 1
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
trmmWithside: side uplo: uplo trans: transa diag: diag m: m n: n alpha: alpha a: A lda: lda b: B ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/3/2011 20:34'!
trmvWithUplo: Uplo TransA: TransA Diag: Diag N: N A: A lda: lda X: X incX: incX 
	| cARGtransa cARGn cARGincx cARGlda cARGuplo cARGdiag |
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGtransa := self cCharPointerOn: TransA.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGdiag := self cCharPointerOn: Diag.
	cARGincx := self cIntegerPointerOn: incX.
	^self 
		trmvWithuplo: cARGuplo
		trans: cARGtransa
		diag: cARGdiag
		n: cARGn
		a: A
		lda: cARGlda
		x: X
		incx: cARGincx
		length: 1
		length: 1
		length: 1! !

!BlasLibrary methodsFor: 'procedures' stamp: ''!
trmvWithuplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx length: uploLength length: transLength length: diagLength 
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	self subclassResponsibility! !

!BlasLibrary methodsFor: 'blas level 3' stamp: 'nice 12/18/2011 17:01'!
trsmWithSide: Side Uplo: Uplo TransA: TransA Diag: Diag M: M N: N alpha: alpha A: A lda: lda B: B ldb: ldb 
	| cARGm cARGn cARGalpha cARGlda cARGldb cARGside cARGuplo cARGtransa cARGdiag |
	cARGside := self cCharPointerOn: Side.
	cARGuplo := self cCharPointerOn: Uplo.
	cARGtransa := self cCharPointerOn: TransA.
	cARGdiag := self cCharPointerOn: Diag.
	cARGm := self cIntegerPointerOn: M.
	cARGn := self cIntegerPointerOn: N.
	cARGlda := self cIntegerPointerOn: lda.
	cARGldb := self cIntegerPointerOn: ldb.
	cARGalpha := self cElementPointerOn: alpha.
	^self 
		trsmWithside: cARGside
		uplo: cARGuplo
		trans: cARGtransa
		diag: cARGdiag
		m: cARGm
		n: cARGn
		alpha: cARGalpha
		a: A
		lda: cARGlda
		b: B
		ldb: cARGldb
		length: 1
		length: 1
		length: 1
		length: 1! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
unit
	^$U! !

!BlasLibrary methodsFor: 'accessing' stamp: ''!
upper

	^$U! !

BlasLibrary subclass: #BlasSLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!BlasSLibrary commentStamp: '<historical>' prior: 0!
BlasSLibrary holds BLAS functions for the single precision real arithmetic!

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:24'!
asumF2CWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: double 'sasum_'( long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:43'!
asumWithN: N X: X incX: incX 
	| cARGn cARGincx |
	self class isCompiledWithF2Cconventions ifFalse: [^super asumWithN: N X: X incX: incX].
	cARGn := self cIntegerPointerOn: N.
	cARGincx := self cIntegerPointerOn: incX.
	^self 
		asumF2CWithn: cARGn
		x: X
		incx: cARGincx! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: float 'sasum_'( long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'saxpy_'( long * float * float * long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!BlasSLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aFloat 
	^self cRealPointerOn: aFloat! !

!BlasSLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'scopy_'( long * float * long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:28'!
dotF2CWithn: n x: x incx: incx y: y incy: incy
	<cdecl: double 'sdot_'( long * float * long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
dotWithn: n x: x incx: incx y: y incy: incy
	<cdecl: float 'sdot_'( long * float * long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:31'!
dotcWithn: n x: x incx: incx y: y incy: incy
	self class isCompiledWithF2Cconventions ifTrue: [^self dotF2CWithn: n x: x incx: incx y: y incy: incy].
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:30'!
dotuWithn: n x: x incx: incx y: y incy: incy
	self class isCompiledWithF2Cconventions ifTrue: [^self dotF2CWithn: n x: x incx: incx y: y incy: incy].
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/27/2006 17:10'!
gemmWithtransa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: ltransa length: ltransb
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'sgemm_'( char * char * long* long* long* float * float * long* float * long* float * float * long* long long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/27/2006 17:09'!
gemvWithtrans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: l
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugated"

	<cdecl: void 'sgemv_'( char* long* long* float * float * long* float * long* float* float* long* long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/27/2006 17:11'!
gerWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'sger_'(long* long* float * float * long* float * long* float * long*)>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
gercWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugated(y)+A"

	^self gerWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
geruWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	^self gerWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
hemmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: lside length: luplo 
	"C=alpha*A*B+beta*C"

	^self 
		symmWithside: side
		uplo: uplo
		m: m
		n: n
		alpha: alpha
		a: a
		lda: lda
		b: b
		ldb: ldb
		beta: beta
		c: c
		ldc: ldc
		length: lside
		length: luplo! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
hemvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	^self 
		symvWithuplo: uplo
		n: n
		alpha: alpha
		n: a
		lda: lda
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy
		length: luplo! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
hpmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	^self 
		spmvWithuplo: uplo
		n: n
		alpha: alpha
		ap: ap
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy
		length: luplo! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'isamax_'( long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:28'!
nrm2F2CWithn: n x: x incx: incx
	"||x||_2"

	<cdecl: double 'snrm2_'( long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: float 'snrm2_'( long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
realScalWithn: n alpha: alpha x: x incx: incx
	^self scalWithn: n alpha: alpha x: x incx: incx! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
rotWithn: n x: x incx: incx y: y incy: incy c: c s: s
	<cdecl: void 'srot_'( long * float * long * float * long * float * float * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
rotgWitha: a b: b c: c s: s
	<cdecl: void 'srotg_'( float * float * float * float * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'sscal_'( long * float * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
spmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	<cdecl: void 'sspmv_'( char * long * double * double * double * long * double * double * long * long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'sswap_'( long * float * long * float * long * )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
symmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: lside length: luplo 
	"C=alpha*A*B+beta*C"

	<cdecl: void 'ssymm_'( char * char * long * long * float * float * long * float * long * float * float * long * long long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
symvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: luplo
	"y=alpha*X+beta*y"

	<cdecl: void 'ssymv_'( char * long * double * double * long * double * long * double * double * long * long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
tpmvWithuplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx length: uploLength length: transLength length: diagLength 
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'stpmv_'( char * char * char * long * float * float * long * long long long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
trmmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'strmm_'( char * char * char * char * long * long * float * float * long * float * long * long long long long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: ''!
trmvWithuplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx length: uploLength length: transLength length: diagLength
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'strmv_'( char * char * char * long * float * long * float * long * long long long )>
	^self externalCallFailed! !

!BlasSLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:02'!
trsmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'strsm_'( char * char * char * char * long * long * float * float * long * float * long * long long long long )>
	^self externalCallFailed! !

BlasLibrary subclass: #BlasZLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!BlasZLibrary commentStamp: '<historical>' prior: 0!
BlasZLibrary holds BLAS functions for the double precision complex arithmetic!

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: double 'dzasum_'( long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'zaxpy_'( long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!BlasZLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!BlasZLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 5/20/2006 23:45'!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'zcopy_'( long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 23:11'!
dotcF2Cret: retval Withn: n x: x incx: incx y: y incy: incy
	"^transpose(x)*y"

	<cdecl: void 'zdotu_'( "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:52'!
dotcWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn retval |
	self class isCompiledWithF2Cconventions ifFalse: [^self dotcWithN: N X: X incX: incX Y: Y incY: incY].
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	retval := self allocateDoubleComplexArraySize: 1.
	self 
		dotcF2Cret: retval arrayPointer
		Withn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy.
	^retval at: 1! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
dotcWithn: n x: x incx: incx y: y incy: incy
	"^transposeConjugated(x)*y"

	<cdecl: ExternalDoubleComplex 'zdotc_'( long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 23:12'!
dotuF2Cret: retval Withn: n x: x incx: incx y: y incy: incy
	"^transpose(x)*y"

	<cdecl: void 'zdotu_'( "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'blas level 1' stamp: 'nice 2/5/2017 13:52'!
dotuWithN: N X: X incX: incX Y: Y incY: incY 
	| cARGincx cARGincy cARGn retval |
	self class isCompiledWithF2Cconventions ifFalse: [^self dotuWithN: N X: X incX: incX Y: Y incY: incY].
	cARGincx := self cIntegerPointerOn: incX.
	cARGincy := self cIntegerPointerOn: incY.
	cARGn := self cIntegerPointerOn: N.
	retval := self allocateDoubleComplexArraySize: 1.
	self 
		dotuF2Cret: retval arrayPointer
		Withn: cARGn
		x: X
		incx: cARGincx
		y: Y
		incy: cARGincy.
	^retval at: 1! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
dotuWithn: n x: x incx: incx y: y incy: incy
	"^transpose(x)*y"

	<cdecl: ExternalDoubleComplex 'zdotu_'( long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/21/2010 22:57'!
gemmWithtransa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: ltransa length: ltransb 
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'zgemm_'( char * char * long* long* long* "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long* long long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/21/2010 22:58'!
gemvWithtrans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: ltrans
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugate"

	<cdecl: void 'zgemv_'( char * long* long*  "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long* long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/21/2010 22:59'!
gercWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugated(y)+A"

	<cdecl: void 'zgerc_'(long* long* "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * long*)>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/21/2010 23:00'!
geruWithm: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'zgeru_'(long* long* "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * long* "ExternalDoubleComplex"void * long*)>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
hemmWithside: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc length: lside length: luplo 
	"C=alpha*A*B+beta*C"

	<cdecl: void 'zhemm_'( char * char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
hemvWithuplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy length: luplo
	"y=alpha*X+beta*y"

	<cdecl: void 'zhemv_'( char * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
hpmvWithuplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy length: luplo 
	"y=alpha*X+beta*y"

	<cdecl: void 'zhpmv_'( char * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'izamax_'( long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: double 'dznrm2_'( long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
realScalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'zdscal_'( long * double * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'zscal_'( long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'zswap_'( long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
tpmvWithuplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx length: uploLength length: transLength length: diagLength 
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'ztpmv_'( char * char * char * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long long long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
trmmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'ztrmm_'( char * char * char * char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long long long long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: ''!
trmvWithuplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx length: uploLength length: transLength length: diagLength
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'ztrmv_'( char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long long long )>
	^self externalCallFailed! !

!BlasZLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:02'!
trsmWithside: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb length: lside length: luplo length: ltrans length: ldiag 
	<cdecl: void 'ztrsm_'( char * char * char * char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long long long long )>
	^self externalCallFailed! !

CMathLibrary subclass: #CBlasLibrary
	instanceVariableNames: ''
	classVariableNames: 'MacOsxModuleName UnixModuleName Win32ModuleName'
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CBlasLibrary commentStamp: 'nice 7/29/2016 23:14' prior: 0!
Interface to CBLAS library

C-BLAS is same as BLAS but with C-interface.
That means that dimensions of arrays and other scalars are passed by value.
Thus this should be slightly more efficient than BLAS because Smalltalk does not need to allocate memory to pass those scalars.!

CBlasLibrary subclass: #CBlasCLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CBlasCLibrary commentStamp: 'nice 7/29/2016 23:15' prior: 0!
CBlasCLibrary holds CBLAS functions for the single precision complex arithmetic!

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:41'!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: float 'cblas_scasum'( long  "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:43'!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'cblas_caxpy'( long  "ExternalFloatComplex"void * "ExternalFloatComplex"void * long  "ExternalFloatComplex"void * long  )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:39'!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!CBlasCLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 22:22'!
cElementArgumentOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!CBlasCLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:39'!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!CBlasCLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:39'!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:44'!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'cblas_ccopy'( long  "ExternalFloatComplex"void * long  "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 15:44'!
dotcWithN: N X: X incX: incX Y: Y incY: incY 
	| dotc |
	dotc := ExternalFloatComplexArray with: Complex zero.
	self 
		dotcWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY
		dotc: dotc arrayPointer.
	^dotc at: 1! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:46'!
dotcWithn: n x: x incx: incx y: y incy: incy dotc: dotc
	"dotc := transposeConjugate(x)*y"

	<cdecl: void 'cblas_cdotc_sub'( long  "ExternalFloatComplex"void * long  "ExternalFloatComplex"void * long "ExternalFloatComplex"void * )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 15:47'!
dotuWithN: N X: X incX: incX Y: Y incY: incY 
	| dotu |
	dotu := ExternalFloatComplexArray with: Complex zero.
	self 
		dotuWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY
		dotu: dotu arrayPointer.
	^dotu at: 1! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:47'!
dotuWithn: n x: x incx: incx y: y incy: incy dotu: dotu
	"dotu := transpose(x)*y"

	<cdecl: void 'cblas_cdotu_sub'( long  "ExternalFloatComplex"void * long  "ExternalFloatComplex"void * long "ExternalFloatComplex"void * )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:50'!
gemmWithorder: order transa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'cblas_cgemm'( long long long long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long  "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:52'!
gemvWithorder: order trans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_cgemv'( long long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long  "ExternalFloatComplex"void * long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:53'!
gercWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugate(y)+A"

	<cdecl: void 'cblas_cgerc'( long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:54'!
geruWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'cblas_cgeru'( long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:58'!
hemmWithorder: order side: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C=alpha*A*B+beta*C"

	<cdecl: void 'cblas_chemm'( long long long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:58'!
hemvWithorder: order uplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_chemv'( long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:59'!
hpmvWithorder: order uplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_chpmv'( long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:00'!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'cblas_icamax'( long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:01'!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: float 'cblas_scnrm2'( long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:02'!
realScalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cblas_csscal'( long float "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:02'!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cblas_cscal'( long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:03'!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'cblas_cswap'( long "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:04'!
tpmvWithorder: order uplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_ctpmv'( long long long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:06'!
trmmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_ctrmm'( long long long long long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:12'!
trmvWithorder: order uplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_ctrmv'( long long long long long "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

!CBlasCLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:03'!
trsmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_ctrsm'( long long long long long long long "ExternalFloatComplex"void * "ExternalFloatComplex"void * long "ExternalFloatComplex"void * long )>
	^self externalCallFailed! !

CBlasLibrary subclass: #CBlasDLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CBlasDLibrary commentStamp: 'nice 7/29/2016 23:15' prior: 0!
CBlasDLibrary holds CBLAS functions for the double precision real arithmetic!

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:21'!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: double 'cblas_dasum'( long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:41'!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'cblas_daxpy'( long double double * long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:18'!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!CBlasDLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:18'!
cElementArgumentOn: aDouble 
	^aDouble! !

!CBlasDLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:18'!
cElementPointerOn: aDouble 
	^self cRealPointerOn: aDouble! !

!CBlasDLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:19'!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:22'!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'cblas_dcopy'( long double * long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:22'!
dotWithn: n x: x incx: incx y: y incy: incy
	<cdecl: double 'cblas_ddot'( long double * long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:22'!
dotcWithn: n x: x incx: incx y: y incy: incy
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:23'!
dotuWithn: n x: x incx: incx y: y incy: incy
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:41'!
gemmWithorder: order transa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'cblas_dgemm'( long long long long long long double double * long double * long double double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:42'!
gemvWithorder: order trans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugate"

	<cdecl: void 'cblas_dgemv'( long long long long double double * long double * long double double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:42'!
gerWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'cblas_dger'( long long long double double * long double * long double * long)>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:26'!
gercWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugated(y)+A"

	^self 
		gerWithorder: order
		m: m
		n: n
		alpha: alpha
		x: x
		incx: incx
		y: y
		incy: incy
		a: a
		lda: lda! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:26'!
geruWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	^self 
		gerWithorder: order
		m: m
		n: n
		alpha: alpha
		x: x
		incx: incx
		y: y
		incy: incy
		a: a
		lda: lda! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:27'!
hemmWithorder: order side: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C=alpha*A*B+beta*C"

	^self 
		symmWithorder: order
		side: side
		uplo: uplo
		m: m
		n: n
		alpha: alpha
		a: a
		lda: lda
		b: b
		ldb: ldb
		beta: beta
		c: c
		ldc: ldc! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:27'!
hemvWithorder: order uplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	^self 
		symvWithorder: order
		uplo: uplo
		n: n
		alpha: alpha
		n: a
		lda: lda
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:28'!
hpmvWithorder: order uplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	^self 
		spmvWithorder: order
		uplo: uplo
		n: n
		alpha: alpha
		ap: ap
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:28'!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'cblas_idamax'( long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:29'!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: double 'cblas_dnrm2'( long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:29'!
realScalWithn: n alpha: alpha x: x incx: incx
	^self scalWithn: n alpha: alpha x: x incx: incx! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:31'!
rotWithn: n x: x incx: incx y: y incy: incy c: c s: s
	<cdecl: void 'cblas_drot'( long double * long double * long double double )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:33'!
rotgWitha: a b: b c: c s: s
	<cdecl: void 'cblas_drotg'( double * double * double * double * )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:34'!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cblas_dscal'( long double double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:43'!
spmvWithorder: order uplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_dspmv'( long long long double double * double * long double double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:35'!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'cblas_dswap'( long double * long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:43'!
symmWithorder: order side: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C=alpha*A*B+beta*C"

	<cdecl: void 'cblas_dsymm'( long long long long long double double * long double * long double double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:43'!
symvWithorder: order uplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy 
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_dsymv'( long long long double double * long double * long double double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:38'!
tpmvWithorder: order uplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_dtpmv'( long long long long long double * double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:40'!
trmmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_dtrmm'( long long long long long long long double double * long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:40'!
trmvWithorder: order uplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_dtrmv'( long long long long long double * long double * long )>
	^self externalCallFailed! !

!CBlasDLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:03'!
trsmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_dtrsm'( long long long long long long long double double * long double * long )>
	^self externalCallFailed! !

!CBlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:17'!
macOsxModuleName
	<preference: 'The name of the C-BLAS library on MacOSX'
	category: 'Smallapack'
	description: 'You might want to pick the veclib version from Accelerated.framework'
	type: #String>
	^MacOsxModuleName ifNil: [ 'libBlas.dylib' ]! !

!CBlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
macOsxModuleName: aString
	MacOsxModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!CBlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:18'!
unixModuleName
	<preference: 'The name of the C-BLAS library on Unix'
	category: 'Smallapack'
	description: 'The cblas library usually comes with recent versions of lapack. Check for existing liblapack-dev package.'
	type: #String>
	^UnixModuleName ifNil: [ 'libcblas.so' ]! !

!CBlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
unixModuleName: aString
	UnixModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!CBlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:18'!
win32ModuleName
	<preference: 'The name of the C-BLAS library on Win32'
	category: 'Smallapack'
	description: 'The cblas library usually comes with recent versions of lapack. Check on http://www.netlib.org.'
	type: #String>
	^Win32ModuleName ifNil: [ 'cblas' ]! !

!CBlasLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
win32ModuleName: aString
	Win32ModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:08'!
asumWithN: N X: X incX: incX 
	^self 
		asumWithn: N
		x: X
		incx: incX! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 15:31'!
axpyWithN: N alpha: alpha X: X incX: incX Y: Y incY: incY 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		axpyWithn: N
		alpha: cARGalpha
		x: X
		incx: incX
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:38'!
cComplexPointerOn: aComplex 
	^self subclassResponsibility! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 22:22'!
cElementArgumentOn: aComplex 
	^self subclassResponsibility! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:38'!
cElementPointerOn: aComplex 
	^self subclassResponsibility! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:38'!
cRealPointerOn: aComplex 
	^self subclassResponsibility! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:37'!
colMajor
	^102! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:37'!
conjugated
	^114! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:11'!
copyWithN: N X: X incX: incX Y: Y incY: incY 
	^self 
		copyWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:57'!
dotWithN: N X: X incX: incX Y: Y incY: incY 
	^self 
		dotuWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:57'!
dotcWithN: N X: X incX: incX Y: Y incY: incY 
	^self 
		dotcWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:57'!
dotuWithN: N X: X incX: incX Y: Y incY: incY 
	^self 
		dotuWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 3' stamp: 'nice 6/1/2011 22:22'!
gemmWithTransA: TransA TransB: TransB M: M N: N K: K alpha: alpha A: A lda: lda B: B ldb: ldb beta: beta C: C ldc: ldc 
	| cARGalpha cARGbeta |
	cARGalpha := self cElementArgumentOn: alpha.
	cARGbeta := self cElementArgumentOn: beta.
	^self 
		gemmWithorder: self colMajor
		transa: TransA
		transb: TransB
		m: M
		n: N
		k: K
		alpha: cARGalpha
		a: A
		lda: lda
		b: B
		ldb: ldb
		beta: cARGbeta
		c: C
		ldc: ldc! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:29'!
gemvWithTransA: TransA M: M N: N alpha: alpha A: A lda: lda X: X incX: incX beta: beta Y: Y incY: incY 
	| cARGalpha cARGbeta |
	cARGalpha := self cElementArgumentOn: alpha.
	cARGbeta := self cElementArgumentOn: beta.
	^self 
		gemvWithorder: self colMajor
		trans: TransA
		m: M
		n: N
		alpha: cARGalpha
		a: A
		lda: lda
		x: X
		incx: incX
		beta: cARGbeta
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:38'!
gerWithM: M N: N alpha: alpha X: X incX: incX Y: Y incY: incY A: A lda: lda 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		geruWithorder: self colMajor
		m: M
		n: N
		alpha: cARGalpha
		x: X
		incx: incX
		y: Y
		incy: incY
		a: A
		lda: lda! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:38'!
gercWithM: M N: N alpha: alpha X: X incX: incX Y: Y incY: incY A: A lda: lda 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		gercWithorder: self colMajor
		m: M
		n: N
		alpha: cARGalpha
		x: X
		incx: incX
		y: Y
		incy: incY
		a: A
		lda: lda! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:38'!
geruWithM: M N: N alpha: alpha X: X incX: incX Y: Y incY: incY A: A lda: lda 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		geruWithorder: self colMajor
		m: M
		n: N
		alpha: cARGalpha
		x: X
		incx: incX
		y: Y
		incy: incY
		a: A
		lda: lda! !

!CBlasLibrary methodsFor: 'blas level 3' stamp: 'nice 6/1/2011 22:25'!
hemmWithSide: Side Uplo: Uplo M: M N: N alpha: alpha A: A lda: lda B: B ldb: ldb beta: beta C: C ldc: ldc 
	| cARGalpha cARGbeta |
	cARGalpha := self cElementArgumentOn: alpha.
	cARGbeta := self cElementArgumentOn: beta.
	^self 
		hemmWithorder: self colMajor
		side: Side
		uplo: Uplo
		m: M
		n: N
		alpha: cARGalpha
		a: A
		lda: lda
		b: B
		ldb: ldb
		beta: cARGbeta
		c: C
		ldc: ldc! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:46'!
hemvWithUplo: Uplo N: N alpha: alpha A: A lda: lda X: X incX: incX beta: beta Y: Y incY: incY 
	| cARGalpha cARGbeta |
	cARGalpha := self cElementArgumentOn: alpha.
	cARGbeta := self cElementArgumentOn: beta.
	self 
		hemvWithorder: self colMajor
		uplo: Uplo
		n: N
		alpha: cARGalpha
		n: A
		lda: lda
		x: X
		incx: incX
		beta: cARGbeta
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:47'!
hpmvWithUplo: Uplo N: N alpha: alpha Ap: Ap X: X incX: incX beta: beta Y: Y incY: incY 
	| cARGalpha cARGbeta |
	cARGalpha := self cElementArgumentOn: alpha.
	cARGbeta := self cElementArgumentOn: beta.
	^self 
		hpmvWithorder: self colMajor
		uplo: Uplo
		n: N
		alpha: cARGalpha
		ap: Ap
		x: X
		incx: incX
		beta: cARGbeta
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:35'!
left
	^141! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:35'!
lower
	^122! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:36'!
nonUnit
	^131! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:36'!
notTransposed
	^111! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:16'!
realScalWithN: N alpha: alpha X: X incX: incX 
	^self 
		realScalWithn: N
		alpha: alpha
		x: X
		incx: incX! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:35'!
right
	^142! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:37'!
rowMajor
	^101! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:50'!
scalWithN: N alpha: alpha X: X incX: incX 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		scalWithn: N
		alpha: cARGalpha
		x: X
		incx: incX! !

!CBlasLibrary methodsFor: 'blas level 1' stamp: 'nice 6/1/2011 22:17'!
swapWithN: N X: X incX: incX Y: Y incY: incY 
	^self 
		swapWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:48'!
tpmvWithUplo: Uplo TransA: TransA Diag: Diag N: N Ap: A X: X incX: incX 
	^self 
		tpmvWithorder: self colMajor
		uplo: Uplo
		trans: TransA
		diag: Diag
		n: N
		ap: A
		x: X
		incx: incX! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:37'!
transposeConjugated
	^113! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:36'!
transposed
	^112! !

!CBlasLibrary methodsFor: 'blas level 3' stamp: 'nice 6/1/2011 22:26'!
trmmWithSide: Side Uplo: Uplo TransA: TransA Diag: Diag M: M N: N alpha: alpha A: A lda: lda B: B ldb: ldb 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		trmmWithorder: self colMajor
		side: Side
		uplo: Uplo
		trans: TransA
		diag: Diag
		m: M
		n: N
		alpha: cARGalpha
		a: A
		lda: lda
		b: B
		ldb: ldb! !

!CBlasLibrary methodsFor: 'blas level 2' stamp: 'nice 6/1/2011 22:49'!
trmvWithUplo: Uplo TransA: TransA Diag: Diag N: N A: A lda: lda X: X incX: incX 
	^self 
		trmvWithorder: self colMajor
		uplo: Uplo
		trans: TransA
		diag: Diag
		n: N
		a: A
		lda: lda
		x: X
		incx: incX! !

!CBlasLibrary methodsFor: 'blas level 3' stamp: 'nice 12/18/2011 17:04'!
trsmWithSide: Side Uplo: Uplo TransA: TransA Diag: Diag M: M N: N alpha: alpha A: A lda: lda B: B ldb: ldb 
	| cARGalpha |
	cARGalpha := self cElementArgumentOn: alpha.
	^self 
		trsmWithorder: self colMajor
		side: Side
		uplo: Uplo
		trans: TransA
		diag: Diag
		m: M
		n: N
		alpha: cARGalpha
		a: A
		lda: lda
		b: B
		ldb: ldb! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:36'!
unit
	^132! !

!CBlasLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:35'!
upper
	^121! !

CBlasLibrary subclass: #CBlasSLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CBlasSLibrary commentStamp: 'nice 7/29/2016 23:15' prior: 0!
CBlasSLibrary holds CBLAS functions for the single precision real arithmetic!

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:21'!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: float 'cblas_sasum'( long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:41'!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'cblas_saxpy'( long float float * long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:18'!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!CBlasSLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:18'!
cElementArgumentOn: aFloat 
	^aFloat! !

!CBlasSLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:18'!
cElementPointerOn: aFloat 
	^self cRealPointerOn: aFloat! !

!CBlasSLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 23:19'!
cRealPointerOn: aFloat 
	^self cFloatPointerOn: aFloat! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:22'!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'cblas_scopy'( long float * long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:22'!
dotWithn: n x: x incx: incx y: y incy: incy
	<cdecl: float 'cblas_sdot'( long float * long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:22'!
dotcWithn: n x: x incx: incx y: y incy: incy
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:23'!
dotuWithn: n x: x incx: incx y: y incy: incy
	^self dotWithn: n x: x incx: incx y: y incy: incy! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:41'!
gemmWithorder: order transa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'cblas_sgemm'( long long long long long long float float * long float * long float float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:42'!
gemvWithorder: order trans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugate"

	<cdecl: void 'cblas_sgemv'( long long long long float float * long float * long float float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:42'!
gerWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'cblas_sger'( long long long float float * long float * long float * long)>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:26'!
gercWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugated(y)+A"

	^self 
		gerWithorder: order
		m: m
		n: n
		alpha: alpha
		x: x
		incx: incx
		y: y
		incy: incy
		a: a
		lda: lda! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:26'!
geruWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	^self 
		gerWithorder: order
		m: m
		n: n
		alpha: alpha
		x: x
		incx: incx
		y: y
		incy: incy
		a: a
		lda: lda! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:27'!
hemmWithorder: order side: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C=alpha*A*B+beta*C"

	^self 
		symmWithorder: order
		side: side
		uplo: uplo
		m: m
		n: n
		alpha: alpha
		a: a
		lda: lda
		b: b
		ldb: ldb
		beta: beta
		c: c
		ldc: ldc! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:27'!
hemvWithorder: order uplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	^self 
		symvWithorder: order
		uplo: uplo
		n: n
		alpha: alpha
		n: a
		lda: lda
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:28'!
hpmvWithorder: order uplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	^self 
		spmvWithorder: order
		uplo: uplo
		n: n
		alpha: alpha
		ap: ap
		x: x
		incx: incx
		beta: beta
		y: y
		incy: incy! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:48'!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'cblas_isamax'( long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:29'!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: float 'cblas_snrm2'( long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:29'!
realScalWithn: n alpha: alpha x: x incx: incx
	^self scalWithn: n alpha: alpha x: x incx: incx! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:31'!
rotWithn: n x: x incx: incx y: y incy: incy c: c s: s
	<cdecl: void 'cblas_srot'( long float * long float * long float float )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:33'!
rotgWitha: a b: b c: c s: s
	<cdecl: void 'cblas_srotg'( float * float * float * float * )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:34'!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cblas_sscal'( long float float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:43'!
spmvWithorder: order uplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_sspmv'( long long long float float * float * long float float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:35'!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'cblas_sswap'( long float * long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:43'!
symmWithorder: order side: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C=alpha*A*B+beta*C"

	<cdecl: void 'cblas_ssymm'( long long long long long float float * long float * long float float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:43'!
symvWithorder: order uplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy 
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_ssymv'( long long long float float * long float * long float float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:38'!
tpmvWithorder: order uplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_stpmv'( long long long long long float * float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:40'!
trmmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_strmm'( long long long long long long long float float * long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:40'!
trmvWithorder: order uplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_strmv'( long long long long long float * long float * long )>
	^self externalCallFailed! !

!CBlasSLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:03'!
trsmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_strsm'( long long long long long long long float float * long float * long )>
	^self externalCallFailed! !

CBlasLibrary subclass: #CBlasZLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CBlasZLibrary commentStamp: 'nice 7/29/2016 23:15' prior: 0!
CBlasZLibrary holds CBLAS functions for the double precision complex arithmetic!

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/3/2011 15:16'!
asumWithn: n x: x incx: incx
	"||real(x)||_1 + ||imag(x)||_1"

	<cdecl: double 'cblas_dzasum'( long  "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:43'!
axpyWithn: n alpha: alpha x: x incx: incx y: y incy: incy
	"y := alpha*x+y"

	<cdecl: void 'cblas_zaxpy'( long  "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long  "ExternalDoubleComplex"void * long  )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:39'!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!CBlasZLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 22:22'!
cElementArgumentOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!CBlasZLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:39'!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!CBlasZLibrary methodsFor: 'accessing' stamp: 'nice 6/1/2011 21:39'!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:44'!
copyWithn: n x: x incx: incx y: y incy: incy
	"y := x"

	<cdecl: void 'cblas_zcopy'( long  "ExternalDoubleComplex"void * long  "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 15:47'!
dotcWithN: N X: X incX: incX Y: Y incY: incY 
	| dotc |
	dotc := ExternalDoubleComplexArray with: Complex zero.
	self 
		dotcWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY
		dotc: dotc arrayPointer.
	^dotc at: 1! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:46'!
dotcWithn: n x: x incx: incx y: y incy: incy dotc: dotc
	"dotc := transposeConjugate(x)*y"

	<cdecl: void 'cblas_zdotc_sub'( long  "ExternalDoubleComplex"void * long  "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'blas level 1' stamp: 'nice 6/3/2011 15:47'!
dotuWithN: N X: X incX: incX Y: Y incY: incY 
	| dotu |
	dotu := ExternalDoubleComplexArray with: Complex zero.
	self 
		dotuWithn: N
		x: X
		incx: incX
		y: Y
		incy: incY
		dotu: dotu arrayPointer.
	^dotu at: 1! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:47'!
dotuWithn: n x: x incx: incx y: y incy: incy dotu: dotu
	"dotu := transpose(x)*y"

	<cdecl: void 'cblas_zdotu_sub'( long  "ExternalDoubleComplex"void * long  "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:50'!
gemmWithorder: order transa: transa transb: transb m: m n: n k: k alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C:=alpha*op(A)*op(B)+beta*C  , C has dimension (m,n)"

	<cdecl: void 'cblas_zgemm'( long long long long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long  "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:52'!
gemvWithorder: order trans: trans m: m n: n alpha: alpha a: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*op(X)+beta*y op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_zgemv'( long long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long  "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:53'!
gercWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transposeConjugate(y)+A"

	<cdecl: void 'cblas_zgerc'( long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:54'!
geruWithorder: order m: m n: n alpha: alpha x: x incx: incx y: y incy: incy a: a lda: lda 
	"A=alpha*x*transpose(y)+A"

	<cdecl: void 'cblas_zgeru'( long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:58'!
hemmWithorder: order side: side uplo: uplo m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb beta: beta c: c ldc: ldc
	"C=alpha*A*B+beta*C"

	<cdecl: void 'cblas_zhemm'( long long long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:58'!
hemvWithorder: order uplo: uplo n: n alpha: alpha n: a lda: lda x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_zhemv'( long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 21:59'!
hpmvWithorder: order uplo: uplo n: n alpha: alpha ap: ap x: x incx: incx beta: beta y: y incy: incy
	"y=alpha*X+beta*y"

	<cdecl: void 'cblas_zhpmv'( long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:13'!
iamaxWithn: n x: x incx: incx
	"index of max : max_i (abs(real(x_i))+abs(imag(x_i)))"

	<cdecl: long 'cblas_izamax'( long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:13'!
nrm2Withn: n x: x incx: incx
	"||x||_2"

	<cdecl: double 'cblas_sznrm2'( long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/3/2011 15:58'!
realScalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cblas_zdscal'( long double "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:02'!
scalWithn: n alpha: alpha x: x incx: incx
	<cdecl: void 'cblas_zscal'( long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:03'!
swapWithn: n x: x incx: incx y: y incy: incy
	"x <-> y"

	<cdecl: void 'cblas_zswap'( long "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:04'!
tpmvWithorder: order uplo: uplo trans: trans diag: diag n: n ap: ap x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_ztpmv'( long long long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 22:06'!
trmmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_ztrmm'( long long long long long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 6/1/2011 23:12'!
trmvWithorder: order uplo: uplo trans: trans diag: diag n: n a: a lda: lda x: x incx: incx
	"x=op(a)*x op=yourself, transpose, transposeConjugated"

	<cdecl: void 'cblas_ztrmv'( long long long long long "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

!CBlasZLibrary methodsFor: 'procedures' stamp: 'nice 12/18/2011 17:03'!
trsmWithorder: order side: side uplo: uplo trans: trans diag: diag m: m n: n alpha: alpha a: a lda: lda b: b ldb: ldb
	<cdecl: void 'cblas_ztrsm'( long long long long long long long "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long "ExternalDoubleComplex"void * long )>
	^self externalCallFailed! !

CMathLibrary subclass: #CLapackLibrary
	instanceVariableNames: ''
	classVariableNames: 'CompiledWithF2Cconventions MacOsxModuleName UnixModuleName Win32ModuleName'
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CLapackLibrary commentStamp: '<historical>' prior: 0!
Interface to LAPACK library as compiled via f2c.
Note that the the length of character arguments is not passed to the routines, except fot ilaenv.!

CLapackLibrary subclass: #CLapackCLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CLapackCLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!CLapackCLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!CLapackCLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!CLapackCLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^true! !

!CLapackCLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^false! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  CGEBAK forms the right or left eigenvectors of a complex general
*  matrix by backward transformation on the computed eigenvectors of the
*  balanced matrix output by CGEBAL.
"

	<cdecl: long 'cgebak_'( char * char * long * long * long * float * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info 
	"
*  Purpose
*  =======
*  CGEBAL balances a general complex matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'cgebal_'( char * long * "ExternalFloatComplex"void * long * long * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGECON estimates the reciprocal of the condition number of a general
*  complex matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by CGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'cgecon_'( char * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  CGEES computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues, the Schur form T, and, optionally, the matrix of Schur
*  vectors Z.  This gives the Schur factorization A = Z*T*(Z**H).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A complex matrix is in Schur form if it is upper triangular.
"

	<cdecl: long 'cgees_'( char * char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info 	"
*  Purpose
*  =======
*  CGEEV computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'cgeev_'( char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgeevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGEEVX computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  SCALE, and ABNRM), reciprocal condition numbers for the eigenvalues
*  (RCONDE), and reciprocal condition numbers for the right
*  eigenvectors (RCONDV).
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
*  Balancing a matrix means permuting the rows and columns to make it
*  more nearly upper triangular, and applying a diagonal similarity
*  transformation D * A * D**(-1), where D is a diagonal matrix, to
*  make its rows and columns closer in norm and the condition numbers
*  of its eigenvalues and eigenvectors smaller.  The computed
*  reciprocal condition numbers correspond to the balanced matrix.
*  Permuting rows and columns will not change the condition numbers
*  (in exact arithmetic) but diagonal scaling will.  For further
*  explanation of balancing, see section 4.10.2 of the LAPACK
*  Users' Guide.
"

	<cdecl: long 'cgeevx_'( char * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * float * float * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'cgehrd_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGELQF computes an LQ factorization of a complex M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'cgelqf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGELS solves overdetermined or underdetermined complex linear systems
*  involving an M-by-N matrix A, or its conjugate-transpose, using a QR
*  or LQ factorization of A.  It is assumed that A has full rank.
*  The following options are provided:
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'C' and m >= n:  find the minimum norm solution of
*     an undetermined system A**H * X = B.
*  4. If TRANS = 'C' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**H * X ||.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
"

	<cdecl: long 'cgels_'( char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  CGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder tranformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'cgelsd_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * long * "ExternalFloatComplex"void * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGELSS computes the minimum norm solution to a complex linear
*  least squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'cgelss_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine CGELSY.
*  CGELSX computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'cgelsx_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * float * long * "ExternalFloatComplex"void * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGELSY computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
"

	<cdecl: long 'cgelsy_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * float * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGEQLF computes a QL factorization of a complex M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'cgeqlf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'cgeqp3_'( long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGEQRF computes a QR factorization of a complex M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'cgeqrf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGERQF computes an RQ factorization of a complex M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'cgerqf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  CGESDD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors, by using divide-and-conquer method. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**H, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'cgesdd_'( char * long * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CGESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'cgesv_'( long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGESVD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**H, not V.
"

	<cdecl: long 'cgesvd_'( char * char * long * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  CGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'cgetrf_'( long * long * "ExternalFloatComplex"void * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGETRI computes the inverse of a matrix using the LU factorization
*  computed by CGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'cgetri_'( long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CGETRS solves a system of linear equations
*     A * X = B,  A**T * X = B,  or  A**H * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by CGETRF.
"

	<cdecl: long 'cgetrs_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  CGGBAK forms the right or left eigenvectors of a complex generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  CGGBAL.
"

	<cdecl: long 'cggbak_'( char * char * long * long * long * float * float * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info 
	"
*  Purpose
*  =======
*  CGGBAL balances a pair of general complex matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'cggbal_'( char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long * float * float * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:45'!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGGEV computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B), the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right generalized eigenvector v(j) corresponding to the
*  generalized eigenvalue lambda(j) of (A,B) satisfies
*               A * v(j) = lambda(j) * B * v(j).
*  The left generalized eigenvector u(j) corresponding to the
*  generalized eigenvalues lambda(j) of (A,B) satisfies
*               u(j)**H * A = lambda(j) * u(j)**H * B
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'cggev_'( char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  CGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'cggevx_'( char * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * float * float * float * float * "ExternalFloatComplex"void * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  CGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'cggevx_'( char * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * float * float * float * float * "ExternalFloatComplex"void * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'cggglm_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info 
	"
*  Purpose
*  =======
*  CGGHRD reduces a pair of complex matrices (A,B) to generalized upper
*  Hessenberg form using unitary transformations, where A is a
*  general matrix and B is upper triangular.  The form of the generalized
*  eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the unitary matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**H*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**H*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**H*x.
*  The unitary matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**H = (Q1*Q) * H * (Z1*Z)**H
*       Q1 * B * Z1**H = (Q1*Q) * T * (Z1*Z)**H
*  If Q1 is the unitary matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then CGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'cgghrd_'( char * char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'cgglse_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary matrix,
*  and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of matrix Z.
"

	<cdecl: long 'cggqrf_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of the matrix Z.
"

	<cdecl: long 'cggrqf_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:46'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  CGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N complex matrix A and P-by-N complex matrix B:
*        U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are unitary matrices, and Z' means the conjugate
*  transpose of Z.  Let K+L = the effective numerical rank of the
*  matrix (A',B')', then R is a (K+L)-by-(K+L) nonsingular upper
*  triangular matrix, D1 and D2 are M-by-(K+L) and P-by-(K+L) 'diagonal'
*  matrices and of the following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the unitary
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthnormal columns, then the GSVD of A and B is also
*  equal to the CS decomposition of A and B. Furthermore, the GSVD can
*  be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, and D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                        X = Q*(  I   0    )
*                              (  0 inv(R) )
"

	<cdecl: long 'cggsvd_'( char * char * char * long * long * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * float * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xheconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 
	"
*  Purpose
*  =======
*  CHECON estimates the reciprocal of the condition number of a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by CHETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'checon_'( char * long * "ExternalFloatComplex"void * long * long * float * float * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork info: info 
	<cdecl: void 'cheev_'( char * char * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  CHEEVD computes all eigenvalues and, optionally, eigenvectors of a
*  complex Hermitian matrix A.  If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'cheevd_'( char * char * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  CHEEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix T.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, CHEEVR calls CSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  CSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : CHEEVR calls CSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  CHEEVR calls SSTEBZ and CSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of CSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'cheevr_'( char * char * char * long * "ExternalFloatComplex"void * long * float * float * long * long * float * long * float * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  CHEEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix A.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
"

	<cdecl: long 'cheevx_'( char * char * char * long * "ExternalFloatComplex"void * long * float * float * long * long * float * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CHEGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be Hermitian and B is also
*  positive definite.
"

	<cdecl: long 'chegv_'( long * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  CHEGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'chegvd_'( long * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  CHEGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'chegvx_'( long * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * long * long * float * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CHESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**H,  if UPLO = 'U', or
*     A = L * D * L**H,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'chesv_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CHETRF computes the factorization of a complex Hermitian matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**H  or  A = L*D*L**H
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'chetrf_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  CHETRI computes the inverse of a complex Hermitian indefinite matrix
*  A using the factorization A = U*D*U**H or A = L*D*L**H computed by
*  CHETRF.
"

	<cdecl: long 'chetri_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CHETRS solves a system of linear equations A*X = B with a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by CHETRF.
"

	<cdecl: long 'chetrs_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlacgvWithn: n x: x incx: incx 
	"
*  Purpose
*  =======
*  CLACGV conjugates a complex vector of length N.
"

	<cdecl: long 'clacgv_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 
	"
*  Purpose
*  =======
*  CLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'clacpy_'( char * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:43'!
xlangeF2CWithnorm: norm m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex matrix A.
"

	<cdecl: double 'clange_'( char * long * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex matrix A.
"

	<cdecl: float 'clange_'( char * long * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:44'!
xlanheF2CWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANHE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A.
"

	<cdecl: double 'clanhe_'( char * char * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANHE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A.
"

	<cdecl: float 'clanhe_'( char * char * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:44'!
xlanhpF2CWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  CLANHP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A,  supplied in packed form.
"

	<cdecl: double 'clanhp_'( char * char * long * "ExternalFloatComplex"void * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlanhpWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  CLANHP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A,  supplied in packed form.
"

	<cdecl: float 'clanhp_'( char * char * long * "ExternalFloatComplex"void * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:44'!
xlanspF2CWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  CLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'clansp_'( char * char * long * "ExternalFloatComplex"void * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  CLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A,  supplied in packed form.
"

	<cdecl: float 'clansp_'( char * char * long * "ExternalFloatComplex"void * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:44'!
xlansyF2CWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
"

	<cdecl: double 'clansy_'( char * char * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
"

	<cdecl: float 'clansy_'( char * char * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:44'!
xlantpF2CWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  CLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'clantp_'( char * char * char * long * "ExternalFloatComplex"void * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  CLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: float 'clantp_'( char * char * char * long * "ExternalFloatComplex"void * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:44'!
xlantrF2CWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'clantr_'( char * char * char * long * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  CLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: float 'clantr_'( char * char * char * long * long * "ExternalFloatComplex"void * long * float * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  CLARNV returns a vector of n random complex numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'clarnv_'( long * long * long * "ExternalFloatComplex"void * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 
	"
*  Purpose
*  =======
*  CLASET initializes a 2-D array A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'claset_'( char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  CPOTRF computes the Cholesky factorization of a complex Hermitian
*  positive definite matrix A.
*  The factorization has the form
*     A = U**H * U,  if UPLO = 'U', or
*     A = L  * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'cpotrf_'( char * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 
	"
*  Purpose
*  =======
*  CSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by CSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'csycon_'( char * long * "ExternalFloatComplex"void * long * long * float * float * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CSYSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'csysv_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CSYTRF computes the factorization of a complex symmetric matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  with 1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'csytrf_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  CSYTRI computes the inverse of a complex symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  CSYTRF.
"

	<cdecl: long 'csytri_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CSYTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by CSYTRF.
"

	<cdecl: long 'csytrs_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst info: info 
	"
*  Purpose
*  =======
*  CTGEXC reorders the generalized Schur decomposition of a complex
*  matrix pair (A,B), using an unitary equivalence transformation
*  (A, B) := Q * (A, B) * Z', so that the diagonal block of (A, B) with
*  row index IFST is moved to row ILST.
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'ctgexc_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  CTGSEN reorders the generalized Schur decomposition of a complex
*  matrix pair (A, B) (in terms of an unitary equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the pair (A,B). The leading
*  columns of Q and Z form unitary bases of the corresponding left and
*  right eigenspaces (deflating subspaces). (A, B) must be in
*  generalized Schur canonical form, that is, A and B are both upper
*  triangular.
*  CTGSEN also computes the generalized eigenvalues
*           w(j)= ALPHA(j) / BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, the routine computes estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'ctgsen_'( long * long * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * float * "ExternalFloatComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  CTGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C            (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with complex entries. A, B, D and E are upper
*  triangular (i.e., (A,D) and (B,E) in generalized Schur form).
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1
*  is an output scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve Zx = scale*b, where Z
*  is defined as
*         Z = [ kron(In, A)  -kron(B', Im) ]        (2)
*             [ kron(In, D)  -kron(E', Im) ],
*  Here Ix is the identity matrix of size x and X' is the conjugate
*  transpose of X. Kron(X, Y) is the Kronecker product between the
*  matrices X and Y.
*  If TRANS = 'C', y in the conjugate transposed system Z'*y = scale*b
*  is solved for, which is equivalent to solve for R and L in
*              A' * R + D' * L = scale * C           (3)
*              R * B' + L * E' = scale * -F
*  This case (TRANS = 'C') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using CLACON.
*  If IJOB >= 1, CTGSYL computes a Frobenius norm-based estimate of
*  Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z.
*  This is a level-3 BLAS algorithm.
"

	<cdecl: long 'ctgsyl_'( char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ctpcon_'( char * char * char * long * "ExternalFloatComplex"void * float * "ExternalFloatComplex"void * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info 
	"
*  Purpose
*  =======
*  CTPTRI computes the inverse of a complex upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'ctptri_'( char * char * long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CTPTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'ctptrs_'( char * char * char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ctrcon_'( char * char * char * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst info: info 
	"
*  Purpose
*  =======
*  CTREXC reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*  is moved to row ILST.
*  The Schur form T is reordered by a unitary similarity transformation
*  Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*  postmultplying it with Z.
"

	<cdecl: long 'ctrexc_'( char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CTRSEN reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that a selected cluster of eigenvalues appears in
*  the leading positions on the diagonal of the upper triangular matrix
*  T, and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
"

	<cdecl: long 'ctrsen_'( char * char * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info 
	"
*  Purpose
*  =======
*  CTRSYL solves the complex Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**H, and A and B are both upper triangular. A is
*  M-by-M and B is N-by-N; the right hand side C and the solution X are
*  M-by-N; and scale is an output scale factor, set <= 1 to avoid
*  overflow in X.
"

	<cdecl: long 'ctrsyl_'( char * char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  CTRTRI computes the inverse of a complex upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'ctrtri_'( char * char * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CTRTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'ctrtrs_'( char * char * char * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xunghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'cunghr_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xunglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGLQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k)' . . . H(2)' H(1)'
*  as returned by CGELQF.
"

	<cdecl: long 'cunglq_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGQL generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by CGEQLF.
"

	<cdecl: long 'cungql_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGQR generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by CGEQRF.
"

	<cdecl: long 'cungqr_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackCLibrary methodsFor: 'procedures' stamp: ''!
xungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGRQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1)' H(2)' . . . H(k)'
*  as returned by CGERQF.
"

	<cdecl: long 'cungrq_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

CLapackLibrary subclass: #CLapackDLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CLapackDLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!CLapackDLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aDouble 
	^self cRealPointerOn: aDouble! !

!CLapackDLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!CLapackDLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^false! !

!CLapackDLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^true! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  DGEBAK forms the right or left eigenvectors of a real general matrix
*  by backward transformation on the computed eigenvectors of the
*  balanced matrix output by DGEBAL.
"

	<cdecl: long 'dgebak_'( char * char * long * long * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info 
	"
*  Purpose
*  =======
*  DGEBAL balances a general real matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'dgebal_'( char * long * double * long * long * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DGECON estimates the reciprocal of the condition number of a general
*  real matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by DGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'dgecon_'( char * long * double * long * double * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  DGEES computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues, the real Schur form T, and, optionally, the matrix of
*  Schur vectors Z.  This gives the Schur factorization A = Z*T*(Z**T).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  real Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A matrix is in real Schur form if it is upper quasi-triangular with
*  1-by-1 and 2-by-2 blocks. 2-by-2 blocks will be standardized in the
*  form
*          [  a  b  ]
*          [  c  a  ]
*  where b*c < 0. The eigenvalues of such a block are a +- sqrt(bc).
"

	<cdecl: long 'dgees_'( char * char * long * long * double * long * long * double * double * double * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEEV computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'dgeev_'( char * char * long * double * long * double * double * double * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'dgehrd_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELQF computes an LQ factorization of a real M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'dgelqf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELS solves overdetermined or underdetermined real linear systems
*  involving an M-by-N matrix A, or its transpose, using a QR or LQ
*  factorization of A.  It is assumed that A has full rank.
*  The following options are provided:
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'T' and m >= n:  find the minimum norm solution of
*     an undetermined system A**T * X = B.
*  4. If TRANS = 'T' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**T * X ||.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
"

	<cdecl: long 'dgels_'( char * long * long * long * double * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder transformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'dgelsd_'( long * long * long * double * long * double * long * double * double * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELSS computes the minimum norm solution to a real linear least
*  squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'dgelss_'( long * long * long * double * long * double * long * double * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine DGELSY.
*  DGELSX computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'dgelsx_'( long * long * long * double * long * double * long * long * double * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELSY computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
"

	<cdecl: long 'dgelsy_'( long * long * long * double * long * double * long * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEQLF computes a QL factorization of a real M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'dgeqlf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'dgeqp3_'( long * long * double * long * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEQRF computes a QR factorization of a real M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'dgeqrf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGERQF computes an RQ factorization of a real M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'dgerqf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DGESDD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and right singular
*  vectors.  If singular vectors are desired, it uses a
*  divide-and-conquer algorithm.
*  The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**T, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'dgesdd_'( char * long * long * double * long * double * double * long * double * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  DGESV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'dgesv_'( long * long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGESVD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**T, not V.
"

	<cdecl: long 'dgesvd_'( char * char * long * long * double * long * double * double * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  DGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'dgetrf_'( long * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGETRI computes the inverse of a matrix using the LU factorization
*  computed by DGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'dgetri_'( long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  DGETRS solves a system of linear equations
*     A * X = B  or  A' * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by DGETRF.
"

	<cdecl: long 'dgetrs_'( char * long * long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info  
	"
*  Purpose
*  =======
*  DGGBAK forms the right or left eigenvectors of a real generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  DGGBAL.
"

	<cdecl: long 'dggbak_'( char * char * long * long * long * double * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info 
	"
*  Purpose
*  =======
*  DGGBAL balances a pair of general real matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'dggbal_'( char * long * double * long * double * long * long * long * double * double * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGEV computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j).
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B .
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'dggev_'( char * char * long * double * long * double * long * double * double * double * double * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  DGGEVX computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'dggevx_'( char * char * char * char * long * double * long * double * long * double * double * double * double * long * double * long * double * double * double * double * double * double * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'dggglm_'( long * long * long * double * long * double * long * double * double * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info 
	"
*  Purpose
*  =======
*  DGGHRD reduces a pair of real matrices (A,B) to generalized upper
*  Hessenberg form using orthogonal transformations, where A is a
*  general matrix and B is upper triangular.  The form of the
*  generalized eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the orthogonal matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**T*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**T*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**T*x.
*  The orthogonal matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**T = (Q1*Q) * H * (Z1*Z)**T
*       Q1 * B * Z1**T = (Q1*Q) * T * (Z1*Z)**T
*  If Q1 is the orthogonal matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then DGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'dgghrd_'( char * char * long * long * long * double * long * double * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'dgglse_'( long * long * long * double * long * double * long * double * double * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'dggqrf_'( long * long * long * double * long * double * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'dggrqf_'( long * long * long * double * long * double * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:40'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N real matrix A and P-by-N real matrix B:
*      U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are orthogonal matrices, and Z' is the transpose
*  of Z.  Let K+L = the effective numerical rank of the matrix (A',B')',
*  then R is a K+L-by-K+L nonsingular upper triangular matrix, D1 and
*  D2 are M-by-(K+L) and P-by-(K+L) 'diagonal' matrices and of the
*  following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the orthogonal
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthonormal columns, then the GSVD of A and B is
*  also equal to the CS decomposition of A and B. Furthermore, the GSVD
*  can be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                       X = Q*( I   0    )
*                             ( 0 inv(R) ).
"

	<cdecl: long 'dggsvd_'( char * char * char * long * long * long * long * long * double * long * double * long * double * double * double * long * double * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 
	^self 
		xsysvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: lwork
		info: info! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	^self 
		xsytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork
		info: info! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	^self 
		xsytriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		info: info! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	^self 
		xsytrsWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		info: info! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 
	"
*  Purpose
*  =======
*  DLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'dlacpy_'( char * long * long * double * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlamchWithcmach: cmach 
	"
*  Purpose
*  =======
*  DLAMCH determines double precision machine parameters.
"

	<cdecl: double 'dlamch_'( char * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  DLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real matrix A.
"

	<cdecl: double 'dlange_'( char * long * long * double * long * double * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  DLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'dlansp_'( char * char * long * double * double * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  DLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
"

	<cdecl: double 'dlansy_'( char * char * long * double * long * double * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  DLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'dlantp_'( char * char * char * long * double * double * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  DLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'dlantr_'( char * char * char * long * long * double * long * double * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  DLARNV returns a vector of n random real numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'dlarnv_'( long * long * long * double * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 
	"
*  Purpose
*  =======
*  DLASET initializes an m-by-n matrix A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'dlaset_'( char * long * long * double * double * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xorghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'dorghr_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xorglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGLQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by DGELQF.
"

	<cdecl: long 'dorglq_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xorgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGQL generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by DGEQLF.
"

	<cdecl: long 'dorgql_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xorgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGQR generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by DGEQRF.
"

	<cdecl: long 'dorgqr_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xorgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGRQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by DGERQF.
"

	<cdecl: long 'dorgrq_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  DPOTRF computes the Cholesky factorization of a real symmetric
*  positive definite matrix A.
*  The factorization has the form
*     A = U**T * U,  if UPLO = 'U', or
*     A = L  * L**T,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'dpotrf_'( char * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by DSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'dsycon_'( char * long * double * long * long * double * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DSYEV computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A.
"

	<cdecl: long 'dsyev_'( char * char * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  DSYEVD computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A. If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*  Because of large use of BLAS of level 3, DSYEVD needs N**2 more
*  workspace than DSYEVX.
"

	<cdecl: long 'dsyevd_'( char * char * long * double * long * double * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  DSYEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix T.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, DSYEVR calls DSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  DSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : DSYEVR calls DSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  DSYEVR calls DSTEBZ and SSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of DSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'dsyevr_'( char * char * char * long * double * long * double * double * long * long * double * long * double * double * long * long * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  DSYEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of indices
*  for the desired eigenvalues.
"

	<cdecl: long 'dsyevx_'( char * char * char * long * double * long * double * double * long * long * double * long * double * double * long * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DSYGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be symmetric and B is also
*  positive definite.
"

	<cdecl: long 'dsygv_'( long * char * char * long * double * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  DSYGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be symmetric and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'dsygvd_'( long * char * char * long * double * long * double * long * double * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  DSYGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A
*  and B are assumed to be symmetric and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'dsygvx_'( long * char * char * char * long * double * long * double * long * double * double * long * long * double * long * double * double * long * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DSYSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'dsysv_'( char * long * long * double * long * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DSYTRF computes the factorization of a real symmetric matrix A using
*  the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'dsytrf_'( char * long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  DSYTRI computes the inverse of a real symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  DSYTRF.
"

	<cdecl: long 'dsytri_'( char * long * double * long * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  DSYTRS solves a system of linear equations A*X = B with a real
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by DSYTRF.
"

	<cdecl: long 'dsytrs_'( char * long * long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DTGEXC reorders the generalized real Schur decomposition of a real
*  matrix pair (A,B) using an orthogonal equivalence transformation
*                 (A, B) = Q * (A, B) * Z',
*  so that the diagonal block of (A, B) with row index IFST is moved
*  to row ILST.
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by DGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'dtgexc_'( long * long * long * double * long * double * long * double * long * double * long * long * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  DTGSEN reorders the generalized real Schur decomposition of a real
*  matrix pair (A, B) (in terms of an orthonormal equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the upper quasi-triangular
*  matrix A and the upper triangular B. The leading columns of Q and
*  Z form orthonormal bases of the corresponding left and right eigen-
*  spaces (deflating subspaces). (A, B) must be in generalized real
*  Schur canonical form (as returned by DGGES), i.e. A is block upper
*  triangular with 1-by-1 and 2-by-2 diagonal blocks. B is upper
*  triangular.
*  DTGSEN also computes the generalized eigenvalues
*              w(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, DTGSEN computes the estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'dtgsen_'( long * long * long * long * long * double * long * double * long * double * double * double * double * long * double * long * long * double * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DTGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C                 (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with real entries. (A, D) and (B, E) must be in
*  generalized (real) Schur canonical form, i.e. A, B are upper quasi
*  triangular and D, E are upper triangular.
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve  Zx = scale b, where
*  Z is defined as
*             Z = [ kron(In, A)  -kron(B', Im) ]         (2)
*                 [ kron(In, D)  -kron(E', Im) ].
*  Here Ik is the identity matrix of size k and X' is the transpose of
*  X. kron(X, Y) is the Kronecker product between the matrices X and Y.
*  If TRANS = 'T', DTGSYL solves the transposed system Z'*y = scale*b,
*  which is equivalent to solve for R and L in
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * (-F)
*  This case (TRANS = 'T') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using DLACON.
*  If IJOB >= 1, DTGSYL computes a Frobenius norm-based estimate
*  of Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z. See [1-2] for more
*  information.
*  This is a level 3 BLAS algorithm.
"

	<cdecl: long 'dtgsyl_'( char * long * long * long * double * long * double * long * double * long * double * long * double * long * double * long * double * double * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'dtpcon_'( char * char * char * long * double * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info 
	"
*  Purpose
*  =======
*  DTPTRI computes the inverse of a real upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'dtptri_'( char * char * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  DTPTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'dtptrs_'( char * char * char * long * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'dtrcon_'( char * char * char * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work info: info 
	"
*  Purpose
*  =======
*  DTREXC reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that the diagonal block of T with row index IFST is
*  moved to row ILST.
*  The real Schur form T is reordered by an orthogonal similarity
*  transformation Z**T*T*Z, and optionally the matrix Q of Schur vectors
*  is updated by postmultiplying it with Z.
*  T must be in Schur canonical form (as returned by DHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'dtrexc_'( char * long * double * long * double * long * long * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  DTRSEN reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that a selected cluster of eigenvalues appears in
*  the leading diagonal blocks of the upper quasi-triangular matrix T,
*  and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
*  T must be in Schur canonical form (as returned by DHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elemnts equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'dtrsen_'( char * char * long * long * double * long * double * long * double * double * long * double * double * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info 
	"
*  Purpose
*  =======
*  DTRSYL solves the real Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**T, and  A and B are both upper quasi-
*  triangular. A is M-by-M and B is N-by-N; the right hand side C and
*  the solution X are M-by-N; and scale is an output scale factor, set
*  <= 1 to avoid overflow in X.
*  A and B must be in Schur canonical form (as returned by DHSEQR), that
*  is, block upper triangular with 1-by-1 and 2-by-2 diagonal blocks;
*  each 2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'dtrsyl_'( char * char * long * long * long * double * long * double * long * double * long * double * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  DTRTRI computes the inverse of a real upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'dtrtri_'( char * char * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  DTRTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'dtrtrs_'( char * char * char * long * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/27/2017 23:30'!
isCompiledWithF2Cconventions
	<preference: 'Whether C LAPACK is compiled with F2C conventions or not'
	category: 'Smallapack'
	description: 'When compiled with F2C conventions, single precision float results are promoted to double precision.'
	type: #Boolean>
	^CompiledWithF2Cconventions ifNil: [ true ]! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/27/2017 23:30'!
isCompiledWithF2Cconventions: aBoolean
	CompiledWithF2Cconventions := aBoolean! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:19'!
macOsxModuleName
	<preference: 'The name of the C-LAPACK library on MacOSX'
	category: 'Smallapack'
	description: 'You might want to pick the veclib version from Accelerated.framework'
	type: #String>
	^MacOsxModuleName ifNil: [ 'libLapack.dylib' ]! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:55'!
macOsxModuleName: aString
	MacOsxModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:19'!
unixModuleName
	<preference: 'The name of the C-Lapack library on Unix'
	category: 'Smallapack'
	description: 'The C-lapack library might be provided with Altlas.'
	type: #String>
	^UnixModuleName ifNil: [ 'libclapack.so' ]! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:56'!
unixModuleName: aString
	UnixModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:19'!
win32ModuleName
	<preference: 'The name of the C-Lapack library on Win32'
	category: 'Smallapack'
	description: 'The C-lapack library might be provided with Altlas.'
	type: #String>
	^Win32ModuleName ifNil: [ 'clapack' ]! !

!CLapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:56'!
win32ModuleName: aString
	Win32ModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
allEigenValues
	^$A! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: ''!
allSingularVector
	^$A! !

!CLapackLibrary methodsFor: 'accessing' stamp: 'nice 2/16/2006 00:01'!
allocateComplexArraySize: anInteger 
	^self isDoublePrecision
		ifTrue: [self allocateDoubleComplexArraySize: anInteger]
		ifFalse: [self allocateFloatComplexArraySize: anInteger]! !

!CLapackLibrary methodsFor: 'accessing' stamp: 'nice 2/16/2006 00:02'!
allocateElementArraySize: anInteger 
	^self isReal
		ifTrue: [self allocateRealArraySize: anInteger]
		ifFalse: [self allocateComplexArraySize: anInteger]! !

!CLapackLibrary methodsFor: 'accessing' stamp: 'nice 2/16/2006 00:01'!
allocateRealArraySize: anInteger 
	^self isDoublePrecision
		ifTrue: [self allocateDoubleArraySize: anInteger]
		ifFalse: [self allocateFloatArraySize: anInteger]! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: ''!
balanceDoNothing
	"balance do nothing, means finding ilo and ihi bounds of non triangular submatrix"

	^$N! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: ''!
balancePermute
	^$P! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: ''!
balancePermuteAndScale
	^$B! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: ''!
balanceScale
	^$S! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'machine precision' stamp: ''!
dlamch: cmach 
	"extract doublereal precision machine parameters
	.	'E' or 'e',   DLAMCH := eps
	.	'S' or 's ,   DLAMCH := sfmin
	.	'B' or 'b',   DLAMCH := base
	.	'P' or 'p',   DLAMCH := eps*base
	.	'N' or 'n',   DLAMCH := t
	.	'R' or 'r',   DLAMCH := rnd
	.	'M' or 'm',   DLAMCH := emin
	.	'U' or 'u',   DLAMCH := rmin
	.	'L' or 'l',   DLAMCH := emax
	.	'O' or 'o',   DLAMCH := rmax
	where
	.	eps   = relative machine precision
	.	sfmin = safe minimum, such that 1/sfmin does not overflow
	.	base  = base of the machine
	.	prec  = eps*base
	.	t     = number of (base) digits in the mantissa
	.	rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
	.	emin  = minimum exponent before (gradual) underflow
	.	rmin  = underflow threshold - base**(emin-1)
	.	emax  = largest exponent before overflow
	.	rmax  = overflow threshold  - (base**emax)*(1-eps)"

	<cdecl: double 'dlamch_'( char * )>! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
doComputeVector
	"used by eigen value or svd decomposition"

	^$V! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
dontComputeVector
	"used by eigen value or svd decomposition"

	^$N! !

!CLapackLibrary methodsFor: 'machine precision' stamp: ''!
eps
	"return relative machine precision"

	^self lamch: $E! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: 'nice 6/26/2010 18:50'!
gebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv 
	"balance back a general matrix
	ilo and ihi must be allocated outside this routine"


	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgebakWithjob: (self cCharPointerOn: job)
		side: (self cCharPointerOn: side)
		n: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		scale: scale
		m: (self cIntegerPointerOn: m)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: 'nice 6/3/2011 17:25'!
gebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale 
	"balance a general matrix
	ilo and ihi must be allocated outside this routine"

	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgebalWithjob: (self cCharPointerOn: job)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ilo: ilo
		ihi: ihi
		scale: scale
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
geconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeconWithnorm: (self cCharPointerOn: norm)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		anorm: (self cElementPointerOn: anorm)
		rcond: rcond
		work: work
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
geconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeconWithnorm: (self cCharPointerOn: norm)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		anorm: (self cRealPointerOn: anorm)
		rcond: rcond
		work: work
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/3/2011 18:17'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs 
	"schur decomposition (for complex general matrices)
	Note: sdim must be allocated outside
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork bwork lwork |
	work := self allocateElementArraySize: 1.
	bwork := self allocateLogicalArraySize: n.
	rwork := self allocateRealArraySize: n.
	(self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		w: w
		vs: vs
		ldvs: ldvs
		work: work
		lwork: -1
		rwork: rwork
		bwork: bwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 2 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		w: w
		vs: vs
		ldvs: ldvs
		work: work
		lwork: lwork
		rwork: rwork
		bwork: bwork! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/27/2010 21:32'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork 
	"schur decomposition (for complex general matrices)
	Note: sdim must be allocated outsied"

	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self 
		xgeesWithjobvs: (self cCharPointerOn: jobvs)
		sort: (self cCharPointerOn: sort)
		select: select
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		sdim: sdim
		w: w
		vs: vs
		ldvs: (self cIntegerPointerOn: ldvs)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		bwork: bwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/3/2011 18:17'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs 
	"schur decomposition (for real general matrices)
	Note: sdim must be allocated outside
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work bwork lwork |
	work := self allocateElementArraySize: 1.
	bwork := self allocateLogicalArraySize: n.
	(self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		wr: wr
		wi: wi
		vs: vs
		ldvs: ldvs
		work: work
		lwork: -1
		bwork: bwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 3 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		wr: wr
		wi: wi
		vs: vs
		ldvs: ldvs
		work: work
		lwork: lwork
		bwork: bwork! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/3/2011 18:18'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork 
	"schur decomposition (for real general matrices)
	Note: sdim must be allocated outsied"

	| cARGjobvs cARGsort cARGn cARGlda cARGldvs cARGlwork cARGinfo |
	cARGjobvs := self cCharPointerOn: jobvs.
	cARGsort := self cCharPointerOn: sort.
	cARGn := self cIntegerPointerOn: n.
	cARGlda := self cIntegerPointerOn: lda.
	cARGldvs := self cIntegerPointerOn: ldvs.
	cARGlwork := self cIntegerPointerOn: lwork.
	cARGinfo := self cIntegerPointerOn: 0.
	self 
		xgeesWithjobvs: cARGjobvs
		sort: cARGsort
		select: select
		n: cARGn
		a: a
		lda: cARGlda
		sdim: sdim
		wr: wr
		wi: wi
		vs: vs
		ldvs: cARGldvs
		work: work
		lwork: cARGlwork 
		bwork: bwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 18:19'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"eigenvalue/vector decomposition (for complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: 2 * n.
	(self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		w: w
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1
		rwork: rwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 2 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		w: w
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork
		rwork: rwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:10'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork 
	"eigenvalue/vector decomposition (for complex general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 18:19'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"eigenvalue/vector decomposition (for real general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		wr: wr
		wi: wi
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		wr: wr
		wi: wi
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:41'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork 
	"eigenvalue/vector decomposition (for real general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		wr: wr
		wi: wi
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
geevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeevxWithbalanc: (self cCharPointerOn: balanc)
		jobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		sense: (self cCharPointerOn: sense)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		scale: scale
		abnrm: abnrm
		rconde: rconde
		rcondv: rcondv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 18:18'!
gehrdWithn: n a: a lda: lda tau: tau 
	"hessenberg decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork ilo ihi |
	work := self allocateElementArraySize: 1.
	ilo := self cIntegerPointerOn: 1.
	ihi := self cIntegerPointerOn: n.
	(self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 18:20'!
gehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau 
	"hessenberg decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK
	ilo and ihi must be allocated outside"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/26/2010 19:14'!
gehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork 
	"hessenberg decomposition (for real/complex general matrices)
	ilo and ihi must be allocated outside this routine"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgehrdWithn: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
gelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelqfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsWithtrans: (self cCharPointerOn: trans)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 18:21'!
gelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank 
	"least squares by SVD divide and conquer algorithm
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork iwork smlsiz nlvl minmn |
	minmn := 1 max: (m min: n).
	^self isComplex 
		ifTrue: 
			[
			smlsiz := self 
						ilaenvWithispec: 9
						name: 'CGELSD'
						opts: ' '
						n1: 0
						n2: 0
						n3: 0
						n4: 0.
			nlvl := 1 + (minmn / (smlsiz + 1)) floorLog2.
			work := self allocateElementArraySize: 1.
			iwork := self allocateIntegerArraySize: 3 * minmn * nlvl + (11 * minmn).
			rwork := self allocateRealArraySize: (m >= n 
								ifTrue: [8 * n + (2 * n * smlsiz) + (8 * n * nlvl) + (n * nrhs)]
								ifFalse: [8 * m + (2 * m * smlsiz) + (8 * m * nlvl) + (m * nrhs)]).
			(self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: -1
				rwork: rwork
				iwork: iwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: 
					[lwork := m >= n 
								ifTrue: [1 max: n * (2 + nrhs)]
								ifFalse: [1 max: m * (2 + nrhs)]].
			work := self allocateElementArraySize: lwork.
			self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				rwork: rwork
				iwork: iwork]
		ifFalse: 
			[
			smlsiz := self 
						ilaenvWithispec: 9
						name: 'SGELSD'
						opts: ' '
						n1: 0
						n2: 0
						n3: 0
						n4: 0.
			nlvl := 1 + (minmn / (smlsiz + 1)) floorLog2.
			work := self allocateElementArraySize: 1.
			iwork := self allocateIntegerArraySize: 3 * minmn * nlvl + (11 * minmn).
			(self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				iwork: iwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: 
					[lwork := m >= n 
								ifTrue: [11 * n + (2 * n * smlsiz) + (8 * n * nlvl) + (n * nrhs)]
								ifFalse: [11 * m + (2 * m * smlsiz) + (8 * m * nlvl) + (m * nrhs)]].
			work := self allocateElementArraySize: lwork.
			self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				iwork: iwork]! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsdWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsdWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 18:21'!
gelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank 
	"least squares by SVD
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: (5 * (m min: n) max: 1).
			(self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 1 max: (m min: n) * 2 + (nrhs max: (m max: n))].
			work := self allocateElementArraySize: lwork.
			self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: 
					[lwork := 1 
								max: (m min: n) * 3 + ((nrhs max: (m max: n)) max: 2 * (m min: n))].
			work := self allocateElementArraySize: lwork.
			self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork]! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelssWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelssWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsxWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsxWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 18:22'!
gelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank 
	"least squares by complete orthogonalization
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| mn work rwork lwork |
	mn := m min: n.
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: (2 * n max: 1).
			(self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 1 max: mn + (2 * mn max: (n + 1 max: mn + nrhs))].
			work := self allocateElementArraySize: lwork.
			self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 1 max: (n * 3 + 1 + mn max: mn * 2 + nrhs)].
			work := self allocateElementArraySize: lwork.
			self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork]! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsyWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsyWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
geqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqlfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 18:22'!
geqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau 
	"qr decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: 2 * n.
			(self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := n + 1].
			work := self allocateElementArraySize: lwork.
			self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 3 * n + 1].
			work := self allocateElementArraySize: lwork.
			self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: lwork]! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
geqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqp3Withm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		jpvt: jpvt
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
geqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqp3Withm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		jpvt: jpvt
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 18:22'!
geqrfWithm: m n: n a: a lda: lda tau: tau 
	"qr decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		geqrfWithm: m
		n: n
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geqrfWithm: m
		n: n
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/26/2010 19:42'!
geqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	"qr decomposition (for real/complex general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqrfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
gerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgerqfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
gesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesddWithjobz: (self cCharPointerOn: jobz)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
gesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesddWithjobz: (self cCharPointerOn: jobz)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:18'!
gesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	"find x such that a*x=b, that is solve a linear system of equations
	on return:
		x is stored in b on return
		a contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		ipiv contains permutations of rows P of P*L*U decomposition
	return:
		info contains error code is not 0"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesvWithn: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/3/2011 18:23'!
gesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt 
	"singular value/vector decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: 5 * (m min: n).
			(self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 2 * (m min: n) + (m max: n)].
			work := self allocateElementArraySize: lwork.
			self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 3 * (m min: n) + (m max: n) max: 5 * (m min: n)].
			work := self allocateElementArraySize: lwork.
			self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: lwork]! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/26/2010 19:21'!
gesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork 
	"singular value/vector decomposition (for real general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesvdWithjobu: (self cCharPointerOn: jobu)
		jobvt: (self cCharPointerOn: jobvt)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/26/2010 19:22'!
gesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork 
	"singular value/vector decomposition (for complex general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesvdWithjobu: (self cCharPointerOn: jobu)
		jobvt: (self cCharPointerOn: jobvt)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:19'!
getrfWithm: m n: n a: a lda: lda ipiv: ipiv 
	"P*L*U decomposition of a general matrix
	return 0 if OK"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgetrfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 18:23'!
getriWithn: n a: a lda: lda ipiv: ipiv 
	"inverse of a general matrix"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		getriWithn: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 10 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		getriWithn: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
getriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgetriWithn: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:19'!
getrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	"Solve a general system of equations A*x=B in x"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgetrsWithtrans: (self cCharPointerOn: trans)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: 'nice 6/26/2010 19:02'!
ggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggbakWithjob: (self cCharPointerOn: job)
		side: (self cCharPointerOn: side)
		n: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		lscale: lscale
		rscale: rscale
		m: (self cIntegerPointerOn: m)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-balance' stamp: ''!
ggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggbalWithjob: (self cCharPointerOn: job)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		ilo: ilo
		ihi: ihi
		lscale: lscale
		rscale: rscale
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:19'!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"generalized eigenvalue/vector decomposition (for complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: 8 * n.
	(self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alpha: alpha
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1
		rwork: rwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 1 max: 2 * n].
	work := self allocateElementArraySize: lwork.
	^self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alpha: alpha
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork
		rwork: rwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:19'!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"generalized eigenvalue/vector decomposition (for real general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alphar: alphar
		alphai: alphai
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 1 max: 8 * n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alphar: alphar
		alphai: alphai
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alphar: alphar
		alphai: alphai
		beta: beta
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:32'!
ggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork 
	"use perform: to avoid exceding maximum frame size"
	| cARGinfo args |
	cARGinfo := self cIntegerPointerOn: 0.
	args := {
		"xggevxWithbalanc:" (self cCharPointerOn: balanc).
		"jobvl:" (self cCharPointerOn: jobvl).
		"jobvr:" (self cCharPointerOn: jobvr).
		"sense:" (self cCharPointerOn: sense).
		"n:" (self cIntegerPointerOn: n)
		"a:" a.
		"lda:" (self cIntegerPointerOn: lda).
		"b:" b.
		"ldb:" (self cIntegerPointerOn: ldb).
		"alpha:" alpha.
		"beta:" beta.
		"vl:" vl.
		"ldvl:" (self cIntegerPointerOn: ldvl).
		"vr:" vr.
		"ldvr:" (self cIntegerPointerOn: ldvr).
		"lscale:" lscale.
		"rscale:" rscale.
		"abnrm:" abnrm.
		"bbnrm:" bbnrm.
		"rconde:" rconde.
		"rcondv:" rcondv.
		"work:" work.
		"lwork:" (self cIntegerPointerOn: lwork).
		"rwork:" rwork.
		"iwork:" iwork.
		"bwork:" bwork.
		"info:" cARGinfo.
	}.
	self perform: #xggevxWithbalanc:jobvl:jobvr:sense:n:a:lda:b:ldb:alpha:beta:vl:ldvl:vr:ldvr:lscale:rscale:abnrm:bbnrm:rconde:rcondv:work:lwork:rwork:iwork:bwork:info: withArguments: args.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:38'!
ggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork 
	"Use perform: to avoid exceding maximum frame size"
	| args cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	args := {
		"xggevxWithbalanc:" (self cCharPointerOn: balanc).
		"jobvl:" (self cCharPointerOn: jobvl).
		"jobvr:" (self cCharPointerOn: jobvr).
		"sense:" (self cCharPointerOn: sense).
		"n:" (self cIntegerPointerOn: n).
		"a:" a.
		"lda:" (self cIntegerPointerOn: lda).
		"b:" b.
		"ldb:" (self cIntegerPointerOn: ldb).
		"alphar:" alphar.
		"alphai:" alphai.
		"beta:" beta.
		"vl:" vl.
		"ldvl:" (self cIntegerPointerOn: ldvl).
		"vr:" vr.
		"ldvr:" (self cIntegerPointerOn: ldvr).
		"lscale:" lscale.
		"rscale:" rscale.
		"abnrm:" abnrm.
		"bbnrm:" bbnrm.
		"rconde:" rconde.
		"rcondv:" rcondv.
		"work:" work.
		"lwork:" (self cIntegerPointerOn: lwork).
		"iwork:" iwork.
		"bwork:" bwork.
		"info:" cARGinfo.
	}.
	self perform: #xggevxWithbalanc:jobvl:jobvr:sense:n:a:lda:b:ldb:alphar:alphai:beta:vl:ldvl:vr:ldvr:lscale:rscale:abnrm:bbnrm:rconde:rcondv:work:lwork:iwork:bwork:info: withArguments: args.
	^cARGinfo getHandle signedLongAt: 1
! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
ggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggglmWithn: (self cIntegerPointerOn: n)
		m: (self cIntegerPointerOn: m)
		p: (self cIntegerPointerOn: p)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		d: d
		x: x
		y: y
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: ''!
gghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgghrdWithcompq: (self cCharPointerOn: compq)
		compz: (self cCharPointerOn: compz)
		n: (self cIntegerPointerOn: n)
		ilo: (self cIntegerPointerOn: ilo)
		ihi: (self cIntegerPointerOn: ihi)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 20:18'!
gglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x 
	"least squares subject to equality constraints by orthogonalization
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"
	
	| work lwork |
	work := self allocateElementArraySize: 1.
	(self
			gglseWithm: m
			n: n
			p: p
			a: a
			lda: lda
			b: b
			ldb: ldb
			c: c
			d: d
			x: x
			work: work
			lwork: -1)
			= 0
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 1 max: m + n + p].
	work := self allocateElementArraySize: lwork.
	^self
		gglseWithm: m
		n: n
		p: p
		a: a
		lda: lda
		b: b
		ldb: ldb
		c: c
		d: d
		x: x
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgglseWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		p: (self cIntegerPointerOn: p)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		c: c
		d: d
		x: x
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
ggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggqrfWithn: (self cIntegerPointerOn: n)
		m: (self cIntegerPointerOn: m)
		p: (self cIntegerPointerOn: p)
		a: a
		lda: (self cIntegerPointerOn: lda)
		taua: taua
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		taub: taub
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
ggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggrqfWithm: (self cIntegerPointerOn: m)
		p: (self cIntegerPointerOn: p)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		taua: taua
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		taub: taub
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/26/2010 19:40'!
ggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq
	"Generalized singular value/vector decomposition (for real/complex general matrices)
	return 0 if OK"

	| work rwork iwork |
	^self isComplex 
		ifTrue: 
			[work := self allocateElementArraySize: ((3 * n max: m) max: p)+n.
			rwork := self allocateRealArraySize: 2 * n.
			iwork := self allocateIntegerArraySize: n.
			self 
				ggsvdWithjobu: jobu
				jobv: jobv
				jobq: jobq
				m: m
				n: n
				p: p
				k: k
				l: l
				a: a
				lda: lda
				b: b
				ldb: ldb
				alpha: alpha
				beta: beta
				u: u
				ldu: ldu
				v: v
				ldv: ldv
				q: q
				ldq: ldq
				work: work
				rwork: rwork
				iwork: iwork]
		ifFalse: 
			[work := self allocateElementArraySize: ((3*n max: m) max: p)+n.
			iwork := self allocateIntegerArraySize: n.
			self 
				ggsvdWithjobu: jobu
				jobv: jobv
				jobq: jobq
				m: m
				n: n
				p: p
				k: k
				l: l
				a: a
				lda: lda
				b: b
				ldb: ldb
				alpha: alpha
				beta: beta
				u: u
				ldu: ldu
				v: v
				ldv: ldv
				q: q
				ldq: ldq
				work: work
				iwork: iwork]! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/27/2010 22:19'!
ggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggsvdWithjobu: (self cCharPointerOn: jobu)
		jobv: (self cCharPointerOn: jobv)
		jobq: (self cCharPointerOn: jobq)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		p: (self cIntegerPointerOn: p)
		k: k
		l: l
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		work: work
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/27/2010 22:19'!
ggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggsvdWithjobu: (self cCharPointerOn: jobu)
		jobv: (self cCharPointerOn: jobv)
		jobq: (self cCharPointerOn: jobq)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		p: (self cIntegerPointerOn: p)
		k: k
		l: l
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		work: work
		rwork: rwork
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
heconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheconWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		anorm: (self cRealPointerOn: anorm)
		rcond: rcond
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:18'!
heevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for complex hermitian matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: (3 * n - 2 max: 1).
	(self 
		heevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1
		rwork: rwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 2 * n - 1 max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		heevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork
		rwork: rwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:16'!
heevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork 
	"eigenvalue/vector decomposition (for complex hermitian matrices)"

	| cARGjobz cARGuplo cARGn cARGlda cARGlwork cARGinfo |
	cARGjobz := self cCharPointerOn: jobz.
	cARGuplo := self cCharPointerOn: uplo.
	cARGn := self cIntegerPointerOn: n.
	cARGlda := self cIntegerPointerOn: lda.
	cARGlwork := self cIntegerPointerOn: lwork.
	cARGinfo := self cIntegerPointerOn: 0.
	self 
		xheevWithjobz: cARGjobz
		uplo: cARGuplo
		n: cARGn
		a: a
		lda: cARGlda
		w: w
		work: work
		lwork: cARGlwork
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:15'!
heevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for real hermitian matrices)
	use divide and conquer algorithm
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork iwork lwork lrwork liwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: 1.
	iwork := self allocateIntegerArraySize: 1.
	(self 
		heevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1
		rwork: rwork
		lrwork: -1
		iwork: iwork
		liwork: -1) = 0 
		ifTrue: 
			[lwork := self retrieveLengthQueryAnswerFrom: work.
			lrwork := self retrieveLengthQueryAnswerFrom: rwork.
			liwork := iwork getHandle signedLongAt: 1]
		ifFalse: 
			[lwork := 1 
						max: (jobz = self doComputeVector ifTrue: [n * n + (2 * n)] ifFalse: [n + 1]).
			lrwork := 1 max: (jobz = self doComputeVector 
								ifTrue: [2 * n * n + (5 * n) + 1]
								ifFalse: [n]).
			liwork := 1 
						max: (jobz = self doComputeVector ifTrue: [5 * n + 3] ifFalse: [1])].
	work := self allocateElementArraySize: lwork.
	rwork := self allocateRealArraySize: lrwork.
	iwork := self allocateIntegerArraySize: liwork.
	^self 
		heevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork
		rwork: rwork
		lrwork: lrwork
		iwork: iwork
		liwork: liwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
heevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheevdWithjobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		lrwork: (self cIntegerPointerOn: lrwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
heevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheevrWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cRealPointerOn: vl)
		vu: (self cRealPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cRealPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		isuppz: isuppz
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
heevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheevxWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cRealPointerOn: vl)
		vu: (self cRealPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cRealPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		ifail: ifail
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
hegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhegvWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
hegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhegvdWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		lrwork: (self cIntegerPointerOn: lrwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
hegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhegvxWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		vl: (self cRealPointerOn: vl)
		vu: (self cRealPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cRealPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		ifail: ifail
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:15'!
hesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	"Solve x such that A*x = B with A hermitian
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		hesvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		hesvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:20'!
hesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork 
	"find x such that a*x=b, that is solve a linear system of equations
	on return:
		x is stored in b on return
		a contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		ipiv contains permutations of rows P of P*L*U decomposition
	return:
		info contains error code is not 0"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhesvWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:14'!
hetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"P*L*U decomposition of a hermitian matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		hetrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		hetrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:20'!
hetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork 
	"P*L*U decomposition of a hermitian matrix
	return 0 if OK"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhetrfWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:14'!
hetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"inverse of a hermitian matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		hetriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
hetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhetriWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
hetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhetrsWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 20:17'!
ilaenvWithispec: ispec name: name opts: opts n1: n1 n2: n2 n3: n3 n4: n4 
	"retrieve needed workspace dimensions for some problems"

	| cARGispec cARGname cARGopts cARGn1 cARGn2 cARGn3 cARGn4 |
	cARGispec := self cIntegerPointerOn: ispec.
	cARGn1 := self cIntegerPointerOn: n1.
	cARGn2 := self cIntegerPointerOn: n2.
	cARGn3 := self cIntegerPointerOn: n3.
	cARGn4 := self cIntegerPointerOn: n4.
	cARGname := name copyToHeap.
	cARGopts := opts copyToHeap.
	^self 
		ilaenvWithispec: cARGispec
		name: cARGname
		opts: cARGopts
		n1: cARGn1
		n2: cARGn2
		n3: cARGn3
		n4: cARGn4
		length: name size
		length: opts size! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
ilaenvWithispec: ispec name: name opts: opts n1: n1 n2: n2 n3: n3 n4: n4 length: lengthOfname length: lengthOfopts 
	"
*  Purpose
*  =======
*  ILAENV is called from the LAPACK routines to choose problem-dependent
*  parameters for the local environment.  See ISPEC for a description of
*  the parameters.
*  This version provides a set of parameters which should give good,
*  but not optimal, performance on many of the currently available
*  computers.  Users are encouraged to modify this subroutine to set
*  the tuning parameters for their particular machine using the option
*  and problem size information in the arguments.
*  This routine will not function correctly if it is converted to all
*  lower case.  Converting it to all upper case is allowed.
"

	<cdecl: long 'ilaenv_'( long * char * char * long * long * long * long * long long )>
	^self externalCallFailed! !

!CLapackLibrary methodsFor: 'testing' stamp: ''!
isComplex
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'testing' stamp: ''!
isReal
	^self isComplex not! !

!CLapackLibrary methodsFor: 'testing' stamp: ''!
isSinglePrecision
	^self isDoublePrecision not! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
ithEigenValuesInterval
	^$I! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 18:48'!
lacgvWithn: n x: x incx: incx 
	"conjugate a vector"

	^self 
		xlacgvWithn: (self cIntegerPointerOn: n)
		x: x
		incx: (self cIntegerPointerOn: incx)! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:23'!
lacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 
	"copy a into b"
	^self
		xlacpyWithuplo: (self cCharPointerOn: uplo)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)! !

!CLapackLibrary methodsFor: 'machine precision' stamp: 'nice 1/27/2017 22:46'!
lamch: code 
	"extract single precision machine parameters
	.	'E' or 'e',   DLAMCH := eps
	.	'S' or 's ,   DLAMCH := sfmin
	.	'B' or 'b',   DLAMCH := base
	.	'P' or 'p',   DLAMCH := eps*base
	.	'N' or 'n',   DLAMCH := t
	.	'R' or 'r',   DLAMCH := rnd
	.	'M' or 'm',   DLAMCH := emin
	.	'U' or 'u',   DLAMCH := rmin
	.	'L' or 'l',   DLAMCH := emax
	.	'O' or 'o',   DLAMCH := rmax
	where
	.	eps   = relative machine precision
	.	sfmin = safe minimum, such that 1/sfmin does not overflow
	.	base  = base of the machine
	.	prec  = eps*base
	.	t     = number of (base) digits in the mantissa
	.	rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
	.	emin  = minimum exponent before (gradual) underflow
	.	rmin  = underflow threshold - base**(emin-1)
	.	emax  = largest exponent before overflow
	.	rmax  = overflow threshold  - (base**emax)*(1-eps)"

	| cmach |
	cmach := self cCharPointerOn: code.
	^self isDoublePrecision 
		ifTrue: [self dlamch: cmach]
		ifFalse: [self class isCompiledWithF2Cconventions
			ifTrue: [self slamchF2C: cmach]
			ifFalse: [self slamch: cmach]]! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 18:24'!
langeWithnorm: norm m: m n: n a: a lda: lda 
	"compute norm of a general matrix or vector"

	| work |
	work := self allocateRealArraySize: m.
	^self 
		langeWithnorm: norm
		m: m
		n: n
		a: a
		lda: lda
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 1/27/2017 22:52'!
langeWithnorm: norm m: m n: n a: a lda: lda work: work 
	"compute norm of a general matrix or vector"
	(self isSinglePrecision and: [self class isCompiledWithF2Cconventions])
		ifTrue: [^self
			xlangeF2CWithnorm: (self cCharPointerOn: norm)
			m: (self cIntegerPointerOn: m)
			n: (self cIntegerPointerOn: n)
			a: a
			lda: (self cIntegerPointerOn: lda)
			work: work].
	^self
		xlangeWithnorm: (self cCharPointerOn: norm)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 18:24'!
lanheWithnorm: norm uplo: uplo n: n a: a lda: lda 
	"compute norm of a hermitian matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		lanheWithnorm: norm
		uplo: uplo
		n: n
		a: a
		lda: lda
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:24'!
lanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	^self
		xlanheWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 18:24'!
lansyWithnorm: norm uplo: uplo n: n a: a lda: lda 
	"compute norm of a symmetric matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		lansyWithnorm: norm
		uplo: uplo
		n: n
		a: a
		lda: lda
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 1/27/2017 22:51'!
lansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	(self isSinglePrecision and: [self class isCompiledWithF2Cconventions])
		ifTrue: [^self
			xlansyF2CWithnorm: (self cCharPointerOn: norm)
			uplo: (self cCharPointerOn: uplo)
			n: (self cIntegerPointerOn: n)
			a: a
			lda: (self cIntegerPointerOn: lda)
			work: work].
	^self
		xlansyWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 18:25'!
lantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda 
	"compute norm of a triangular matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		lantrWithnorm: norm
		uplo: uplo
		diag: diag
		m: m
		n: n
		a: a
		lda: lda
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 1/27/2017 22:50'!
lantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	(self isSinglePrecision and: [self class isCompiledWithF2Cconventions])
		ifTrue: [^self
			xlantrF2CWithnorm: (self cCharPointerOn: norm)
			uplo: (self cCharPointerOn: uplo)
			diag: (self cCharPointerOn: diag)
			m: (self cIntegerPointerOn: m)
			n: (self cIntegerPointerOn: n)
			a: a
			lda: (self cIntegerPointerOn: lda)
			work: work].
	^self
		xlantrWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:25'!
larnvWithidist: idist iseed: iseed n: n x: x 
	"fill x with random numbers"
	^self
		xlarnvWithidist: (self cIntegerPointerOn: idist)
		iseed: iseed
		n: (self cIntegerPointerOn: n)
		x: x! !

!CLapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:25'!
lasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 
	"set alpha off diagonal, beta on diagonal"
	^self
		xlasetWithuplo: (self cCharPointerOn: uplo)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		alpha: (self cElementPointerOn: alpha)
		beta: (self cElementPointerOn: beta)
		a: a
		lda: (self cIntegerPointerOn: lda)! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
lower
	^$L! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
maxAbs
	^$M! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: ''!
noSingularVector
	^$N! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
nonUnit
	^$N! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
norm1
	^$1! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
normF
	^$F! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
normI
	^$I! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
normal01
	"used by random number generator"

	^3! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
notTransposed
	^$N! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 18:25'!
orghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		orghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := (ihi getHandle signedLongAt: 1) - (ilo getHandle signedLongAt: 1) max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		orghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/26/2010 19:15'!
orghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix
	ilo and ihi must be allocated outside"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorghrWithn: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
orglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorglqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
orgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorgqlWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 18:25'!
orgqrWithm: m n: n k: k a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		orgqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		orgqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/26/2010 19:46'!
orgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorgqrWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
orgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorgrqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'private' stamp: 'nice 5/21/2006 00:17'!
retrieveLengthQueryAnswerFrom: workPointer 
	"After a length query (setting LWORK=-1 as LAPACK 3.0 argument),
	answer is returned into the first element of the work array.
	This work array can be either real or complex...
	This method will retrieve information whatever"

	^(self isDoublePrecision
		ifTrue: [workPointer getHandle doubleAt: 1]
		ifFalse: [workPointer getHandle floatAt: 1]) asInteger! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
schurDoNotSort
	^$N! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
schurDoSort
	^$S! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
schurSelectFunction
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectAbsLessThanUnity
	^CCallback do: (self isComplex 
				ifTrue: 
					[[:w | ((w memberAt: #r) i: (w memberAt: #i)) abs <= 1 ifTrue: [1] ifFalse: [0]]]
				ifFalse: 
					[[:wr :wi | (wr contents i: wi contents) abs <= 1 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectAbsStriclyLessThanUnity
	^CCallback do: (self isComplex 
				ifTrue: 
					[[:w | ((w memberAt: #r) i: (w memberAt: #i)) abs < 1 ifTrue: [1] ifFalse: [0]]]
				ifFalse: 
					[[:wr :wi | (wr contents i: wi contents) abs < 1 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectNegativeReal
	^CCallback do: (self isComplex 
				ifTrue: [[:w | (w memberAt: #r) <= 0 ifTrue: [1] ifFalse: [0]]]
				ifFalse: [[:wr :wi | wr contents <= 0 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectNone
	^CCallback do: (self isComplex 
				ifTrue: [[:w | 0]]
				ifFalse: [[:wr :wi | 0]])
		ofType: self schurSelectFunction! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectStrictlyNegativeReal
	^CCallback do: (self isComplex 
				ifTrue: [[:w | (w memberAt: #r) < 0 ifTrue: [1] ifFalse: [0]]]
				ifFalse: [[:wr :wi | wr contents < 0 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!CLapackLibrary methodsFor: 'machine precision' stamp: ''!
slamch: cmach
	"extract single precision machine parameters
	.	'E' or 'e',   DLAMCH := eps
	.	'S' or 's ,   DLAMCH := sfmin
	.	'B' or 'b',   DLAMCH := base
	.	'P' or 'p',   DLAMCH := eps*base
	.	'N' or 'n',   DLAMCH := t
	.	'R' or 'r',   DLAMCH := rnd
	.	'M' or 'm',   DLAMCH := emin
	.	'U' or 'u',   DLAMCH := rmin
	.	'L' or 'l',   DLAMCH := emax
	.	'O' or 'o',   DLAMCH := rmax
	where
	.	eps   = relative machine precision
	.	sfmin = safe minimum, such that 1/sfmin does not overflow
	.	base  = base of the machine
	.	prec  = eps*base
	.	t     = number of (base) digits in the mantissa
	.	rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
	.	emin  = minimum exponent before (gradual) underflow
	.	rmin  = underflow threshold - base**(emin-1)
	.	emax  = largest exponent before overflow
	.	rmax  = overflow threshold  - (base**emax)*(1-eps)"

	<cdecl: float 'slamch_'( char * )>! !

!CLapackLibrary methodsFor: 'machine precision' stamp: 'nice 1/27/2017 22:48'!
slamchF2C: cmach
	"Thanks F2C for these promotions to double complexifying our world gratuitously."
	<cdecl: double 'slamch_'( char * )>! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: ''!
someSingularVector
	^$S! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
syconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyconWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		anorm: (self cRealPointerOn: anorm)
		rcond: rcond
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
syconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyconWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		anorm: (self cElementPointerOn: anorm)
		rcond: rcond
		work: work
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 19:13'!
syevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for real symmetric matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		syevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 3 * n - 1 max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		syevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:13'!
syevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork 
	"eigenvalue/vector decomposition (for real symmetric matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevWithjobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 19:13'!
syevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for real symmetric matrices)
	use divide and conquer algorithm
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work iwork lwork liwork |
	work := self allocateElementArraySize: 1.
	iwork := self allocateIntegerArraySize: 1.
	(self 
		syevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1
		iwork: iwork
		liwork: -1) = 0 
		ifTrue: 
			[lwork := self retrieveLengthQueryAnswerFrom: work.
			liwork := iwork getHandle signedLongAt: 1]
		ifFalse: 
			[lwork := 1 max: (jobz = self doComputeVector 
								ifTrue: [2 * n * n + (6 * n) + 1]
								ifFalse: [2 * n + 1]).
			liwork := 1 max: (jobz = self doComputeVector ifTrue: [5 * n + 3] ifFalse: [1])].
	work := self allocateElementArraySize: lwork.
	iwork := self allocateIntegerArraySize: liwork.
	^self 
		syevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork
		iwork: iwork
		liwork: liwork! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
syevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevdWithjobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
syevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevrWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cElementPointerOn: vl)
		vu: (self cElementPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cElementPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		isuppz: isuppz
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
syevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevxWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cElementPointerOn: vl)
		vu: (self cElementPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cElementPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		ifail: ifail
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
sygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsygvWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
sygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsygvdWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
sygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsygvxWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		vl: (self cElementPointerOn: vl)
		vu: (self cElementPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cElementPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		ifail: ifail
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
sysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsysvWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 19:13'!
sytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"P*L*U decomposition of a syrmitian matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		sytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		sytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:20'!
sytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork 
	"P*L*U decomposition of a symmetric matrix
	return 0 if OK"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsytrfWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 19:12'!
sytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"inverse of a symmetric matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		sytriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
sytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsytriWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
sytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsytrsWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgexcWithwantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		ifst: ifst
		ilst: ilst
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgexcWithwantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		ifst: ifst
		ilst: ilst
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgsenWithijob: (self cIntegerPointerOn: ijob)
		wantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		select: select
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		m: m
		dif: dif
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgsenWithijob: (self cIntegerPointerOn: ijob)
		wantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		select: select
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alphar: alphar
		alphai: alphai
		beta: beta
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		m: m
		dif: dif
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-sylvester' stamp: ''!
tgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgsylWithtrans: (self cCharPointerOn: trans)
		ijob: (self cIntegerPointerOn: ijob)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		c: c
		ldc: (self cIntegerPointerOn: ldc)
		d: d
		ldd: (self cIntegerPointerOn: ldd)
		e: e
		lde: (self cIntegerPointerOn: lde)
		f: f
		ldf: (self cIntegerPointerOn: ldf)
		dif: dif
		scale: scale
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
transposeConjugated
	^$C! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
transposed
	^$T! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
trconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrconWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		rcond: rcond
		work: work
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-condition number' stamp: ''!
trconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrconWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		rcond: rcond
		work: work
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
trexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrexcWithcompq: (self cCharPointerOn: compq)
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		ifst: (self cIntegerPointerOn: ifst)
		ilst: (self cIntegerPointerOn: ilst)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
trexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrexcWithcompq: (self cCharPointerOn: compq)
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		ifst: ifst
		ilst: ilst
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
trsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrsenWithjob: (self cCharPointerOn: job)
		compq: (self cCharPointerOn: compq)
		select: select
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		w: w
		m: m
		s: s
		sep: sep
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-schur' stamp: ''!
trsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrsenWithjob: (self cCharPointerOn: job)
		compq: (self cCharPointerOn: compq)
		select: select
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		wr: wr
		wi: wi
		m: m
		s: s
		sep: sep
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-sylvester' stamp: ''!
trsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrsylWithtrana: (self cCharPointerOn: trana)
		tranb: (self cCharPointerOn: tranb)
		isgn: (self cIntegerPointerOn: isgn)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		c: c
		ldc: (self cIntegerPointerOn: ldc)
		scale: scale
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: ''!
trtriWithuplo: uplo diag: diag n: n a: a lda: lda 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrtriWithuplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:21'!
trtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb 
	"Solve a triangular system of equations A*x=B in x"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrtrsWithuplo: (self cCharPointerOn: uplo)
		trans: (self cCharPointerOn: trans)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 19:12'!
unghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		unghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := (ihi getHandle signedLongAt: 1) - (ilo getHandle signedLongAt: 1) max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		unghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/26/2010 19:16'!
unghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix
	ilo and ihi must be allocated outside"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xunghrWithn: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
unglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xunglqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
ungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xungqlWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 19:12'!
ungqrWithm: m n: n k: k a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		ungqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		ungqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/26/2010 19:46'!
ungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xungqrWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'processing-qr' stamp: ''!
ungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xungrqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
uniform01
	"used by random number generator"

	^1! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
uniform11
	"used by random number generator"

	^2! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
uniformCircle
	"used by random number generator"

	^5! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
uniformDisc
	"used by random number generator"

	^4! !

!CLapackLibrary methodsFor: 'accessing' stamp: ''!
upper
	^$U! !

!CLapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
valueEigenValuesInterval
	"for finding eigenvalues lying in a certain interval"

	^$V! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 2/19/2009 09:39'!
wantQ: aBoolean
	^aBoolean
		ifTrue: [$Q]
		ifFalse: [$N]! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 2/19/2009 09:39'!
wantU: aBoolean
	^aBoolean
		ifTrue: [$U]
		ifFalse: [$N]! !

!CLapackLibrary methodsFor: 'processing-svd' stamp: 'nice 2/19/2009 09:39'!
wantV: aBoolean
	^aBoolean
		ifTrue: [$V]
		ifFalse: [$N]! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork bwork: bwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:40'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:46'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xheconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xheevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork info: info 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xheevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xheevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xheevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlacgvWithn: n x: x incx: incx 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlamchWithcmach: cmach 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlanhpWithnorm: norm uplo: uplo n: n ap: ap work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xorghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xorglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xorgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xorgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xorgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info  

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xunghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xunglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!CLapackLibrary methodsFor: 'procedures' stamp: ''!
xungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

CLapackLibrary subclass: #CLapackSLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CLapackSLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!CLapackSLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aDouble 
	^self cRealPointerOn: aDouble! !

!CLapackSLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!CLapackSLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^false! !

!CLapackSLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^false! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  SGEBAK forms the right or left eigenvectors of a real general matrix
*  by backward transformation on the computed eigenvectors of the
*  balanced matrix output by SGEBAL.
"

	<cdecl: long 'sgebak_'( char * char * long * long * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info 
	"
*  Purpose
*  =======
*  SGEBAL balances a general real matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'sgebal_'( char * long * float * long * long * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  SGECON estimates the reciprocal of the condition number of a general
*  real matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by SGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'sgecon_'( char * long * float * long * float * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  SGEES computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues, the real Schur form T, and, optionally, the matrix of
*  Schur vectors Z.  This gives the Schur factorization A = Z*T*(Z**T).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  real Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A matrix is in real Schur form if it is upper quasi-triangular with
*  1-by-1 and 2-by-2 blocks. 2-by-2 blocks will be standardized in the
*  form
*          [  a  b  ]
*          [  c  a  ]
*  where b*c < 0. The eigenvalues of such a block are a +- sqrt(bc).
"

	<cdecl: long 'sgees_'( char * char * long * long * float * long * long * float * float * float * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEEV computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'sgeev_'( char * char * long * float * long * float * float * float * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'sgehrd_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELQF computes an LQ factorization of a real M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'sgelqf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELS solves overdetermined or underdetermined real linear systems
*  involving an M-by-N matrix A, or its transpose, using a QR or LQ
*  factorization of A.  It is assumed that A has full rank.
*  The following options are provided: 
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'T' and m >= n:  find the minimum norm solution of
*     an undetermined system A**T * X = B.
*  4. If TRANS = 'T' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**T * X ||.
*  Several right hand side vectors b and solution vectors x can be 
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution 
*  matrix X.
"

	<cdecl: long 'sgels_'( char * long * long * long * float * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  SGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder transformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'sgelsd_'( long * long * long * float * long * float * long * float * float * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELSS computes the minimum norm solution to a real linear least
*  squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'sgelss_'( long * long * long * float * long * float * long * float * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine SGELSY.
*  SGELSX computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be 
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'sgelsx_'( long * long * long * float * long * float * long * long * float * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELSY computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
"

	<cdecl: long 'sgelsy_'( long * long * long * float * long * float * long * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEQLF computes a QL factorization of a real M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'sgeqlf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'sgeqp3_'( long * long * float * long * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEQRF computes a QR factorization of a real M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'sgeqrf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGERQF computes an RQ factorization of a real M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'sgerqf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  SGESDD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and right singular
*  vectors.  If singular vectors are desired, it uses a
*  divide-and-conquer algorithm.
*  The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**T, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'sgesdd_'( char * long * long * float * long * float * float * long * float * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  SGESV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'sgesv_'( long * long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGESVD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**T, not V.
"

	<cdecl: long 'sgesvd_'( char * char * long * long * float * long * float * float * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  SGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'sgetrf_'( long * long * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGETRI computes the inverse of a matrix using the LU factorization
*  computed by SGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'sgetri_'( long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  SGETRS solves a system of linear equations
*     A * X = B  or  A' * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by SGETRF.
"

	<cdecl: long 'sgetrs_'( char * long * long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  SGGBAK forms the right or left eigenvectors of a real generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  SGGBAL.
"

	<cdecl: long 'sggbak_'( char * char * long * long * long * float * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info 
	"
*  Purpose
*  =======
*  SGGBAL balances a pair of general real matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'sggbal_'( char * long * float * long * float * long * long * long * float * float * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGEV computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j).
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B .
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'sggev_'( char * char * long * float * long * float * long * float * float * float * float * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  SGGEVX computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'sggevx_'( char * char * char * char * long * float * long * float * long * float * float * float * float * long * float * long * float * float * float * float * float * float * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'sggglm_'( long * long * long * float * long * float * long * float * float * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info 
	"
*  Purpose
*  =======
*  SGGHRD reduces a pair of real matrices (A,B) to generalized upper
*  Hessenberg form using orthogonal transformations, where A is a
*  general matrix and B is upper triangular.  The form of the
*  generalized eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the orthogonal matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**T*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**T*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**T*x.
*  The orthogonal matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**T = (Q1*Q) * H * (Z1*Z)**T
*       Q1 * B * Z1**T = (Q1*Q) * T * (Z1*Z)**T
*  If Q1 is the orthogonal matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then SGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'sgghrd_'( char * char * long * long * long * float * long * float * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'sgglse_'( long * long * long * float * long * float * long * float * float * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'sggqrf_'( long * long * long * float * long * float * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'sggrqf_'( long * long * long * float * long * float * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:41'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  SGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N real matrix A and P-by-N real matrix B:
*      U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are orthogonal matrices, and Z' is the transpose
*  of Z.  Let K+L = the effective numerical rank of the matrix (A',B')',
*  then R is a K+L-by-K+L nonsingular upper triangular matrix, D1 and
*  D2 are M-by-(K+L) and P-by-(K+L) 'diagonal' matrices and of the
*  following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the orthogonal
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthonormal columns, then the GSVD of A and B is
*  also equal to the CS decomposition of A and B. Furthermore, the GSVD
*  can be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                       X = Q*( I   0    )
*                             ( 0 inv(R) ).
"

	<cdecl: long 'sggsvd_'( char * char * char * long * long * long * long * long * float * long * float * long * float * float * float * long * float * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 
	^self 
		xsysvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: lwork
		info: info! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	^self 
		xsytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork
		info: info! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	^self 
		xsytriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		info: info! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	^self 
		xsytrsWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		info: info! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 
	"
*  Purpose
*  =======
*  SLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'slacpy_'( char * long * long * float * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlamchWithcmach: cmach 
	"
*  Purpose
*  =======
*  SLAMCH determines single precision machine parameters.
"

	<cdecl: float 'slamch_'( char * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:48'!
xlangeF2CWithnorm: norm m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  SLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real matrix A.
"

	<cdecl: double 'slange_'( char * long * long * float * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  SLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real matrix A.
"

	<cdecl: float 'slange_'( char * long * long * float * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:49'!
xlanspF2CWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  SLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'slansp_'( char * char * long * float * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  SLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A,  supplied in packed form.
"

	<cdecl: float 'slansp_'( char * char * long * float * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:49'!
xlansyF2CWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  SLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
"

	<cdecl: double 'slansy_'( char * char * long * float * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  SLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
"

	<cdecl: float 'slansy_'( char * char * long * float * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:49'!
xlantpF2CWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  SLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'slantp_'( char * char * char * long * float * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  SLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: float 'slantp_'( char * char * char * long * float * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:49'!
xlantrF2CWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  SLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'slantr_'( char * char * char * long * long * float * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  SLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: float 'slantr_'( char * char * char * long * long * float * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  SLARNV returns a vector of n random real numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'slarnv_'( long * long * long * float * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 
	"
*  Purpose
*  =======
*  SLASET initializes an m-by-n matrix A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'slaset_'( char * long * long * float * float * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xorghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'sorghr_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xorglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGLQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by SGELQF.
"

	<cdecl: long 'sorglq_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xorgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGQL generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by SGEQLF.
"

	<cdecl: long 'sorgql_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xorgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGQR generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by SGEQRF.
"

	<cdecl: long 'sorgqr_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xorgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGRQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by SGERQF.
"

	<cdecl: long 'sorgrq_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  SPOTRF computes the Cholesky factorization of a real symmetric
*  positive definite matrix A.
*  The factorization has the form
*     A = U**T * U,  if UPLO = 'U', or
*     A = L  * L**T,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'spotrf_'( char * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  SSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by SSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'ssycon_'( char * long * float * long * long * float * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SSYEV computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A.
"

	<cdecl: long 'ssyev_'( char * char * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  SSYEVD computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A. If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*  Because of large use of BLAS of level 3, SSYEVD needs N**2 more
*  workspace than SSYEVX.
"

	<cdecl: long 'ssyevd_'( char * char * long * float * long * float * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  SSYEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix T.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, SSYEVR calls SSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  SSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : SSYEVR calls SSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  SSYEVR calls SSTEBZ and SSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of SSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'ssyevr_'( char * char * char * long * float * long * float * float * long * long * float * long * float * float * long * long * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  SSYEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of indices
*  for the desired eigenvalues.
"

	<cdecl: long 'ssyevx_'( char * char * char * long * float * long * float * float * long * long * float * long * float * float * long * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SSYGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be symmetric and B is also
*  positive definite.
"

	<cdecl: long 'ssygv_'( long * char * char * long * float * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  SSYGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be symmetric and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'ssygvd_'( long * char * char * long * float * long * float * long * float * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  SSYGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A
*  and B are assumed to be symmetric and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'ssygvx_'( long * char * char * char * long * float * long * float * long * float * float * long * long * float * long * float * float * long * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info  
	"
*  Purpose
*  =======
*  SSYSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'ssysv_'( char * long * long * float * long * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SSYTRF computes the factorization of a real symmetric matrix A using
*  the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'ssytrf_'( char * long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  SSYTRI computes the inverse of a real symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  SSYTRF.
"

	<cdecl: long 'ssytri_'( char * long * float * long * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  SSYTRS solves a system of linear equations A*X = B with a real
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by SSYTRF.
"

	<cdecl: long 'ssytrs_'( char * long * long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  STGEXC reorders the generalized real Schur decomposition of a real
*  matrix pair (A,B) using an orthogonal equivalence transformation
*                 (A, B) = Q * (A, B) * Z',
*  so that the diagonal block of (A, B) with row index IFST is moved
*  to row ILST.
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by SGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'stgexc_'( long * long * long * float * long * float * long * float * long * float * long * long * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  STGSEN reorders the generalized real Schur decomposition of a real
*  matrix pair (A, B) (in terms of an orthonormal equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the upper quasi-triangular
*  matrix A and the upper triangular B. The leading columns of Q and
*  Z form orthonormal bases of the corresponding left and right eigen-
*  spaces (deflating subspaces). (A, B) must be in generalized real
*  Schur canonical form (as returned by SGGES), i.e. A is block upper
*  triangular with 1-by-1 and 2-by-2 diagonal blocks. B is upper
*  triangular.
*  STGSEN also computes the generalized eigenvalues
*              w(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, STGSEN computes the estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'stgsen_'( long * long * long * long * long * float * long * float * long * float * float * float * float * long * float * long * long * float * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  STGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C                 (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with real entries. (A, D) and (B, E) must be in
*  generalized (real) Schur canonical form, i.e. A, B are upper quasi
*  triangular and D, E are upper triangular.
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve  Zx = scale b, where
*  Z is defined as
*             Z = [ kron(In, A)  -kron(B', Im) ]         (2)
*                 [ kron(In, D)  -kron(E', Im) ].
*  Here Ik is the identity matrix of size k and X' is the transpose of
*  X. kron(X, Y) is the Kronecker product between the matrices X and Y.
*  If TRANS = 'T', STGSYL solves the transposed system Z'*y = scale*b,
*  which is equivalent to solve for R and L in
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * (-F)
*  This case (TRANS = 'T') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using SLACON.
*  If IJOB >= 1, STGSYL computes a Frobenius norm-based estimate
*  of Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z. See [1-2] for more
*  information.
*  This is a level 3 BLAS algorithm.
"

	<cdecl: long 'stgsyl_'( char * long * long * long * float * long * float * long * float * long * float * long * float * long * float * long * float * float * float * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  STPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'stpcon_'( char * char * char * long * float * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info 
	"
*  Purpose
*  =======
*  STPTRI computes the inverse of a real upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'stptri_'( char * char * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  STPTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'stptrs_'( char * char * char * long * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork info: info 
	"
*  Purpose
*  =======
*  STRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'strcon_'( char * char * char * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work info: info 
	"
*  Purpose
*  =======
*  STREXC reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that the diagonal block of T with row index IFST is
*  moved to row ILST.
*  The real Schur form T is reordered by an orthogonal similarity
*  transformation Z**T*T*Z, and optionally the matrix Q of Schur vectors
*  is updated by postmultiplying it with Z.
*  T must be in Schur canonical form (as returned by SHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'strexc_'( char * long * float * long * float * long * long * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  STRSEN reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that a selected cluster of eigenvalues appears in
*  the leading diagonal blocks of the upper quasi-triangular matrix T,
*  and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
*  T must be in Schur canonical form (as returned by SHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elemnts equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'strsen_'( char * char * long * long * float * long * float * long * float * float * long * float * float * float * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info 
	"
*  Purpose
*  =======
*  STRSYL solves the real Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**T, and  A and B are both upper quasi-
*  triangular. A is M-by-M and B is N-by-N; the right hand side C and
*  the solution X are M-by-N; and scale is an output scale factor, set
*  <= 1 to avoid overflow in X.
*  A and B must be in Schur canonical form (as returned by SHSEQR), that
*  is, block upper triangular with 1-by-1 and 2-by-2 diagonal blocks;
*  each 2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'strsyl_'( char * char * long * long * long * float * long * float * long * float * long * float * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  STRTRI computes the inverse of a real upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'strtri_'( char * char * long * float * long * long * )>
	^self externalCallFailed! !

!CLapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  STRTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'strtrs_'( char * char * char * long * long * float * long * float * long * long * )>
	^self externalCallFailed! !

CLapackLibrary subclass: #CLapackZLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!CLapackZLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!CLapackZLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!CLapackZLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!CLapackZLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^true! !

!CLapackZLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^true! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  ZGEBAK forms the right or left eigenvectors of a complex general
*  matrix by backward transformation on the computed eigenvectors of the
*  balanced matrix output by ZGEBAL.
"

	<cdecl: long 'zgebak_'( char * char * long * long * long * double * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info 
	"
*  Purpose
*  =======
*  ZGEBAL balances a general complex matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'zgebal_'( char * long * "ExternalDoubleComplex"void * long * long * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGECON estimates the reciprocal of the condition number of a general
*  complex matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by ZGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'zgecon_'( char * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  ZGEES computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues, the Schur form T, and, optionally, the matrix of Schur
*  vectors Z.  This gives the Schur factorization A = Z*T*(Z**H).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A complex matrix is in Schur form if it is upper triangular.
"

	<cdecl: long 'zgees_'( char * char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGEEV computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'zgeev_'( char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGEEVX computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  SCALE, and ABNRM), reciprocal condition numbers for the eigenvalues
*  (RCONDE), and reciprocal condition numbers for the right
*  eigenvectors (RCONDV).
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
*  Balancing a matrix means permuting the rows and columns to make it
*  more nearly upper triangular, and applying a diagonal similarity
*  transformation D * A * D**(-1), where D is a diagonal matrix, to
*  make its rows and columns closer in norm and the condition numbers
*  of its eigenvalues and eigenvectors smaller.  The computed
*  reciprocal condition numbers correspond to the balanced matrix.
*  Permuting rows and columns will not change the condition numbers
*  (in exact arithmetic) but diagonal scaling will.  For further
*  explanation of balancing, see section 4.10.2 of the LAPACK
*  Users' Guide.
"

	<cdecl: long 'zgeevx_'( char * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * double * double * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'zgehrd_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGELQF computes an LQ factorization of a complex M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'zgelqf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info  
	"
*  Purpose
*  =======
*  ZGELS solves overdetermined or underdetermined complex linear systems
*  involving an M-by-N matrix A, or its conjugate-transpose, using a QR
*  or LQ factorization of A.  It is assumed that A has full rank.
*  The following options are provided:
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'C' and m >= n:  find the minimum norm solution of
*     an undetermined system A**H * X = B.
*  4. If TRANS = 'C' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**H * X ||.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
"

	<cdecl: long 'zgels_'( char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  ZGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder tranformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zgelsd_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * long * "ExternalDoubleComplex"void * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGELSS computes the minimum norm solution to a complex linear
*  least squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'zgelss_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine ZGELSY.
*  ZGELSX computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'zgelsx_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * double * long * "ExternalDoubleComplex"void * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGELSY computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
"

	<cdecl: long 'zgelsy_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * double * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGEQLF computes a QL factorization of a complex M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'zgeqlf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'zgeqp3_'( long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGEQRF computes a QR factorization of a complex M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'zgeqrf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGERQF computes an RQ factorization of a complex M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'zgerqf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  ZGESDD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors, by using divide-and-conquer method. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**H, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zgesdd_'( char * long * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZGESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'zgesv_'( long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGESVD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**H, not V.
"

	<cdecl: long 'zgesvd_'( char * char * long * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  ZGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'zgetrf_'( long * long * "ExternalDoubleComplex"void * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGETRI computes the inverse of a matrix using the LU factorization
*  computed by ZGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'zgetri_'( long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZGETRS solves a system of linear equations
*     A * X = B,  A**T * X = B,  or  A**H * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by ZGETRF.
"

	<cdecl: long 'zgetrs_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info 
	"
*  Purpose
*  =======
*  ZGGBAK forms the right or left eigenvectors of a complex generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  ZGGBAL.
"

	<cdecl: long 'zggbak_'( char * char * long * long * long * double * double * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info 
	"
*  Purpose
*  =======
*  ZGGBAL balances a pair of general complex matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'zggbal_'( char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long * double * double * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info  
	"
*  Purpose
*  =======
*  ZGGEV computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B), the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right generalized eigenvector v(j) corresponding to the
*  generalized eigenvalue lambda(j) of (A,B) satisfies
*               A * v(j) = lambda(j) * B * v(j).
*  The left generalized eigenvector u(j) corresponding to the
*  generalized eigenvalues lambda(j) of (A,B) satisfies
*               u(j)**H * A = lambda(j) * u(j)**H * B
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'zggev_'( char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  ZGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'zggevx_'( char * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * double * double * double * double * "ExternalDoubleComplex"void * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork info: info 
	"
*  Purpose
*  =======
*  ZGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'zggevx_'( char * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * double * double * double * double * "ExternalDoubleComplex"void * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'zggglm_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info 
	"
*  Purpose
*  =======
*  ZGGHRD reduces a pair of complex matrices (A,B) to generalized upper
*  Hessenberg form using unitary transformations, where A is a
*  general matrix and B is upper triangular.  The form of the
*  generalized eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the unitary matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**H*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**H*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**H*x.
*  The unitary matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**H = (Q1*Q) * H * (Z1*Z)**H
*       Q1 * B * Z1**H = (Q1*Q) * T * (Z1*Z)**H
*  If Q1 is the unitary matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then ZGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'zgghrd_'( char * char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'zgglse_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary matrix,
*  and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of matrix Z.
"

	<cdecl: long 'zggqrf_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of the matrix Z.
"

	<cdecl: long 'zggrqf_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:46'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  ZGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N complex matrix A and P-by-N complex matrix B:
*        U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are unitary matrices, and Z' means the conjugate
*  transpose of Z.  Let K+L = the effective numerical rank of the
*  matrix (A',B')', then R is a (K+L)-by-(K+L) nonsingular upper
*  triangular matrix, D1 and D2 are M-by-(K+L) and P-by-(K+L) 'diagonal'
*  matrices and of the following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the unitary
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthnormal columns, then the GSVD of A and B is also
*  equal to the CS decomposition of A and B. Furthermore, the GSVD can
*  be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, and D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                        X = Q*(  I   0    )
*                              (  0 inv(R) )
"

	<cdecl: long 'zggsvd_'( char * char * char * long * long * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * double * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xheconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 
	"
*  Purpose
*  =======
*  ZHECON estimates the reciprocal of the condition number of a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by ZHETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'zhecon_'( char * long * "ExternalDoubleComplex"void * long * long * double * double * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork info: info 
	<cdecl: void 'zheev_'( char * char * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  ZHEEVD computes all eigenvalues and, optionally, eigenvectors of a
*  complex Hermitian matrix A.  If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zheevd_'( char * char * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  ZHEEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix T.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, ZHEEVR calls ZSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  ZSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : ZHEEVR calls ZSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  ZHEEVR calls DSTEBZ and ZSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of ZSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'zheevr_'( char * char * char * long * "ExternalDoubleComplex"void * long * double * double * long * long * double * long * double * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * double * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  ZHEEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix A.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
"

	<cdecl: long 'zheevx_'( char * char * char * long * "ExternalDoubleComplex"void * long * double * double * long * long * double * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZHEGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be Hermitian and B is also
*  positive definite.
"

	<cdecl: long 'zhegv_'( long * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  ZHEGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zhegvd_'( long * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info 
	"
*  Purpose
*  =======
*  ZHEGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'zhegvx_'( long * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * long * long * double * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZHESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**H,  if UPLO = 'U', or
*     A = L * D * L**H,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'zhesv_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZHETRF computes the factorization of a complex Hermitian matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**H  or  A = L*D*L**H
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'zhetrf_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  ZHETRI computes the inverse of a complex Hermitian indefinite matrix
*  A using the factorization A = U*D*U**H or A = L*D*L**H computed by
*  ZHETRF.
"

	<cdecl: long 'zhetri_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZHETRS solves a system of linear equations A*X = B with a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by ZHETRF.
"

	<cdecl: long 'zhetrs_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlacgvWithn: n x: x incx: incx 
	"
*  Purpose
*  =======
*  ZLACGV conjugates a complex vector of length N.
"

	<cdecl: long 'zlacgv_'( long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 
	"
*  Purpose
*  =======
*  ZLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'zlacpy_'( char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  ZLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex matrix A.
"

	<cdecl: double 'zlange_'( char * long * long * "ExternalDoubleComplex"void * long * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  ZLANHE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A.
"

	<cdecl: double 'zlanhe_'( char * char * long * "ExternalDoubleComplex"void * long * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlanhpWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  ZLANHP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A,  supplied in packed form.
"

	<cdecl: double 'zlanhp_'( char * char * long * "ExternalDoubleComplex"void * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  ZLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'zlansp_'( char * char * long * "ExternalDoubleComplex"void * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  ZLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
"

	<cdecl: double 'zlansy_'( char * char * long * "ExternalDoubleComplex"void * long * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work 
	"
*  Purpose
*  =======
*  ZLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'zlantp_'( char * char * char * long * "ExternalDoubleComplex"void * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	"
*  Purpose
*  =======
*  ZLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'zlantr_'( char * char * char * long * long * "ExternalDoubleComplex"void * long * double * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  ZLARNV returns a vector of n random complex numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'zlarnv_'( long * long * long * "ExternalDoubleComplex"void * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 
	"
*  Purpose
*  =======
*  ZLASET initializes a 2-D array A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'zlaset_'( char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  ZPOTRF computes the Cholesky factorization of a complex Hermitian
*  positive definite matrix A.
*  The factorization has the form
*     A = U**H * U,  if UPLO = 'U', or
*     A = L  * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'zpotrf_'( char * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xspconWithuplo: uplo n: n ap: ap ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 
	"
*  Purpose
*  =======
*  ZSPCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric packed matrix A using the
*  factorization A = U*D*U**T or A = L*D*L**T computed by ZSPTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'zspcon_'( char * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xspsvWithuplo: uplo n: n nrhs: nrhs ap: ap ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZSPSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix stored in packed format and X
*  and B are N-by-NRHS matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, D is symmetric and block diagonal with 1-by-1
*  and 2-by-2 diagonal blocks.  The factored form of A is then used to
*  solve the system of equations A * X = B.
"

	<cdecl: long 'zspsv_'( char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsptrfWithuplo: uplo n: n ap: ap ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  ZSPTRF computes the factorization of a complex symmetric matrix A
*  stored in packed format using the Bunch-Kaufman diagonal pivoting
*  method:
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
"

	<cdecl: long 'zsptrf_'( char * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsptriWithuplo: uplo n: n ap: ap ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  ZSPTRI computes the inverse of a complex symmetric indefinite matrix
*  A in packed storage using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by ZSPTRF.
"

	<cdecl: long 'zsptri_'( char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsptrsWithuplo: uplo n: n nrhs: nrhs ap: ap ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZSPTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A stored in packed format using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by ZSPTRF.
"

	<cdecl: long 'zsptrs_'( char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info 
	"
*  Purpose
*  =======
*  ZSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by ZSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'zsycon_'( char * long * "ExternalDoubleComplex"void * long * long * double * double * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info  
	"
*  Purpose
*  =======
*  ZSYSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'zsysv_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZSYTRF computes the factorization of a complex symmetric matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  with 1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'zsytrf_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info 
	"
*  Purpose
*  =======
*  ZSYTRI computes the inverse of a complex symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  ZSYTRF.
"

	<cdecl: long 'zsytri_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZSYTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by ZSYTRF.
"

	<cdecl: long 'zsytrs_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst info: info 
	"
*  Purpose
*  =======
*  ZTGEXC reorders the generalized Schur decomposition of a complex
*  matrix pair (A,B), using an unitary equivalence transformation
*  (A, B) := Q * (A, B) * Z', so that the diagonal block of (A, B) with
*  row index IFST is moved to row ILST.
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'ztgexc_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  ZTGSEN reorders the generalized Schur decomposition of a complex
*  matrix pair (A, B) (in terms of an unitary equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the pair (A,B). The leading
*  columns of Q and Z form unitary bases of the corresponding left and
*  right eigenspaces (deflating subspaces). (A, B) must be in
*  generalized Schur canonical form, that is, A and B are both upper
*  triangular.
*  ZTGSEN also computes the generalized eigenvalues
*           w(j)= ALPHA(j) / BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, the routine computes estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'ztgsen_'( long * long * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * double * "ExternalDoubleComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  ZTGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C            (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with complex entries. A, B, D and E are upper
*  triangular (i.e., (A,D) and (B,E) in generalized Schur form).
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1
*  is an output scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve Zx = scale*b, where Z
*  is defined as
*         Z = [ kron(In, A)  -kron(B', Im) ]        (2)
*             [ kron(In, D)  -kron(E', Im) ],
*  Here Ix is the identity matrix of size x and X' is the conjugate
*  transpose of X. Kron(X, Y) is the Kronecker product between the
*  matrices X and Y.
*  If TRANS = 'C', y in the conjugate transposed system Z'*y = scale*b
*  is solved for, which is equivalent to solve for R and L in
*              A' * R + D' * L = scale * C           (3)
*              R * B' + L * E' = scale * -F
*  This case (TRANS = 'C') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using ZLACON.
*  If IJOB >= 1, ZTGSYL computes a Frobenius norm-based estimate of
*  Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z.
*  This is a level-3 BLAS algorithm.
"

	<cdecl: long 'ztgsyl_'( char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ztpcon_'( char * char * char * long * "ExternalDoubleComplex"void * double * "ExternalDoubleComplex"void * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info 
	"
*  Purpose
*  =======
*  ZTPTRI computes the inverse of a complex upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'ztptri_'( char * char * long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZTPTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'ztptrs_'( char * char * char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ztrcon_'( char * char * char * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst info: info 
	"
*  Purpose
*  =======
*  ZTREXC reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*  is moved to row ILST.
*  The Schur form T is reordered by a unitary similarity transformation
*  Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*  postmultplying it with Z.
"

	<cdecl: long 'ztrexc_'( char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZTRSEN reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that a selected cluster of eigenvalues appears in
*  the leading positions on the diagonal of the upper triangular matrix
*  T, and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
"

	<cdecl: long 'ztrsen_'( char * char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info 
	"
*  Purpose
*  =======
*  ZTRSYL solves the complex Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**H, and A and B are both upper triangular. A is
*  M-by-M and B is N-by-N; the right hand side C and the solution X are
*  M-by-N; and scale is an output scale factor, set <= 1 to avoid
*  overflow in X.
"

	<cdecl: long 'ztrsyl_'( char * char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info 
	"
*  Purpose
*  =======
*  ZTRTRI computes the inverse of a complex upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'ztrtri_'( char * char * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZTRTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'ztrtrs_'( char * char * char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xunghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'zunghr_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xunglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGLQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k)' . . . H(2)' H(1)'
*  as returned by ZGELQF.
"

	<cdecl: long 'zunglq_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGQL generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by ZGEQLF.
"

	<cdecl: long 'zungql_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGQR generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by ZGEQRF.
"

	<cdecl: long 'zungqr_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!CLapackZLibrary methodsFor: 'procedures' stamp: ''!
xungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGRQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1)' H(2)' . . . H(k)'
*  as returned by ZGERQF.
"

	<cdecl: long 'zungrq_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

CMathLibrary subclass: #LapackLibrary
	instanceVariableNames: ''
	classVariableNames: 'CompiledWithF2Cconventions MacOsxModuleName UnixModuleName Win32ModuleName'
	poolDictionaries: ''
	category: 'Smallapack-External'!

!LapackLibrary commentStamp: '<historical>' prior: 0!
Interface to LAPACK library!

LapackLibrary subclass: #LapackCLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!LapackCLibrary commentStamp: 'nice 7/29/2016 23:16' prior: 0!
LapackCLibrary holds LAPACK functions for the single precision complex arithmetic!

!LapackCLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!LapackCLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!LapackCLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!LapackCLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^true! !

!LapackCLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^false! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  CGEBAK forms the right or left eigenvectors of a complex general
*  matrix by backward transformation on the computed eigenvectors of the
*  balanced matrix output by CGEBAL.
"

	<cdecl: long 'cgebak_'( char * char * long * long * long * float * long * "ExternalFloatComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  CGEBAL balances a general complex matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'cgebal_'( char * long * "ExternalFloatComplex"void * long * long * long * float * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm 
	"
*  Purpose
*  =======
*  CGECON estimates the reciprocal of the condition number of a general
*  complex matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by CGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'cgecon_'( char * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * float * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork info: info length: lengthOfjobvs length: lengthOfsort 
	"
*  Purpose
*  =======
*  CGEES computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues, the Schur form T, and, optionally, the matrix of Schur
*  vectors Z.  This gives the Schur factorization A = Z*T*(Z**H).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A complex matrix is in Schur form if it is upper triangular.
"

	<cdecl: long 'cgees_'( char * char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  CGEEV computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'cgeev_'( char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgeevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  CGEEVX computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  SCALE, and ABNRM), reciprocal condition numbers for the eigenvalues
*  (RCONDE), and reciprocal condition numbers for the right
*  eigenvectors (RCONDV).
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
*  Balancing a matrix means permuting the rows and columns to make it
*  more nearly upper triangular, and applying a diagonal similarity
*  transformation D * A * D**(-1), where D is a diagonal matrix, to
*  make its rows and columns closer in norm and the condition numbers
*  of its eigenvalues and eigenvectors smaller.  The computed
*  reciprocal condition numbers correspond to the balanced matrix.
*  Permuting rows and columns will not change the condition numbers
*  (in exact arithmetic) but diagonal scaling will.  For further
*  explanation of balancing, see section 4.10.2 of the LAPACK
*  Users' Guide.
"

	<cdecl: long 'cgeevx_'( char * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * float * float * "ExternalFloatComplex"void * long * float * long * long long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'cgehrd_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGELQF computes an LQ factorization of a complex M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'cgelqf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  CGELS solves overdetermined or underdetermined complex linear systems
*  involving an M-by-N matrix A, or its conjugate-transpose, using a QR
*  or LQ factorization of A.  It is assumed that A has full rank.
*  The following options are provided:
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'C' and m >= n:  find the minimum norm solution of
*     an undetermined system A**H * X = B.
*  4. If TRANS = 'C' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**H * X ||.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
"

	<cdecl: long 'cgels_'( char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  CGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder tranformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'cgelsd_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * long * "ExternalFloatComplex"void * long * float * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGELSS computes the minimum norm solution to a complex linear
*  least squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'cgelss_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine CGELSY.
*  CGELSX computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'cgelsx_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * float * long * "ExternalFloatComplex"void * float * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGELSY computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
"

	<cdecl: long 'cgelsy_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * float * long * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGEQLF computes a QL factorization of a complex M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'cgeqlf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  CGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'cgeqp3_'( long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * float * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGEQRF computes a QR factorization of a complex M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'cgeqrf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGERQF computes an RQ factorization of a complex M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'cgerqf_'( long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork info: info length: lengthOfjobz 
	"
*  Purpose
*  =======
*  CGESDD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors, by using divide-and-conquer method. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**H, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'cgesdd_'( char * long * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  CGESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'cgesv_'( long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:44'!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork info: info length: lengthOfjobu length: lengthOfjobvt 
	"
*  Purpose
*  =======
*  CGESVD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**H, not V.
"

	<cdecl: long 'cgesvd_'( char * char * long * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  CGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'cgetrf_'( long * long * "ExternalFloatComplex"void * long * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGETRI computes the inverse of a matrix using the LU factorization
*  computed by CGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'cgetri_'( long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  CGETRS solves a system of linear equations
*     A * X = B,  A**T * X = B,  or  A**H * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by CGETRF.
"

	<cdecl: long 'cgetrs_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  CGGBAK forms the right or left eigenvectors of a complex generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  CGGBAL.
"

	<cdecl: long 'cggbak_'( char * char * long * long * long * float * float * long * "ExternalFloatComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  CGGBAL balances a pair of general complex matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'cggbal_'( char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long * float * float * float * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 5/21/2006 21:45'!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  CGGEV computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B), the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right generalized eigenvector v(j) corresponding to the
*  generalized eigenvalue lambda(j) of (A,B) satisfies
*               A * v(j) = lambda(j) * B * v(j).
*  The left generalized eigenvector u(j) corresponding to the
*  generalized eigenvalues lambda(j) of (A,B) satisfies
*               u(j)**H * A = lambda(j) * u(j)**H * B
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'cggev_'( char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  CGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'cggevx_'( char * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * float * float * float * float * "ExternalFloatComplex"void * long * float * long * long * long long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  CGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'cggevx_'( char * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * float * float * float * float * "ExternalFloatComplex"void * long * float * long * long * long * long long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'cggglm_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info length: lengthOfcompq length: lengthOfcompz 
	"
*  Purpose
*  =======
*  CGGHRD reduces a pair of complex matrices (A,B) to generalized upper
*  Hessenberg form using unitary transformations, where A is a
*  general matrix and B is upper triangular.  The form of the generalized
*  eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the unitary matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**H*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**H*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**H*x.
*  The unitary matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**H = (Q1*Q) * H * (Z1*Z)**H
*       Q1 * B * Z1**H = (Q1*Q) * T * (Z1*Z)**H
*  If Q1 is the unitary matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then CGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'cgghrd_'( char * char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'cgglse_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary matrix,
*  and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of matrix Z.
"

	<cdecl: long 'cggqrf_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of the matrix Z.
"

	<cdecl: long 'cggrqf_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:46'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork info: info length: lengthOfjobu length: lengthOfjobv length: lengthOfjobq 
	"
*  Purpose
*  =======
*  CGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N complex matrix A and P-by-N complex matrix B:
*        U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are unitary matrices, and Z' means the conjugate
*  transpose of Z.  Let K+L = the effective numerical rank of the
*  matrix (A',B')', then R is a (K+L)-by-(K+L) nonsingular upper
*  triangular matrix, D1 and D2 are M-by-(K+L) and P-by-(K+L) 'diagonal'
*  matrices and of the following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the unitary
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthnormal columns, then the GSVD of A and B is also
*  equal to the CS decomposition of A and B. Furthermore, the GSVD can
*  be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, and D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                        X = Q*(  I   0    )
*                              (  0 inv(R) )
"

	<cdecl: long 'cggsvd_'( char * char * char * long * long * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * float * long * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xheconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHECON estimates the reciprocal of the condition number of a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by CHETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'checon_'( char * long * "ExternalFloatComplex"void * long * long * float * float * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork info: info length: ljobz length: luplo 
	<cdecl: void 'cheev_'( char * char * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHEEVD computes all eigenvalues and, optionally, eigenvectors of a
*  complex Hermitian matrix A.  If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'cheevd_'( char * char * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHEEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix T.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, CHEEVR calls CSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  CSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : CHEEVR calls CSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  CHEEVR calls SSTEBZ and CSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of CSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'cheevr_'( char * char * char * long * "ExternalFloatComplex"void * long * float * float * long * long * float * long * float * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * float * long * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xheevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHEEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix A.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
"

	<cdecl: long 'cheevx_'( char * char * char * long * "ExternalFloatComplex"void * long * float * float * long * long * float * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHEGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be Hermitian and B is also
*  positive definite.
"

	<cdecl: long 'chegv_'( long * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHEGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'chegvd_'( long * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * long * float * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHEGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'chegvx_'( long * char * char * char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * long * long * float * long * float * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**H,  if UPLO = 'U', or
*     A = L * D * L**H,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'chesv_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHETRF computes the factorization of a complex Hermitian matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**H  or  A = L*D*L**H
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'chetrf_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHETRI computes the inverse of a complex Hermitian indefinite matrix
*  A using the factorization A = U*D*U**H or A = L*D*L**H computed by
*  CHETRF.
"

	<cdecl: long 'chetri_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CHETRS solves a system of linear equations A*X = B with a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by CHETRF.
"

	<cdecl: long 'chetrs_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlacgvWithn: n x: x incx: incx 
	"
*  Purpose
*  =======
*  CLACGV conjugates a complex vector of length N.
"

	<cdecl: long 'clacgv_'( long * "ExternalFloatComplex"void * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'clacpy_'( char * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:31'!
xlangeF2CWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 
	"
*  Purpose
*  =======
*  CLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex matrix A.
"

	<cdecl: double 'clange_'( char * long * long * "ExternalFloatComplex"void * long * float * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 
	"
*  Purpose
*  =======
*  CLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex matrix A.
"

	<cdecl: float 'clange_'( char * long * long * "ExternalFloatComplex"void * long * float * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:31'!
xlanheF2CWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANHE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A.
"

	<cdecl: double 'clanhe_'( char * char * long * "ExternalFloatComplex"void * long * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANHE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A.
"

	<cdecl: float 'clanhe_'( char * char * long * "ExternalFloatComplex"void * long * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:32'!
xlanhpF2CWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANHP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A,  supplied in packed form.
"

	<cdecl: double 'clanhp_'( char * char * long * "ExternalFloatComplex"void * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlanhpWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANHP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A,  supplied in packed form.
"

	<cdecl: float 'clanhp_'( char * char * long * "ExternalFloatComplex"void * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:32'!
xlanspF2CWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'clansp_'( char * char * long * "ExternalFloatComplex"void * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A,  supplied in packed form.
"

	<cdecl: float 'clansp_'( char * char * long * "ExternalFloatComplex"void * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:32'!
xlansyF2CWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
"

	<cdecl: double 'clansy_'( char * char * long * "ExternalFloatComplex"void * long * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
"

	<cdecl: float 'clansy_'( char * char * long * "ExternalFloatComplex"void * long * float * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:32'!
xlantpF2CWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'clantp_'( char * char * char * long * "ExternalFloatComplex"void * float * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: float 'clantp_'( char * char * char * long * "ExternalFloatComplex"void * float * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:32'!
xlantrF2CWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'clantr_'( char * char * char * long * long * "ExternalFloatComplex"void * long * float * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: float 'clantr_'( char * char * char * long * long * "ExternalFloatComplex"void * long * float * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  CLARNV returns a vector of n random complex numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'clarnv_'( long * long * long * "ExternalFloatComplex"void * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CLASET initializes a 2-D array A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'claset_'( char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CPOTRF computes the Cholesky factorization of a complex Hermitian
*  positive definite matrix A.
*  The factorization has the form
*     A = U**H * U,  if UPLO = 'U', or
*     A = L  * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'cpotrf_'( char * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by CSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'csycon_'( char * long * "ExternalFloatComplex"void * long * long * float * float * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CSYSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'csysv_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CSYTRF computes the factorization of a complex symmetric matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  with 1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'csytrf_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CSYTRI computes the inverse of a complex symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  CSYTRF.
"

	<cdecl: long 'csytri_'( char * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  CSYTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by CSYTRF.
"

	<cdecl: long 'csytrs_'( char * long * long * "ExternalFloatComplex"void * long * long * "ExternalFloatComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst info: info 
	"
*  Purpose
*  =======
*  CTGEXC reorders the generalized Schur decomposition of a complex
*  matrix pair (A,B), using an unitary equivalence transformation
*  (A, B) := Q * (A, B) * Z', so that the diagonal block of (A, B) with
*  row index IFST is moved to row ILST.
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'ctgexc_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  CTGSEN reorders the generalized Schur decomposition of a complex
*  matrix pair (A, B) (in terms of an unitary equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the pair (A,B). The leading
*  columns of Q and Z form unitary bases of the corresponding left and
*  right eigenspaces (deflating subspaces). (A, B) must be in
*  generalized Schur canonical form, that is, A and B are both upper
*  triangular.
*  CTGSEN also computes the generalized eigenvalues
*           w(j)= ALPHA(j) / BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, the routine computes estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'ctgsen_'( long * long * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * float * "ExternalFloatComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  CTGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C            (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with complex entries. A, B, D and E are upper
*  triangular (i.e., (A,D) and (B,E) in generalized Schur form).
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1
*  is an output scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve Zx = scale*b, where Z
*  is defined as
*         Z = [ kron(In, A)  -kron(B', Im) ]        (2)
*             [ kron(In, D)  -kron(E', Im) ],
*  Here Ix is the identity matrix of size x and X' is the conjugate
*  transpose of X. Kron(X, Y) is the Kronecker product between the
*  matrices X and Y.
*  If TRANS = 'C', y in the conjugate transposed system Z'*y = scale*b
*  is solved for, which is equivalent to solve for R and L in
*              A' * R + D' * L = scale * C           (3)
*              R * B' + L * E' = scale * -F
*  This case (TRANS = 'C') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using CLACON.
*  If IJOB >= 1, CTGSYL computes a Frobenius norm-based estimate of
*  Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z.
*  This is a level-3 BLAS algorithm.
"

	<cdecl: long 'ctgsyl_'( char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * long * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ctpcon_'( char * char * char * long * "ExternalFloatComplex"void * float * "ExternalFloatComplex"void * float * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CTPTRI computes the inverse of a complex upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'ctptri_'( char * char * long * "ExternalFloatComplex"void * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CTPTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'ctptrs_'( char * char * char * long * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ctrcon_'( char * char * char * long * "ExternalFloatComplex"void * long * float * "ExternalFloatComplex"void * float * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst info: info length: lengthOfcompq 
	"
*  Purpose
*  =======
*  CTREXC reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*  is moved to row ILST.
*  The Schur form T is reordered by a unitary similarity transformation
*  Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*  postmultplying it with Z.
"

	<cdecl: long 'ctrexc_'( char * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long * long * long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork info: info length: lengthOfjob length: lengthOfcompq 
	"
*  Purpose
*  =======
*  CTRSEN reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that a selected cluster of eigenvalues appears in
*  the leading positions on the diagonal of the upper triangular matrix
*  T, and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
"

	<cdecl: long 'ctrsen_'( char * char * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * float * "ExternalFloatComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info length: lengthOftrana length: lengthOftranb 
	"
*  Purpose
*  =======
*  CTRSYL solves the complex Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**H, and A and B are both upper triangular. A is
*  M-by-M and B is N-by-N; the right hand side C and the solution X are
*  M-by-N; and scale is an output scale factor, set <= 1 to avoid
*  overflow in X.
"

	<cdecl: long 'ctrsyl_'( char * char * long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * float * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CTRTRI computes the inverse of a complex upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'ctrtri_'( char * char * long * "ExternalFloatComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  CTRTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'ctrtrs_'( char * char * char * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * long * long * long long long )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xunghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'cunghr_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xunglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGLQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k)' . . . H(2)' H(1)'
*  as returned by CGELQF.
"

	<cdecl: long 'cunglq_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGQL generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by CGEQLF.
"

	<cdecl: long 'cungql_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGQR generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by CGEQRF.
"

	<cdecl: long 'cungqr_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackCLibrary methodsFor: 'procedures' stamp: ''!
xungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  CUNGRQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1)' H(2)' . . . H(k)'
*  as returned by CGERQF.
"

	<cdecl: long 'cungrq_'( long * long * long * "ExternalFloatComplex"void * long * "ExternalFloatComplex"void * "ExternalFloatComplex"void * long * long * )>
	^self externalCallFailed! !

LapackLibrary subclass: #LapackDLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!LapackDLibrary commentStamp: 'nice 7/29/2016 23:17' prior: 0!
LapackDLibrary holds LAPACK functions for the double precision real arithmetic!

!LapackDLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!LapackDLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aDouble 
	^self cRealPointerOn: aDouble! !

!LapackDLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!LapackDLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^false! !

!LapackDLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^true! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  DGEBAK forms the right or left eigenvectors of a real general matrix
*  by backward transformation on the computed eigenvectors of the
*  balanced matrix output by DGEBAL.
"

	<cdecl: long 'dgebak_'( char * char * long * long * long * double * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  DGEBAL balances a general real matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'dgebal_'( char * long * double * long * long * long * double * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm 
	"
*  Purpose
*  =======
*  DGECON estimates the reciprocal of the condition number of a general
*  real matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by DGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'dgecon_'( char * long * double * long * double * double * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork info: info length: lengthOfjobvs length: lengthOfsort 
	"
*  Purpose
*  =======
*  DGEES computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues, the real Schur form T, and, optionally, the matrix of
*  Schur vectors Z.  This gives the Schur factorization A = Z*T*(Z**T).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  real Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A matrix is in real Schur form if it is upper quasi-triangular with
*  1-by-1 and 2-by-2 blocks. 2-by-2 blocks will be standardized in the
*  form
*          [  a  b  ]
*          [  c  a  ]
*  where b*c < 0. The eigenvalues of such a block are a +- sqrt(bc).
"

	<cdecl: long 'dgees_'( char * char * long * long * double * long * long * double * double * double * long * double * long * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  DGEEV computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'dgeev_'( char * char * long * double * long * double * double * double * long * double * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'dgehrd_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELQF computes an LQ factorization of a real M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'dgelqf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  DGELS solves overdetermined or underdetermined real linear systems
*  involving an M-by-N matrix A, or its transpose, using a QR or LQ
*  factorization of A.  It is assumed that A has full rank.
*  The following options are provided:
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'T' and m >= n:  find the minimum norm solution of
*     an undetermined system A**T * X = B.
*  4. If TRANS = 'T' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**T * X ||.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
"

	<cdecl: long 'dgels_'( char * long * long * long * double * long * double * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  DGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder transformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'dgelsd_'( long * long * long * double * long * double * long * double * double * long * double * long * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELSS computes the minimum norm solution to a real linear least
*  squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'dgelss_'( long * long * long * double * long * double * long * double * double * long * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine DGELSY.
*  DGELSX computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'dgelsx_'( long * long * long * double * long * double * long * long * double * long * double * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGELSY computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
"

	<cdecl: long 'dgelsy_'( long * long * long * double * long * double * long * long * double * long * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEQLF computes a QL factorization of a real M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'dgeqlf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'dgeqp3_'( long * long * double * long * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGEQRF computes a QR factorization of a real M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'dgeqrf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGERQF computes an RQ factorization of a real M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'dgerqf_'( long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork info: info length: lengthOfjobz 
	"
*  Purpose
*  =======
*  DGESDD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and right singular
*  vectors.  If singular vectors are desired, it uses a
*  divide-and-conquer algorithm.
*  The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**T, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'dgesdd_'( char * long * long * double * long * double * double * long * double * long * double * long * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  DGESV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'dgesv_'( long * long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork info: info length: lengthOfjobu length: lengthOfjobvt 
	"
*  Purpose
*  =======
*  DGESVD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**T, not V.
"

	<cdecl: long 'dgesvd_'( char * char * long * long * double * long * double * double * long * double * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  DGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'dgetrf_'( long * long * double * long * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGETRI computes the inverse of a matrix using the LU factorization
*  computed by DGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'dgetri_'( long * double * long * long * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  DGETRS solves a system of linear equations
*     A * X = B  or  A' * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by DGETRF.
"

	<cdecl: long 'dgetrs_'( char * long * long * double * long * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  DGGBAK forms the right or left eigenvectors of a real generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  DGGBAL.
"

	<cdecl: long 'dggbak_'( char * char * long * long * long * double * double * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  DGGBAL balances a pair of general real matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'dggbal_'( char * long * double * long * double * long * long * long * double * double * double * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  DGGEV computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j).
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B .
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'dggev_'( char * char * long * double * long * double * long * double * double * double * double * long * double * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  DGGEVX computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'dggevx_'( char * char * char * char * long * double * long * double * long * double * double * double * double * long * double * long * double * double * double * double * double * double * double * long * long * long * long * long long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'dggglm_'( long * long * long * double * long * double * long * double * double * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info length: lengthOfcompq length: lengthOfcompz 
	"
*  Purpose
*  =======
*  DGGHRD reduces a pair of real matrices (A,B) to generalized upper
*  Hessenberg form using orthogonal transformations, where A is a
*  general matrix and B is upper triangular.  The form of the
*  generalized eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the orthogonal matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**T*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**T*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**T*x.
*  The orthogonal matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**T = (Q1*Q) * H * (Z1*Z)**T
*       Q1 * B * Z1**T = (Q1*Q) * T * (Z1*Z)**T
*  If Q1 is the orthogonal matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then DGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'dgghrd_'( char * char * long * long * long * double * long * double * long * double * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'dgglse_'( long * long * long * double * long * double * long * double * double * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'dggqrf_'( long * long * long * double * long * double * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'dggrqf_'( long * long * long * double * long * double * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:40'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork info: info length: lengthOfjobu length: lengthOfjobv length: lengthOfjobq 
	"
*  Purpose
*  =======
*  DGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N real matrix A and P-by-N real matrix B:
*      U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are orthogonal matrices, and Z' is the transpose
*  of Z.  Let K+L = the effective numerical rank of the matrix (A',B')',
*  then R is a K+L-by-K+L nonsingular upper triangular matrix, D1 and
*  D2 are M-by-(K+L) and P-by-(K+L) 'diagonal' matrices and of the
*  following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the orthogonal
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthonormal columns, then the GSVD of A and B is
*  also equal to the CS decomposition of A and B. Furthermore, the GSVD
*  can be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                       X = Q*( I   0    )
*                             ( 0 inv(R) ).
"

	<cdecl: long 'dggsvd_'( char * char * char * long * long * long * long * long * double * long * double * long * double * double * double * long * double * long * double * long * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	^self 
		xsysvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: lwork
		info: info
		length: lengthOfuplo! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: luplo 
	^self 
		xsytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork
		info: info
		length: luplo! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	^self 
		xsytriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		info: info
		length: lengthOfuplo! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	^self 
		xsytrsWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		info: info
		length: lengthOfuplo! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'dlacpy_'( char * long * long * double * long * double * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlamchWithcmach: cmach length: lengthOfcmach 
	"
*  Purpose
*  =======
*  DLAMCH determines double precision machine parameters.
"

	<cdecl: double 'dlamch_'( char * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 
	"
*  Purpose
*  =======
*  DLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real matrix A.
"

	<cdecl: double 'dlange_'( char * long * long * double * long * double * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'dlansp_'( char * char * long * double * double * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
"

	<cdecl: double 'dlansy_'( char * char * long * double * long * double * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'dlantp_'( char * char * char * long * double * double * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'dlantr_'( char * char * char * long * long * double * long * double * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  DLARNV returns a vector of n random real numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'dlarnv_'( long * long * long * double * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DLASET initializes an m-by-n matrix A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'dlaset_'( char * long * long * double * double * double * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xorghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'dorghr_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xorglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGLQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by DGELQF.
"

	<cdecl: long 'dorglq_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xorgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGQL generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by DGEQLF.
"

	<cdecl: long 'dorgql_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xorgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGQR generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by DGEQRF.
"

	<cdecl: long 'dorgqr_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xorgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DORGRQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by DGERQF.
"

	<cdecl: long 'dorgrq_'( long * long * long * double * long * double * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DPOTRF computes the Cholesky factorization of a real symmetric
*  positive definite matrix A.
*  The factorization has the form
*     A = U**T * U,  if UPLO = 'U', or
*     A = L  * L**T,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'dpotrf_'( char * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by DSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'dsycon_'( char * long * double * long * long * double * double * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYEV computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A.
"

	<cdecl: long 'dsyev_'( char * char * long * double * long * double * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYEVD computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A. If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*  Because of large use of BLAS of level 3, DSYEVD needs N**2 more
*  workspace than DSYEVX.
"

	<cdecl: long 'dsyevd_'( char * char * long * double * long * double * double * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix T.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, DSYEVR calls DSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  DSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : DSYEVR calls DSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  DSYEVR calls DSTEBZ and SSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of DSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'dsyevr_'( char * char * char * long * double * long * double * double * long * long * double * long * double * double * long * long * double * long * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsyevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of indices
*  for the desired eigenvalues.
"

	<cdecl: long 'dsyevx_'( char * char * char * long * double * long * double * double * long * long * double * long * double * double * long * double * long * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be symmetric and B is also
*  positive definite.
"

	<cdecl: long 'dsygv_'( long * char * char * long * double * long * double * long * double * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be symmetric and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'dsygvd_'( long * char * char * long * double * long * double * long * double * double * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A
*  and B are assumed to be symmetric and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'dsygvx_'( long * char * char * char * long * double * long * double * long * double * double * long * long * double * long * double * double * long * double * long * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'dsysv_'( char * long * long * double * long * long * double * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYTRF computes the factorization of a real symmetric matrix A using
*  the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'dsytrf_'( char * long * double * long * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYTRI computes the inverse of a real symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  DSYTRF.
"

	<cdecl: long 'dsytri_'( char * long * double * long * long * double * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  DSYTRS solves a system of linear equations A*X = B with a real
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by DSYTRF.
"

	<cdecl: long 'dsytrs_'( char * long * long * double * long * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  DTGEXC reorders the generalized real Schur decomposition of a real
*  matrix pair (A,B) using an orthogonal equivalence transformation
*                 (A, B) = Q * (A, B) * Z',
*  so that the diagonal block of (A, B) with row index IFST is moved
*  to row ILST.
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by DGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'dtgexc_'( long * long * long * double * long * double * long * double * long * double * long * long * long * double * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  DTGSEN reorders the generalized real Schur decomposition of a real
*  matrix pair (A, B) (in terms of an orthonormal equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the upper quasi-triangular
*  matrix A and the upper triangular B. The leading columns of Q and
*  Z form orthonormal bases of the corresponding left and right eigen-
*  spaces (deflating subspaces). (A, B) must be in generalized real
*  Schur canonical form (as returned by DGGES), i.e. A is block upper
*  triangular with 1-by-1 and 2-by-2 diagonal blocks. B is upper
*  triangular.
*  DTGSEN also computes the generalized eigenvalues
*              w(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, DTGSEN computes the estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'dtgsen_'( long * long * long * long * long * double * long * double * long * double * double * double * double * long * double * long * long * double * double * long * long * long * long * )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  DTGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C                 (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with real entries. (A, D) and (B, E) must be in
*  generalized (real) Schur canonical form, i.e. A, B are upper quasi
*  triangular and D, E are upper triangular.
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve  Zx = scale b, where
*  Z is defined as
*             Z = [ kron(In, A)  -kron(B', Im) ]         (2)
*                 [ kron(In, D)  -kron(E', Im) ].
*  Here Ik is the identity matrix of size k and X' is the transpose of
*  X. kron(X, Y) is the Kronecker product between the matrices X and Y.
*  If TRANS = 'T', DTGSYL solves the transposed system Z'*y = scale*b,
*  which is equivalent to solve for R and L in
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * (-F)
*  This case (TRANS = 'T') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using DLACON.
*  If IJOB >= 1, DTGSYL computes a Frobenius norm-based estimate
*  of Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z. See [1-2] for more
*  information.
*  This is a level 3 BLAS algorithm.
"

	<cdecl: long 'dtgsyl_'( char * long * long * long * double * long * double * long * double * long * double * long * double * long * double * long * double * double * double * long * long * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'dtpcon_'( char * char * char * long * double * double * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DTPTRI computes the inverse of a real upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'dtptri_'( char * char * long * double * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DTPTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'dtptrs_'( char * char * char * long * long * double * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'dtrcon_'( char * char * char * long * double * long * double * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work info: info length: lengthOfcompq 
	"
*  Purpose
*  =======
*  DTREXC reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that the diagonal block of T with row index IFST is
*  moved to row ILST.
*  The real Schur form T is reordered by an orthogonal similarity
*  transformation Z**T*T*Z, and optionally the matrix Q of Schur vectors
*  is updated by postmultiplying it with Z.
*  T must be in Schur canonical form (as returned by DHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'dtrexc_'( char * long * double * long * double * long * long * long * double * long * long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjob length: lengthOfcompq 
	"
*  Purpose
*  =======
*  DTRSEN reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that a selected cluster of eigenvalues appears in
*  the leading diagonal blocks of the upper quasi-triangular matrix T,
*  and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
*  T must be in Schur canonical form (as returned by DHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elemnts equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'dtrsen_'( char * char * long * long * double * long * double * long * double * double * long * double * double * double * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info length: lengthOftrana length: lengthOftranb 
	"
*  Purpose
*  =======
*  DTRSYL solves the real Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**T, and  A and B are both upper quasi-
*  triangular. A is M-by-M and B is N-by-N; the right hand side C and
*  the solution X are M-by-N; and scale is an output scale factor, set
*  <= 1 to avoid overflow in X.
*  A and B must be in Schur canonical form (as returned by DHSEQR), that
*  is, block upper triangular with 1-by-1 and 2-by-2 diagonal blocks;
*  each 2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'dtrsyl_'( char * char * long * long * long * double * long * double * long * double * long * double * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DTRTRI computes the inverse of a real upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'dtrtri_'( char * char * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackDLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  DTRTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'dtrtrs_'( char * char * char * long * long * double * long * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/27/2017 22:15'!
isCompiledWithF2Cconventions
	<preference: 'Whether LAPACK is compiled with F2C conventions or not'
	category: 'Smallapack'
	description: 'When compiled with F2C conventions, single precision float results are promoted to double precision.'
	type: #Boolean>
	^CompiledWithF2Cconventions ifNil: [ false ]! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/27/2017 22:35'!
isCompiledWithF2Cconventions: aBoolean
	CompiledWithF2Cconventions := aBoolean! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:20'!
macOsxModuleName
	<preference: 'The name of the FORTRAN LAPACK library on MacOSX'
	category: 'Smallapack'
	description: 'You might want to pick the veclib version from Accelerated.framework'
	type: #String>
	^MacOsxModuleName ifNil: [ 'libLapack.dylib' ]! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:56'!
macOsxModuleName: aString
	MacOsxModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:20'!
unixModuleName
	<preference: 'The name of the FORTRAN Lapack library on Unix'
	category: 'Smallapack'
	description: 'Check for existing liblapack-dev package.'
	type: #String>
	^UnixModuleName ifNil: [ 'liblapack.so' ]! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:57'!
unixModuleName: aString
	UnixModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:20'!
win32ModuleName
	<preference: 'The name of the FORTRAN Lapack library on Win32'
	category: 'Smallapack'
	description: 'Look on http://www.netlib.org'
	type: #String>
	^Win32ModuleName ifNil: [ 'lapack' ]! !

!LapackLibrary class methodsFor: 'preferences' stamp: 'nice 1/23/2017 23:57'!
win32ModuleName: aString
	Win32ModuleName := aString.
	self withAllSubclassesDo: #install "reset cache"! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
allEigenValues
	^$A! !

!LapackLibrary methodsFor: 'processing-svd' stamp: ''!
allSingularVector
	^$A! !

!LapackLibrary methodsFor: 'accessing' stamp: 'nice 2/16/2006 00:01'!
allocateComplexArraySize: anInteger 
	^self isDoublePrecision
		ifTrue: [self allocateDoubleComplexArraySize: anInteger]
		ifFalse: [self allocateFloatComplexArraySize: anInteger]! !

!LapackLibrary methodsFor: 'accessing' stamp: 'nice 2/16/2006 00:02'!
allocateElementArraySize: anInteger 
	^self isReal
		ifTrue: [self allocateRealArraySize: anInteger]
		ifFalse: [self allocateComplexArraySize: anInteger]! !

!LapackLibrary methodsFor: 'accessing' stamp: 'nice 2/16/2006 00:01'!
allocateRealArraySize: anInteger 
	^self isDoublePrecision
		ifTrue: [self allocateDoubleArraySize: anInteger]
		ifFalse: [self allocateFloatArraySize: anInteger]! !

!LapackLibrary methodsFor: 'processing-balance' stamp: ''!
balanceDoNothing
	"balance do nothing, means finding ilo and ihi bounds of non triangular submatrix"

	^$N! !

!LapackLibrary methodsFor: 'processing-balance' stamp: ''!
balancePermute
	^$P! !

!LapackLibrary methodsFor: 'processing-balance' stamp: ''!
balancePermuteAndScale
	^$B! !

!LapackLibrary methodsFor: 'processing-balance' stamp: ''!
balanceScale
	^$S! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'machine precision' stamp: ''!
dlamch: cmach length: lcmach
	"extract doublereal precision machine parameters
	.	'E' or 'e',   DLAMCH := eps
	.	'S' or 's ,   DLAMCH := sfmin
	.	'B' or 'b',   DLAMCH := base
	.	'P' or 'p',   DLAMCH := eps*base
	.	'N' or 'n',   DLAMCH := t
	.	'R' or 'r',   DLAMCH := rnd
	.	'M' or 'm',   DLAMCH := emin
	.	'U' or 'u',   DLAMCH := rmin
	.	'L' or 'l',   DLAMCH := emax
	.	'O' or 'o',   DLAMCH := rmax
	where
	.	eps   = relative machine precision
	.	sfmin = safe minimum, such that 1/sfmin does not overflow
	.	base  = base of the machine
	.	prec  = eps*base
	.	t     = number of (base) digits in the mantissa
	.	rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
	.	emin  = minimum exponent before (gradual) underflow
	.	rmin  = underflow threshold - base**(emin-1)
	.	emax  = largest exponent before overflow
	.	rmax  = overflow threshold  - (base**emax)*(1-eps)"

	<cdecl: double 'dlamch_'( char *  long )>! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
doComputeVector
	"used by eigen value or svd decomposition"

	^$V! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
dontComputeVector
	"used by eigen value or svd decomposition"

	^$N! !

!LapackLibrary methodsFor: 'machine precision' stamp: ''!
eps
	"return relative machine precision"

	^self lamch: $E! !

!LapackLibrary methodsFor: 'processing-balance' stamp: 'nice 6/26/2010 18:50'!
gebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv 
	"balance back a general matrix
	ilo and ihi must be allocated outside this routine"


	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgebakWithjob: (self cCharPointerOn: job)
		side: (self cCharPointerOn: side)
		n: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		scale: scale
		m: (self cIntegerPointerOn: m)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-balance' stamp: 'nice 6/26/2010 18:52'!
gebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale 
	"balance a general matrix
	ilo and ihi must be allocated outside this routine"

	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgebalWithjob: (self cCharPointerOn: job)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ilo: ilo
		ihi: ihi
		scale: scale
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
geconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeconWithnorm: (self cCharPointerOn: norm)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		anorm: (self cElementPointerOn: anorm)
		rcond: rcond
		work: work
		iwork: iwork
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
geconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeconWithnorm: (self cCharPointerOn: norm)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		anorm: (self cRealPointerOn: anorm)
		rcond: rcond
		work: work
		rwork: rwork
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/3/2011 20:34'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs 
	"schur decomposition (for complex general matrices)
	Note: sdim must be allocated outside
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork bwork lwork |
	work := self allocateElementArraySize: 1.
	bwork := self allocateLogicalArraySize: n.
	rwork := self allocateRealArraySize: n.
	(self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		w: w
		vs: vs
		ldvs: ldvs
		work: work
		lwork: -1
		rwork: rwork
		bwork: bwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 2 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		w: w
		vs: vs
		ldvs: ldvs
		work: work
		lwork: lwork
		rwork: rwork
		bwork: bwork! !

!LapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/27/2010 21:32'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork 
	"schur decomposition (for complex general matrices)
	Note: sdim must be allocated outsied"

	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self 
		xgeesWithjobvs: (self cCharPointerOn: jobvs)
		sort: (self cCharPointerOn: sort)
		select: select
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		sdim: sdim
		w: w
		vs: vs
		ldvs: (self cIntegerPointerOn: ldvs)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		bwork: bwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/3/2011 20:34'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs 
	"schur decomposition (for real general matrices)
	Note: sdim must be allocated outside
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work bwork lwork |
	work := self allocateElementArraySize: 1.
	bwork := self allocateLogicalArraySize: n.
	(self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		wr: wr
		wi: wi
		vs: vs
		ldvs: ldvs
		work: work
		lwork: -1
		bwork: bwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 3 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geesWithjobvs: jobvs
		sort: sort
		select: select
		n: n
		a: a
		lda: lda
		sdim: sdim
		wr: wr
		wi: wi
		vs: vs
		ldvs: ldvs
		work: work
		lwork: lwork
		bwork: bwork! !

!LapackLibrary methodsFor: 'processing-schur' stamp: 'nice 6/3/2011 20:34'!
geesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork 
	"schur decomposition (for real general matrices)
	Note: sdim must be allocated outsied"

	| cARGjobvs cARGsort cARGn cARGlda cARGldvs cARGlwork cARGinfo |
	cARGjobvs := self cCharPointerOn: jobvs.
	cARGsort := self cCharPointerOn: sort.
	cARGn := self cIntegerPointerOn: n.
	cARGlda := self cIntegerPointerOn: lda.
	cARGldvs := self cIntegerPointerOn: ldvs.
	cARGlwork := self cIntegerPointerOn: lwork.
	cARGinfo := self cIntegerPointerOn: 0.
	self 
		xgeesWithjobvs: cARGjobvs
		sort: cARGsort
		select: select
		n: cARGn
		a: a
		lda: cARGlda
		sdim: sdim
		wr: wr
		wi: wi
		vs: vs
		ldvs: cARGldvs
		work: work
		lwork: cARGlwork 
		bwork: bwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:33'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"eigenvalue/vector decomposition (for complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: 2 * n.
	(self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		w: w
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1
		rwork: rwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 2 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		w: w
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork
		rwork: rwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:10'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork 
	"eigenvalue/vector decomposition (for complex general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:33'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"eigenvalue/vector decomposition (for real general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		wr: wr
		wi: wi
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		geevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		wr: wr
		wi: wi
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:41'!
geevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork 
	"eigenvalue/vector decomposition (for real general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		wr: wr
		wi: wi
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
geevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeevxWithbalanc: (self cCharPointerOn: balanc)
		jobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		sense: (self cCharPointerOn: sense)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		scale: scale
		abnrm: abnrm
		rconde: rconde
		rcondv: rcondv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 20:32'!
gehrdWithn: n a: a lda: lda tau: tau 
	"hessenberg decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork ilo ihi |
	work := self allocateElementArraySize: 1.
	ilo := self cIntegerPointerOn: 1.
	ihi := self cIntegerPointerOn: n.
	(self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 20:32'!
gehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau 
	"hessenberg decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK
	ilo and ihi must be allocated outside"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		gehrdWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/26/2010 19:14'!
gehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork 
	"hessenberg decomposition (for real/complex general matrices)
	ilo and ihi must be allocated outside this routine"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgehrdWithn: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
gelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelqfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsWithtrans: (self cCharPointerOn: trans)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 20:32'!
gelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank 
	"least squares by SVD divide and conquer algorithm
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork iwork smlsiz nlvl minmn |
	minmn := 1 max: (m min: n).
	^self isComplex 
		ifTrue: 
			[
			smlsiz := self 
						ilaenvWithispec: 9
						name: 'CGELSD'
						opts: ' '
						n1: 0
						n2: 0
						n3: 0
						n4: 0.
			nlvl := 1 + (minmn / (smlsiz + 1)) floorLog2.
			work := self allocateElementArraySize: 1.
			iwork := self allocateIntegerArraySize: 3 * minmn * nlvl + (11 * minmn).
			rwork := self allocateRealArraySize: (m >= n 
								ifTrue: [8 * n + (2 * n * smlsiz) + (8 * n * nlvl) + (n * nrhs)]
								ifFalse: [8 * m + (2 * m * smlsiz) + (8 * m * nlvl) + (m * nrhs)]).
			(self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: -1
				rwork: rwork
				iwork: iwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: 
					[lwork := m >= n 
								ifTrue: [1 max: n * (2 + nrhs)]
								ifFalse: [1 max: m * (2 + nrhs)]].
			work := self allocateElementArraySize: lwork.
			self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				rwork: rwork
				iwork: iwork] 
		ifFalse: 
			[
			smlsiz := self 
						ilaenvWithispec: 9
						name: 'SGELSD'
						opts: ' '
						n1: 0
						n2: 0
						n3: 0
						n4: 0.
			nlvl := 1 + (minmn / (smlsiz + 1)) floorLog2.
			work := self allocateElementArraySize: 1.
			iwork := self allocateIntegerArraySize: 3 * minmn * nlvl + (11 * minmn).
			(self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				iwork: iwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: 
					[lwork := m >= n 
								ifTrue: [11 * n + (2 * n * smlsiz) + (8 * n * nlvl) + (n * nrhs)]
								ifFalse: [11 * m + (2 * m * smlsiz) + (8 * m * nlvl) + (m * nrhs)]].
			work := self allocateElementArraySize: lwork.
			self 
				gelsdWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				iwork: iwork]! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsdWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsdWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 20:31'!
gelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank 
	"least squares by SVD
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: (5 * (m min: n) max: 1).
			(self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 1 max: (m min: n) * 2 + (nrhs max: (m max: n))].
			work := self allocateElementArraySize: lwork.
			self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: 
					[lwork := 1 
								max: (m min: n) * 3 + ((nrhs max: (m max: n)) max: 2 * (m min: n))].
			work := self allocateElementArraySize: lwork.
			self 
				gelssWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				s: s
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork]! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelssWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelssWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		s: s
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsxWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsxWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 20:31'!
gelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank 
	"least squares by complete orthogonalization
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| mn work rwork lwork |
	mn := m min: n.
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: (2 * n max: 1).
			(self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 1 max: mn + (2 * mn max: (n + 1 max: mn + nrhs))].
			work := self allocateElementArraySize: lwork.
			self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 1 max: (n * 3 + 1 + mn max: mn * 2 + nrhs)].
			work := self allocateElementArraySize: lwork.
			self 
				gelsyWithm: m
				n: n
				nrhs: nrhs
				a: a
				lda: lda
				b: b
				ldb: ldb
				jpvt: jpvt
				rcond: rcond
				rank: rank
				work: work
				lwork: lwork]! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsyWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cElementPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgelsyWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		jpvt: jpvt
		rcond: (self cRealPointerOn: rcond)
		rank: rank
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
geqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqlfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 20:30'!
geqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau 
	"qr decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: 2 * n.
			(self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := n + 1].
			work := self allocateElementArraySize: lwork.
			self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 3 * n + 1].
			work := self allocateElementArraySize: lwork.
			self 
				geqp3Withm: m
				n: n
				a: a
				lda: lda
				jpvt: jpvt
				tau: tau
				work: work
				lwork: lwork]! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
geqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqp3Withm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		jpvt: jpvt
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
geqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqp3Withm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		jpvt: jpvt
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 20:30'!
geqrfWithm: m n: n a: a lda: lda tau: tau 
	"qr decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		geqrfWithm: m
		n: n
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		geqrfWithm: m
		n: n
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/26/2010 19:42'!
geqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	"qr decomposition (for real/complex general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgeqrfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
gerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgerqfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
gesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesddWithjobz: (self cCharPointerOn: jobz)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
gesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesddWithjobz: (self cCharPointerOn: jobz)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:18'!
gesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	"find x such that a*x=b, that is solve a linear system of equations
	on return:
		x is stored in b on return
		a contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		ipiv contains permutations of rows P of P*L*U decomposition
	return:
		info contains error code is not 0"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesvWithn: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/3/2011 20:30'!
gesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt 
	"singular value/vector decomposition (for real/complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	^self isComplex 
		ifTrue: 
			[
			work := self allocateElementArraySize: 1.
			rwork := self allocateRealArraySize: 5 * (m min: n).
			(self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: -1
				rwork: rwork) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 2 * (m min: n) + (m max: n)].
			work := self allocateElementArraySize: lwork.
			self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: lwork
				rwork: rwork]
		ifFalse: 
			[
			work := self allocateElementArraySize: 1.
			(self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: -1) = 0 
				ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
				ifFalse: [lwork := 3 * (m min: n) + (m max: n) max: 5 * (m min: n)].
			work := self allocateElementArraySize: lwork.
			self 
				gesvdWithjobu: jobu
				jobvt: jobvt
				m: m
				n: n
				a: a
				lda: lda
				s: s
				u: u
				ldu: ldu
				vt: vt
				ldvt: ldvt
				work: work
				lwork: lwork]! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/26/2010 19:21'!
gesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork 
	"singular value/vector decomposition (for real general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesvdWithjobu: (self cCharPointerOn: jobu)
		jobvt: (self cCharPointerOn: jobvt)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/26/2010 19:22'!
gesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork 
	"singular value/vector decomposition (for complex general matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgesvdWithjobu: (self cCharPointerOn: jobu)
		jobvt: (self cCharPointerOn: jobvt)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		s: s
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		vt: vt
		ldvt: (self cIntegerPointerOn: ldvt)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:19'!
getrfWithm: m n: n a: a lda: lda ipiv: ipiv 
	"P*L*U decomposition of a general matrix
	return 0 if OK"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgetrfWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:29'!
getriWithn: n a: a lda: lda ipiv: ipiv 
	"inverse of a general matrix"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		getriWithn: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 10 * n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		getriWithn: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
getriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgetriWithn: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:19'!
getrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	"Solve a general system of equations A*x=B in x"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgetrsWithtrans: (self cCharPointerOn: trans)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-balance' stamp: 'nice 6/26/2010 19:02'!
ggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggbakWithjob: (self cCharPointerOn: job)
		side: (self cCharPointerOn: side)
		n: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		lscale: lscale
		rscale: rscale
		m: (self cIntegerPointerOn: m)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-balance' stamp: ''!
ggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggbalWithjob: (self cCharPointerOn: job)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		ilo: ilo
		ihi: ihi
		lscale: lscale
		rscale: rscale
		work: work
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:20'!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"generalized eigenvalue/vector decomposition (for complex general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: 8 * n.
	(self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alpha: alpha
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1
		rwork: rwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 1 max: 2 * n].
	work := self allocateElementArraySize: lwork.
	^self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alpha: alpha
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork
		rwork: rwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:21'!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr 
	"generalized eigenvalue/vector decomposition (for real general matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alphar: alphar
		alphai: alphai
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 1 max: 8 * n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		ggevWithjobvl: jobvl
		jobvr: jobvr
		n: n
		a: a
		lda: lda
		b: b
		ldb: ldb
		alphar: alphar
		alphai: alphai
		beta: beta
		vl: vl
		ldvl: ldvl
		vr: vr
		ldvr: ldvr
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
ggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggevWithjobvl: (self cCharPointerOn: jobvl)
		jobvr: (self cCharPointerOn: jobvr)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alphar: alphar
		alphai: alphai
		beta: beta
		vl: vl
		ldvl: (self cIntegerPointerOn: ldvl)
		vr: vr
		ldvr: (self cIntegerPointerOn: ldvr)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:32'!
ggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork 
	"use perform: to avoid exceding maximum frame size"
	| cARGinfo args |
	cARGinfo := self cIntegerPointerOn: 0.
	args := {
		"xggevxWithbalanc:" (self cCharPointerOn: balanc).
		"jobvl:" (self cCharPointerOn: jobvl).
		"jobvr:" (self cCharPointerOn: jobvr).
		"sense:" (self cCharPointerOn: sense).
		"n:" (self cIntegerPointerOn: n)
		"a:" a.
		"lda:" (self cIntegerPointerOn: lda).
		"b:" b.
		"ldb:" (self cIntegerPointerOn: ldb).
		"alpha:" alpha.
		"beta:" beta.
		"vl:" vl.
		"ldvl:" (self cIntegerPointerOn: ldvl).
		"vr:" vr.
		"ldvr:" (self cIntegerPointerOn: ldvr).
		"lscale:" lscale.
		"rscale:" rscale.
		"abnrm:" abnrm.
		"bbnrm:" bbnrm.
		"rconde:" rconde.
		"rcondv:" rcondv.
		"work:" work.
		"lwork:" (self cIntegerPointerOn: lwork).
		"rwork:" rwork.
		"iwork:" iwork.
		"bwork:" bwork.
		"info:" cARGinfo.
		"length:" 1.
		"length:" 1.
		"length:" 1.
		"length:" 1.
	}.
	self perform: #xggevxWithbalanc:jobvl:jobvr:sense:n:a:lda:b:ldb:alpha:beta:vl:ldvl:vr:ldvr:lscale:rscale:abnrm:bbnrm:rconde:rcondv:work:lwork:rwork:iwork:bwork:info:length:length:length:length: withArguments: args.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:38'!
ggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork 
	"Use perform: to avoid exceding maximum frame size"
	| args cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	args := {
		"xggevxWithbalanc:" (self cCharPointerOn: balanc).
		"jobvl:" (self cCharPointerOn: jobvl).
		"jobvr:" (self cCharPointerOn: jobvr).
		"sense:" (self cCharPointerOn: sense).
		"n:" (self cIntegerPointerOn: n).
		"a:" a.
		"lda:" (self cIntegerPointerOn: lda).
		"b:" b.
		"ldb:" (self cIntegerPointerOn: ldb).
		"alphar:" alphar.
		"alphai:" alphai.
		"beta:" beta.
		"vl:" vl.
		"ldvl:" (self cIntegerPointerOn: ldvl).
		"vr:" vr.
		"ldvr:" (self cIntegerPointerOn: ldvr).
		"lscale:" lscale.
		"rscale:" rscale.
		"abnrm:" abnrm.
		"bbnrm:" bbnrm.
		"rconde:" rconde.
		"rcondv:" rcondv.
		"work:" work.
		"lwork:" (self cIntegerPointerOn: lwork).
		"iwork:" iwork.
		"bwork:" bwork.
		"info:" cARGinfo.
		"length:" 1.
		"length:" 1.
		"length:" 1.
		"length:" 1.
	}.
	self perform: #xggevxWithbalanc:jobvl:jobvr:sense:n:a:lda:b:ldb:alphar:alphai:beta:vl:ldvl:vr:ldvr:lscale:rscale:abnrm:bbnrm:rconde:rcondv:work:lwork:iwork:bwork:info:length:length:length:length: withArguments: args.
	^cARGinfo getHandle signedLongAt: 1
! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
ggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggglmWithn: (self cIntegerPointerOn: n)
		m: (self cIntegerPointerOn: m)
		p: (self cIntegerPointerOn: p)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		d: d
		x: x
		y: y
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: ''!
gghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgghrdWithcompq: (self cCharPointerOn: compq)
		compz: (self cCharPointerOn: compz)
		n: (self cIntegerPointerOn: n)
		ilo: (self cIntegerPointerOn: ilo)
		ihi: (self cIntegerPointerOn: ihi)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: 'nice 6/3/2011 20:29'!
gglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x 
	"least squares subject to equality constraints by orthogonalization
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"
	
	| work lwork |
	work := self allocateElementArraySize: 1.
	(self
			gglseWithm: m
			n: n
			p: p
			a: a
			lda: lda
			b: b
			ldb: ldb
			c: c
			d: d
			x: x
			work: work
			lwork: -1)
			= 0
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 1 max: m + n + p].
	work := self allocateElementArraySize: lwork.
	^self
		gglseWithm: m
		n: n
		p: p
		a: a
		lda: lda
		b: b
		ldb: ldb
		c: c
		d: d
		x: x
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-least squares' stamp: ''!
gglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xgglseWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		p: (self cIntegerPointerOn: p)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		c: c
		d: d
		x: x
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
ggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggqrfWithn: (self cIntegerPointerOn: n)
		m: (self cIntegerPointerOn: m)
		p: (self cIntegerPointerOn: p)
		a: a
		lda: (self cIntegerPointerOn: lda)
		taua: taua
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		taub: taub
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
ggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggrqfWithm: (self cIntegerPointerOn: m)
		p: (self cIntegerPointerOn: p)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		taua: taua
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		taub: taub
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/26/2010 19:40'!
ggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq
	"Generalized singular value/vector decomposition (for real/complex general matrices)
	return 0 if OK"

	| work rwork iwork |
	^self isComplex 
		ifTrue: 
			[work := self allocateElementArraySize: ((3 * n max: m) max: p)+n.
			rwork := self allocateRealArraySize: 2 * n.
			iwork := self allocateIntegerArraySize: n.
			self 
				ggsvdWithjobu: jobu
				jobv: jobv
				jobq: jobq
				m: m
				n: n
				p: p
				k: k
				l: l
				a: a
				lda: lda
				b: b
				ldb: ldb
				alpha: alpha
				beta: beta
				u: u
				ldu: ldu
				v: v
				ldv: ldv
				q: q
				ldq: ldq
				work: work
				rwork: rwork
				iwork: iwork]
		ifFalse: 
			[work := self allocateElementArraySize: ((3*n max: m) max: p)+n.
			iwork := self allocateIntegerArraySize: n.
			self 
				ggsvdWithjobu: jobu
				jobv: jobv
				jobq: jobq
				m: m
				n: n
				p: p
				k: k
				l: l
				a: a
				lda: lda
				b: b
				ldb: ldb
				alpha: alpha
				beta: beta
				u: u
				ldu: ldu
				v: v
				ldv: ldv
				q: q
				ldq: ldq
				work: work
				iwork: iwork]! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/27/2010 22:19'!
ggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggsvdWithjobu: (self cCharPointerOn: jobu)
		jobv: (self cCharPointerOn: jobv)
		jobq: (self cCharPointerOn: jobq)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		p: (self cIntegerPointerOn: p)
		k: k
		l: l
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		work: work
		iwork: iwork
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 6/27/2010 22:19'!
ggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xggsvdWithjobu: (self cCharPointerOn: jobu)
		jobv: (self cCharPointerOn: jobv)
		jobq: (self cCharPointerOn: jobq)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		p: (self cIntegerPointerOn: p)
		k: k
		l: l
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		u: u
		ldu: (self cIntegerPointerOn: ldu)
		v: v
		ldv: (self cIntegerPointerOn: ldv)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		work: work
		rwork: rwork
		iwork: iwork
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
heconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheconWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		anorm: (self cRealPointerOn: anorm)
		rcond: rcond
		work: work
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:28'!
heevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for complex hermitian matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork lwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: (3 * n - 2 max: 1).
	(self 
		heevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1
		rwork: rwork) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 2 * n - 1 max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		heevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork
		rwork: rwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:28'!
heevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork 
	"eigenvalue/vector decomposition (for complex hermitian matrices)"

	| cARGjobz cARGuplo cARGn cARGlda cARGlwork cARGinfo |
	cARGjobz := self cCharPointerOn: jobz.
	cARGuplo := self cCharPointerOn: uplo.
	cARGn := self cIntegerPointerOn: n.
	cARGlda := self cIntegerPointerOn: lda.
	cARGlwork := self cIntegerPointerOn: lwork.
	cARGinfo := self cIntegerPointerOn: 0.
	self 
		xheevWithjobz: cARGjobz
		uplo: cARGuplo
		n: cARGn
		a: a
		lda: cARGlda
		w: w
		work: work
		lwork: cARGlwork
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:28'!
heevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for real hermitian matrices)
	use divide and conquer algorithm
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work rwork iwork lwork lrwork liwork |
	work := self allocateElementArraySize: 1.
	rwork := self allocateRealArraySize: 1.
	iwork := self allocateIntegerArraySize: 1.
	(self 
		heevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1
		rwork: rwork
		lrwork: -1
		iwork: iwork
		liwork: -1) = 0 
		ifTrue: 
			[lwork := self retrieveLengthQueryAnswerFrom: work.
			lrwork := self retrieveLengthQueryAnswerFrom: rwork.
			liwork := iwork getHandle signedLongAt: 1]
		ifFalse: 
			[lwork := 1 
						max: (jobz = self doComputeVector ifTrue: [n * n + (2 * n)] ifFalse: [n + 1]).
			lrwork := 1 max: (jobz = self doComputeVector 
								ifTrue: [2 * n * n + (5 * n) + 1]
								ifFalse: [n]).
			liwork := 1 
						max: (jobz = self doComputeVector ifTrue: [5 * n + 3] ifFalse: [1])].
	work := self allocateElementArraySize: lwork.
	rwork := self allocateRealArraySize: lrwork.
	iwork := self allocateIntegerArraySize: liwork.
	^self 
		heevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork
		rwork: rwork
		lrwork: lrwork
		iwork: iwork
		liwork: liwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
heevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheevdWithjobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		lrwork: (self cIntegerPointerOn: lrwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
heevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheevrWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cRealPointerOn: vl)
		vu: (self cRealPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cRealPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		isuppz: isuppz
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
heevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xheevxWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cRealPointerOn: vl)
		vu: (self cRealPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cRealPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		ifail: ifail
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
hegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhegvWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
hegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhegvdWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		lrwork: (self cIntegerPointerOn: lrwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
hegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhegvxWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		vl: (self cRealPointerOn: vl)
		vu: (self cRealPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cRealPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		rwork: rwork
		iwork: iwork
		ifail: ifail
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:27'!
hesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	"Solve x such that A*x = B with A hermitian
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		hesvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		hesvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:20'!
hesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork 
	"find x such that a*x=b, that is solve a linear system of equations
	on return:
		x is stored in b on return
		a contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		ipiv contains permutations of rows P of P*L*U decomposition
	return:
		info contains error code is not 0"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhesvWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:27'!
hetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"P*L*U decomposition of a hermitian matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		hetrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		hetrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:20'!
hetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork 
	"P*L*U decomposition of a hermitian matrix
	return 0 if OK"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhetrfWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:27'!
hetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"inverse of a hermitian matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		hetriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
hetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhetriWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
hetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xhetrsWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 20:17'!
ilaenvWithispec: ispec name: name opts: opts n1: n1 n2: n2 n3: n3 n4: n4 
	"retrieve needed workspace dimensions for some problems"

	| cARGispec cARGname cARGopts cARGn1 cARGn2 cARGn3 cARGn4 |
	cARGispec := self cIntegerPointerOn: ispec.
	cARGn1 := self cIntegerPointerOn: n1.
	cARGn2 := self cIntegerPointerOn: n2.
	cARGn3 := self cIntegerPointerOn: n3.
	cARGn4 := self cIntegerPointerOn: n4.
	cARGname := name copyToHeap.
	cARGopts := opts copyToHeap.
	^self 
		ilaenvWithispec: cARGispec
		name: cARGname
		opts: cARGopts
		n1: cARGn1
		n2: cARGn2
		n3: cARGn3
		n4: cARGn4
		length: name size
		length: opts size! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
ilaenvWithispec: ispec name: name opts: opts n1: n1 n2: n2 n3: n3 n4: n4 length: lengthOfname length: lengthOfopts 
	"
*  Purpose
*  =======
*  ILAENV is called from the LAPACK routines to choose problem-dependent
*  parameters for the local environment.  See ISPEC for a description of
*  the parameters.
*  This version provides a set of parameters which should give good,
*  but not optimal, performance on many of the currently available
*  computers.  Users are encouraged to modify this subroutine to set
*  the tuning parameters for their particular machine using the option
*  and problem size information in the arguments.
*  This routine will not function correctly if it is converted to all
*  lower case.  Converting it to all upper case is allowed.
"

	<cdecl: long 'ilaenv_'( long * char * char * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackLibrary methodsFor: 'testing' stamp: ''!
isComplex
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'testing' stamp: ''!
isReal
	^self isComplex not! !

!LapackLibrary methodsFor: 'testing' stamp: ''!
isSinglePrecision
	^self isDoublePrecision not! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
ithEigenValuesInterval
	^$I! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 18:48'!
lacgvWithn: n x: x incx: incx 
	"conjugate a vector"

	^self 
		xlacgvWithn: (self cIntegerPointerOn: n)
		x: x
		incx: (self cIntegerPointerOn: incx)! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:23'!
lacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb 
	"copy a into b"
	^self
		xlacpyWithuplo: (self cCharPointerOn: uplo)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		length: 1! !

!LapackLibrary methodsFor: 'machine precision' stamp: 'nice 1/27/2017 22:41'!
lamch: code 
	"extract single precision machine parameters
	.	'E' or 'e',   DLAMCH := eps
	.	'S' or 's ,   DLAMCH := sfmin
	.	'B' or 'b',   DLAMCH := base
	.	'P' or 'p',   DLAMCH := eps*base
	.	'N' or 'n',   DLAMCH := t
	.	'R' or 'r',   DLAMCH := rnd
	.	'M' or 'm',   DLAMCH := emin
	.	'U' or 'u',   DLAMCH := rmin
	.	'L' or 'l',   DLAMCH := emax
	.	'O' or 'o',   DLAMCH := rmax
	where
	.	eps   = relative machine precision
	.	sfmin = safe minimum, such that 1/sfmin does not overflow
	.	base  = base of the machine
	.	prec  = eps*base
	.	t     = number of (base) digits in the mantissa
	.	rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
	.	emin  = minimum exponent before (gradual) underflow
	.	rmin  = underflow threshold - base**(emin-1)
	.	emax  = largest exponent before overflow
	.	rmax  = overflow threshold  - (base**emax)*(1-eps)"

	| cmach |
	cmach := self cCharPointerOn: code.
	^self isDoublePrecision 
		ifTrue: [self dlamch: cmach length: 1]
		ifFalse: [self class isCompiledWithF2Cconventions
			ifTrue: [self slamchF2C: cmach length: 1]
			ifFalse: [self slamch: cmach length: 1]]! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 20:26'!
langeWithnorm: norm m: m n: n a: a lda: lda 
	"compute norm of a general matrix or vector"

	| work |
	work := self allocateRealArraySize: m.
	^self 
		langeWithnorm: norm
		m: m
		n: n
		a: a
		lda: lda
		work: work! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 1/27/2017 22:36'!
langeWithnorm: norm m: m n: n a: a lda: lda work: work 
	"compute norm of a general matrix or vector"
	
	(self isSinglePrecision and: [self class isCompiledWithF2Cconventions])
		ifTrue:
			[^self
				xlangeF2CWithnorm: (self cCharPointerOn: norm)
				m: (self cIntegerPointerOn: m)
				n: (self cIntegerPointerOn: n)
				a: a
				lda: (self cIntegerPointerOn: lda)
				work: work
				length: 1].
	^self
		xlangeWithnorm: (self cCharPointerOn: norm)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work
		length: 1! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 20:26'!
lanheWithnorm: norm uplo: uplo n: n a: a lda: lda 
	"compute norm of a hermitian matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		lanheWithnorm: norm
		uplo: uplo
		n: n
		a: a
		lda: lda
		work: work! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:24'!
lanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	^self
		xlanheWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work
		length: 1
		length: 1! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 20:26'!
lansyWithnorm: norm uplo: uplo n: n a: a lda: lda 
	"compute norm of a symmetric matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		lansyWithnorm: norm
		uplo: uplo
		n: n
		a: a
		lda: lda
		work: work! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 1/27/2017 22:36'!
lansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work 
	(self isSinglePrecision and: [self class isCompiledWithF2Cconventions])
		ifTrue:
			[^self
				xlansyF2CWithnorm: (self cCharPointerOn: norm)
				uplo: (self cCharPointerOn: uplo)
				n: (self cIntegerPointerOn: n)
				a: a
				lda: (self cIntegerPointerOn: lda)
				work: work
				length: 1
				length: 1].
	^self
		xlansyWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work
		length: 1
		length: 1! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/3/2011 20:26'!
lantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda 
	"compute norm of a triangular matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		lantrWithnorm: norm
		uplo: uplo
		diag: diag
		m: m
		n: n
		a: a
		lda: lda
		work: work! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 1/27/2017 22:37'!
lantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work 
	(self isSinglePrecision and: [self class isCompiledWithF2Cconventions])
		ifTrue:
			[^self
				xlantrF2CWithnorm: (self cCharPointerOn: norm)
				uplo: (self cCharPointerOn: uplo)
				diag: (self cCharPointerOn: diag)
				m: (self cIntegerPointerOn: m)
				n: (self cIntegerPointerOn: n)
				a: a
				lda: (self cIntegerPointerOn: lda)
				work: work
				length: 1
				length: 1
				length: 1].
	^self
		xlantrWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		work: work
		length: 1
		length: 1
		length: 1! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:25'!
larnvWithidist: idist iseed: iseed n: n x: x 
	"fill x with random numbers"
	^self
		xlarnvWithidist: (self cIntegerPointerOn: idist)
		iseed: iseed
		n: (self cIntegerPointerOn: n)
		x: x! !

!LapackLibrary methodsFor: 'processing-auxiliary' stamp: 'nice 6/26/2010 19:25'!
lasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda 
	"set alpha off diagonal, beta on diagonal"
	^self
		xlasetWithuplo: (self cCharPointerOn: uplo)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		alpha: (self cElementPointerOn: alpha)
		beta: (self cElementPointerOn: beta)
		a: a
		lda: (self cIntegerPointerOn: lda)
		length: 1! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
lower
	^$L! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
maxAbs
	^$M! !

!LapackLibrary methodsFor: 'processing-svd' stamp: ''!
noSingularVector
	^$N! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
nonUnit
	^$N! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
norm1
	^$1! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
normF
	^$F! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
normI
	^$I! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
normal01
	"used by random number generator"

	^3! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
notTransposed
	^$N! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 20:39'!
orghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		orghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := (ihi getHandle signedLongAt: 1) - (ilo getHandle signedLongAt: 1) max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		orghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/26/2010 19:15'!
orghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix
	ilo and ihi must be allocated outside"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorghrWithn: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
orglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorglqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
orgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorgqlWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 20:25'!
orgqrWithm: m n: n k: k a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		orgqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		orgqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/26/2010 19:46'!
orgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorgqrWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
orgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xorgrqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'private' stamp: 'nice 5/21/2006 00:17'!
retrieveLengthQueryAnswerFrom: workPointer 
	"After a length query (setting LWORK=-1 as LAPACK 3.0 argument),
	answer is returned into the first element of the work array.
	This work array can be either real or complex...
	This method will retrieve information whatever"

	^(self isDoublePrecision
		ifTrue: [workPointer getHandle doubleAt: 1]
		ifFalse: [workPointer getHandle floatAt: 1]) asInteger! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
schurDoNotSort
	^$N! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
schurDoSort
	^$S! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
schurSelectFunction
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectAbsLessThanUnity
	^CCallback do: (self isComplex 
				ifTrue: 
					[[:w | ((w memberAt: #r) i: (w memberAt: #i)) abs <= 1 ifTrue: [1] ifFalse: [0]]]
				ifFalse: 
					[[:wr :wi | (wr contents i: wi contents) abs <= 1 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectAbsStriclyLessThanUnity
	^CCallback do: (self isComplex 
				ifTrue: 
					[[:w | ((w memberAt: #r) i: (w memberAt: #i)) abs < 1 ifTrue: [1] ifFalse: [0]]]
				ifFalse: 
					[[:wr :wi | (wr contents i: wi contents) abs < 1 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectNegativeReal
	^CCallback do: (self isComplex 
				ifTrue: [[:w | (w memberAt: #r) <= 0 ifTrue: [1] ifFalse: [0]]]
				ifFalse: [[:wr :wi | wr contents <= 0 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectNone
	^CCallback do: (self isComplex 
				ifTrue: [[:w | 0]]
				ifFalse: [[:wr :wi | 0]])
		ofType: self schurSelectFunction! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
selectStrictlyNegativeReal
	^CCallback do: (self isComplex 
				ifTrue: [[:w | (w memberAt: #r) < 0 ifTrue: [1] ifFalse: [0]]]
				ifFalse: [[:wr :wi | wr contents < 0 ifTrue: [1] ifFalse: [0]]])
		ofType: self schurSelectFunction! !

!LapackLibrary methodsFor: 'machine precision' stamp: ''!
slamch: cmach length: lcmach
	"extract single precision machine parameters
	.	'E' or 'e',   DLAMCH := eps
	.	'S' or 's ,   DLAMCH := sfmin
	.	'B' or 'b',   DLAMCH := base
	.	'P' or 'p',   DLAMCH := eps*base
	.	'N' or 'n',   DLAMCH := t
	.	'R' or 'r',   DLAMCH := rnd
	.	'M' or 'm',   DLAMCH := emin
	.	'U' or 'u',   DLAMCH := rmin
	.	'L' or 'l',   DLAMCH := emax
	.	'O' or 'o',   DLAMCH := rmax
	where
	.	eps   = relative machine precision
	.	sfmin = safe minimum, such that 1/sfmin does not overflow
	.	base  = base of the machine
	.	prec  = eps*base
	.	t     = number of (base) digits in the mantissa
	.	rnd   = 1.0 when rounding occurs in addition, 0.0 otherwise
	.	emin  = minimum exponent before (gradual) underflow
	.	rmin  = underflow threshold - base**(emin-1)
	.	emax  = largest exponent before overflow
	.	rmax  = overflow threshold  - (base**emax)*(1-eps)"

	<cdecl: float 'slamch_'( char *  long )>! !

!LapackLibrary methodsFor: 'machine precision' stamp: 'nice 1/27/2017 22:19'!
slamchF2C: cmach length: lcmach
	"Same as slamch, but result promoted to double thanks to F2C conventions..."

	<cdecl: double 'slamch_'( char *  long )>! !

!LapackLibrary methodsFor: 'processing-svd' stamp: ''!
someSingularVector
	^$S! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
syconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyconWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		anorm: (self cRealPointerOn: anorm)
		rcond: rcond
		work: work
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
syconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyconWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		anorm: (self cElementPointerOn: anorm)
		rcond: rcond
		work: work
		iwork: iwork
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:25'!
syevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for real symmetric matrices)
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		syevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := 3 * n - 1 max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		syevWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/26/2010 19:13'!
syevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork 
	"eigenvalue/vector decomposition (for real symmetric matrices)"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevWithjobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: 'nice 6/3/2011 20:25'!
syevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w 
	"eigenvalue/vector decomposition (for real symmetric matrices)
	use divide and conquer algorithm
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work iwork lwork liwork |
	work := self allocateElementArraySize: 1.
	iwork := self allocateIntegerArraySize: 1.
	(self 
		syevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: -1
		iwork: iwork
		liwork: -1) = 0 
		ifTrue: 
			[lwork := self retrieveLengthQueryAnswerFrom: work.
			liwork := iwork getHandle signedLongAt: 1]
		ifFalse: 
			[lwork := 1 max: (jobz = self doComputeVector 
								ifTrue: [2 * n * n + (6 * n) + 1]
								ifFalse: [2 * n + 1]).
			liwork := 1 max: (jobz = self doComputeVector ifTrue: [5 * n + 3] ifFalse: [1])].
	work := self allocateElementArraySize: lwork.
	iwork := self allocateIntegerArraySize: liwork.
	^self 
		syevdWithjobz: jobz
		uplo: uplo
		n: n
		a: a
		lda: lda
		w: w
		work: work
		lwork: lwork
		iwork: iwork
		liwork: liwork! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
syevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevdWithjobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
syevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevrWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cElementPointerOn: vl)
		vu: (self cElementPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cElementPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		isuppz: isuppz
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
syevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsyevxWithjobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		vl: (self cElementPointerOn: vl)
		vu: (self cElementPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cElementPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		ifail: ifail
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
sygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsygvWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
sygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsygvdWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		w: w
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
sygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsygvxWithitype: (self cIntegerPointerOn: itype)
		jobz: (self cCharPointerOn: jobz)
		range: (self cCharPointerOn: range)
		uplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		vl: (self cElementPointerOn: vl)
		vu: (self cElementPointerOn: vu)
		il: (self cIntegerPointerOn: il)
		iu: (self cIntegerPointerOn: iu)
		abstol: (self cElementPointerOn: abstol)
		m: m
		w: w
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		ifail: ifail
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
sysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsysvWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:25'!
sytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"P*L*U decomposition of a syrmitian matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		sytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n * n].
	work := self allocateElementArraySize: lwork.
	^self 
		sytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:20'!
sytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork 
	"P*L*U decomposition of a symmetric matrix
	return 0 if OK"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsytrfWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/3/2011 20:24'!
sytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv 
	"inverse of a symmetric matrix"

	| work |
	work := self allocateElementArraySize: n.
	^self 
		sytriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
sytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsytriWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		work: work
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
sytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xsytrsWithuplo: (self cCharPointerOn: uplo)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		ipiv: ipiv
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgexcWithwantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		ifst: ifst
		ilst: ilst
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgexcWithwantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		ifst: ifst
		ilst: ilst
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgsenWithijob: (self cIntegerPointerOn: ijob)
		wantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		select: select
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alpha: alpha
		beta: beta
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		m: m
		dif: dif
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
tgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgsenWithijob: (self cIntegerPointerOn: ijob)
		wantq: (self cLogicalPointerOn: wantq)
		wantz: (self cLogicalPointerOn: wantz)
		select: select
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		alphar: alphar
		alphai: alphai
		beta: beta
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		z: z
		ldz: (self cIntegerPointerOn: ldz)
		m: m
		dif: dif
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-sylvester' stamp: ''!
tgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtgsylWithtrans: (self cCharPointerOn: trans)
		ijob: (self cIntegerPointerOn: ijob)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		c: c
		ldc: (self cIntegerPointerOn: ldc)
		d: d
		ldd: (self cIntegerPointerOn: ldd)
		e: e
		lde: (self cIntegerPointerOn: lde)
		f: f
		ldf: (self cIntegerPointerOn: ldf)
		dif: dif
		scale: scale
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
transposeConjugated
	^$C! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
transposed
	^$T! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
trconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrconWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		rcond: rcond
		work: work
		iwork: iwork
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-condition number' stamp: ''!
trconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrconWithnorm: (self cCharPointerOn: norm)
		uplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		rcond: rcond
		work: work
		rwork: rwork
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
trexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrexcWithcompq: (self cCharPointerOn: compq)
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		ifst: (self cIntegerPointerOn: ifst)
		ilst: (self cIntegerPointerOn: ilst)
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
trexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrexcWithcompq: (self cCharPointerOn: compq)
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		ifst: ifst
		ilst: ilst
		work: work
		info: cARGinfo
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
trsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrsenWithjob: (self cCharPointerOn: job)
		compq: (self cCharPointerOn: compq)
		select: select
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		w: w
		m: m
		s: s
		sep: sep
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-schur' stamp: ''!
trsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrsenWithjob: (self cCharPointerOn: job)
		compq: (self cCharPointerOn: compq)
		select: select
		n: (self cIntegerPointerOn: n)
		t: t
		ldt: (self cIntegerPointerOn: ldt)
		q: q
		ldq: (self cIntegerPointerOn: ldq)
		wr: wr
		wi: wi
		m: m
		s: s
		sep: sep
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		iwork: iwork
		liwork: (self cIntegerPointerOn: liwork)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-sylvester' stamp: ''!
trsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrsylWithtrana: (self cCharPointerOn: trana)
		tranb: (self cCharPointerOn: tranb)
		isgn: (self cIntegerPointerOn: isgn)
		m: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		c: c
		ldc: (self cIntegerPointerOn: ldc)
		scale: scale
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: ''!
trtriWithuplo: uplo diag: diag n: n a: a lda: lda 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrtriWithuplo: (self cCharPointerOn: uplo)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		a: a
		lda: (self cIntegerPointerOn: lda)
		info: cARGinfo
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-solve' stamp: 'nice 6/26/2010 19:21'!
trtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb 
	"Solve a triangular system of equations A*x=B in x"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xtrtrsWithuplo: (self cCharPointerOn: uplo)
		trans: (self cCharPointerOn: trans)
		diag: (self cCharPointerOn: diag)
		n: (self cIntegerPointerOn: n)
		nrhs: (self cIntegerPointerOn: nrhs)
		a: a
		lda: (self cIntegerPointerOn: lda)
		b: b
		ldb: (self cIntegerPointerOn: ldb)
		info: cARGinfo
		length: 1
		length: 1
		length: 1.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/3/2011 20:24'!
unghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		unghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := (ihi getHandle signedLongAt: 1) - (ilo getHandle signedLongAt: 1) max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		unghrWithn: n
		ilo: ilo
		ihi: ihi
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-hessenberg' stamp: 'nice 6/26/2010 19:16'!
unghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix
	ilo and ihi must be allocated outside"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xunghrWithn: (self cIntegerPointerOn: n)
		ilo: ilo
		ihi: ihi
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
unglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xunglqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
ungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xungqlWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/3/2011 20:24'!
ungqrWithm: m n: n k: k a: a lda: lda tau: tau 
	"generate orthonormal matrix
	use LAPACK 3.0 feature to get optimized lwork
	return 0 if OK"

	| work lwork |
	work := self allocateElementArraySize: 1.
	(self 
		ungqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: -1) = 0 
		ifTrue: [lwork := self retrieveLengthQueryAnswerFrom: work]
		ifFalse: [lwork := n max: 1].
	work := self allocateElementArraySize: lwork.
	^self 
		ungqrWithm: m
		n: n
		k: k
		a: a
		lda: lda
		tau: tau
		work: work
		lwork: lwork! !

!LapackLibrary methodsFor: 'processing-qr' stamp: 'nice 6/26/2010 19:46'!
ungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	"build orthonormal matrix"
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xungqrWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'processing-qr' stamp: ''!
ungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork 
	| cARGinfo |
	cARGinfo := self cIntegerPointerOn: 0.
	self
		xungrqWithm: (self cIntegerPointerOn: m)
		n: (self cIntegerPointerOn: n)
		k: (self cIntegerPointerOn: k)
		a: a
		lda: (self cIntegerPointerOn: lda)
		tau: tau
		work: work
		lwork: (self cIntegerPointerOn: lwork)
		info: cARGinfo.
	^cARGinfo getHandle signedLongAt: 1! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
uniform01
	"used by random number generator"

	^1! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
uniform11
	"used by random number generator"

	^2! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
uniformCircle
	"used by random number generator"

	^5! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
uniformDisc
	"used by random number generator"

	^4! !

!LapackLibrary methodsFor: 'accessing' stamp: ''!
upper
	^$U! !

!LapackLibrary methodsFor: 'processing-eigenvalue' stamp: ''!
valueEigenValuesInterval
	"for finding eigenvalues lying in a certain interval"

	^$V! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 2/19/2009 09:39'!
wantQ: aBoolean
	^aBoolean
		ifTrue: [$Q]
		ifFalse: [$N]! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 2/19/2009 09:39'!
wantU: aBoolean
	^aBoolean
		ifTrue: [$U]
		ifFalse: [$N]! !

!LapackLibrary methodsFor: 'processing-svd' stamp: 'nice 2/19/2009 09:39'!
wantV: aBoolean
	^aBoolean
		ifTrue: [$V]
		ifFalse: [$N]! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info length: lengthOfjob 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork info: info length: lengthOfjobvs length: lengthOfsort 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork info: info length: lengthOfjobvs length: lengthOfsort 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info length: lengthOfjobvl length: lengthOfjobvr 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info length: lengthOfjobvl length: lengthOfjobvr 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info length: lengthOftrans 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork info: info length: lengthOfjobz 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork info: info length: lengthOfjobz 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork info: info length: lengthOfjobu length: lengthOfjobvt 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork info: info length: lengthOfjobu length: lengthOfjobvt 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOftrans 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info length: lengthOfjob 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info length: lengthOfjobvl length: lengthOfjobvr 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info length: lengthOfjobvl length: lengthOfjobvr 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info length: lengthOfcompq length: lengthOfcompz 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:40'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork info: info length: lengthOfjobu length: lengthOfjobv length: lengthOfjobq 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:46'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork info: info length: lengthOfjobu length: lengthOfjobv length: lengthOfjobq 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xheconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xheevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork info: info length: ljobz length: luplo 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xheevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xheevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xheevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlacgvWithn: n x: x incx: incx 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlamchWithcmach: cmach length: lengthOfcmach 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlanhpWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xorghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xorglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xorgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xorgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xorgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsyevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info length: lengthOftrans 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst info: info length: lengthOfcompq 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work info: info length: lengthOfcompq 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork info: info length: lengthOfjob length: lengthOfcompq 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjob length: lengthOfcompq 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info length: lengthOftrana length: lengthOftranb 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info length: lengthOfuplo length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xunghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xunglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

!LapackLibrary methodsFor: 'procedures' stamp: ''!
xungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 

	self subclassResponsibility! !

LapackLibrary subclass: #LapackSLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!LapackSLibrary commentStamp: 'nice 7/29/2016 23:17' prior: 0!
LapackSLibrary holds LAPACK functions for the single precision real arithmetic!

!LapackSLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cFloatComplexPointerOn: aComplex! !

!LapackSLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aDouble 
	^self cRealPointerOn: aDouble! !

!LapackSLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cFloatPointerOn: aDouble! !

!LapackSLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^false! !

!LapackSLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^false! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  SGEBAK forms the right or left eigenvectors of a real general matrix
*  by backward transformation on the computed eigenvectors of the
*  balanced matrix output by SGEBAL.
"

	<cdecl: long 'sgebak_'( char * char * long * long * long * float * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  SGEBAL balances a general real matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'sgebal_'( char * long * float * long * long * long * float * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm 
	"
*  Purpose
*  =======
*  SGECON estimates the reciprocal of the condition number of a general
*  real matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by SGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'sgecon_'( char * long * float * long * float * float * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim wr: wr wi: wi vs: vs ldvs: ldvs work: work lwork: lwork bwork: bwork info: info length: lengthOfjobvs length: lengthOfsort 
	"
*  Purpose
*  =======
*  SGEES computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues, the real Schur form T, and, optionally, the matrix of
*  Schur vectors Z.  This gives the Schur factorization A = Z*T*(Z**T).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  real Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A matrix is in real Schur form if it is upper quasi-triangular with
*  1-by-1 and 2-by-2 blocks. 2-by-2 blocks will be standardized in the
*  form
*          [  a  b  ]
*          [  c  a  ]
*  where b*c < 0. The eigenvalues of such a block are a +- sqrt(bc).
"

	<cdecl: long 'sgees_'( char * char * long * long * float * long * long * float * float * float * long * float * long * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda wr: wr wi: wi vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  SGEEV computes for an N-by-N real nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'sgeev_'( char * char * long * float * long * float * float * float * long * float * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'sgehrd_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELQF computes an LQ factorization of a real M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'sgelqf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  SGELS solves overdetermined or underdetermined real linear systems
*  involving an M-by-N matrix A, or its transpose, using a QR or LQ
*  factorization of A.  It is assumed that A has full rank.
*  The following options are provided: 
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'T' and m >= n:  find the minimum norm solution of
*     an undetermined system A**T * X = B.
*  4. If TRANS = 'T' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**T * X ||.
*  Several right hand side vectors b and solution vectors x can be 
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution 
*  matrix X.
"

	<cdecl: long 'sgels_'( char * long * long * long * float * long * float * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  SGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder transformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'sgelsd_'( long * long * long * float * long * float * long * float * float * long * float * long * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELSS computes the minimum norm solution to a real linear least
*  squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'sgelss_'( long * long * long * float * long * float * long * float * float * long * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine SGELSY.
*  SGELSX computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be 
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'sgelsx_'( long * long * long * float * long * float * long * long * float * long * float * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGELSY computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by orthogonal transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
"

	<cdecl: long 'sgelsy_'( long * long * long * float * long * float * long * long * float * long * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEQLF computes a QL factorization of a real M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'sgeqlf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'sgeqp3_'( long * long * float * long * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGEQRF computes a QR factorization of a real M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'sgeqrf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGERQF computes an RQ factorization of a real M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'sgerqf_'( long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork iwork: iwork info: info length: lengthOfjobz 
	"
*  Purpose
*  =======
*  SGESDD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and right singular
*  vectors.  If singular vectors are desired, it uses a
*  divide-and-conquer algorithm.
*  The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**T, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'sgesdd_'( char * long * long * float * long * float * float * long * float * long * float * long * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  SGESV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'sgesv_'( long * long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork info: info length: lengthOfjobu length: lengthOfjobvt 
	"
*  Purpose
*  =======
*  SGESVD computes the singular value decomposition (SVD) of a real
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M orthogonal matrix, and
*  V is an N-by-N orthogonal matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**T, not V.
"

	<cdecl: long 'sgesvd_'( char * char * long * long * float * long * float * float * long * float * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  SGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'sgetrf_'( long * long * float * long * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGETRI computes the inverse of a matrix using the LU factorization
*  computed by SGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'sgetri_'( long * float * long * long * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  SGETRS solves a system of linear equations
*     A * X = B  or  A' * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by SGETRF.
"

	<cdecl: long 'sgetrs_'( char * long * long * float * long * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  SGGBAK forms the right or left eigenvectors of a real generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  SGGBAL.
"

	<cdecl: long 'sggbak_'( char * char * long * long * long * float * float * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  SGGBAL balances a pair of general real matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'sggbal_'( char * long * float * long * float * long * long * long * float * float * float * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  SGGEV computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j).
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B .
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'sggev_'( char * char * long * float * long * float * long * float * float * float * float * long * float * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork iwork: iwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  SGGEVX computes for a pair of N-by-N real nonsymmetric matrices (A,B)
*  the generalized eigenvalues, and optionally, the left and/or right
*  generalized eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'sggevx_'( char * char * char * char * long * float * long * float * long * float * float * float * float * long * float * long * float * float * float * float * float * float * float * long * long * long * long * long long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'sggglm_'( long * long * long * float * long * float * long * float * float * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info length: lengthOfcompq length: lengthOfcompz 
	"
*  Purpose
*  =======
*  SGGHRD reduces a pair of real matrices (A,B) to generalized upper
*  Hessenberg form using orthogonal transformations, where A is a
*  general matrix and B is upper triangular.  The form of the
*  generalized eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the orthogonal matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**T*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**T*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**T*x.
*  The orthogonal matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**T = (Q1*Q) * H * (Z1*Z)**T
*       Q1 * B * Z1**T = (Q1*Q) * T * (Z1*Z)**T
*  If Q1 is the orthogonal matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then SGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'sgghrd_'( char * char * long * long * long * float * long * float * long * float * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'sgglse_'( long * long * long * float * long * float * long * float * float * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'sggqrf_'( long * long * long * float * long * float * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N orthogonal matrix, Z is a P-by-P orthogonal
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  transpose of the matrix Z.
"

	<cdecl: long 'sggrqf_'( long * long * long * float * long * float * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:41'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work iwork: iwork info: info length: lengthOfjobu length: lengthOfjobv length: lengthOfjobq 
	"
*  Purpose
*  =======
*  SGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N real matrix A and P-by-N real matrix B:
*      U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are orthogonal matrices, and Z' is the transpose
*  of Z.  Let K+L = the effective numerical rank of the matrix (A',B')',
*  then R is a K+L-by-K+L nonsingular upper triangular matrix, D1 and
*  D2 are M-by-(K+L) and P-by-(K+L) 'diagonal' matrices and of the
*  following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the orthogonal
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthonormal columns, then the GSVD of A and B is
*  also equal to the CS decomposition of A and B. Furthermore, the GSVD
*  can be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                       X = Q*( I   0    )
*                             ( 0 inv(R) ).
"

	<cdecl: long 'sggsvd_'( char * char * char * long * long * long * long * long * float * long * float * long * float * float * float * long * float * long * float * long * float * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	^self 
		xsysvWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		work: work
		lwork: lwork
		info: info
		length: lengthOfuplo! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: luplo 
	^self 
		xsytrfWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		lwork: lwork
		info: info
		length: luplo! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	^self 
		xsytriWithuplo: uplo
		n: n
		a: a
		lda: lda
		ipiv: ipiv
		work: work
		info: info
		length: lengthOfuplo! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	^self 
		xsytrsWithuplo: uplo
		n: n
		nrhs: nrhs
		a: a
		lda: lda
		ipiv: ipiv
		b: b
		ldb: ldb
		info: info
		length: lengthOfuplo! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'slacpy_'( char * long * long * float * long * float * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlamchWithcmach: cmach length: lengthOfcmach 
	"
*  Purpose
*  =======
*  SLAMCH determines single precision machine parameters.
"

	<cdecl: float 'slamch_'( char * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:33'!
xlangeF2CWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 
	"
*  Purpose
*  =======
*  SLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real matrix A.
"

	<cdecl: double 'slange_'( char * long * long * float * long * float * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 
	"
*  Purpose
*  =======
*  SLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real matrix A.
"

	<cdecl: float 'slange_'( char * long * long * float * long * float * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:33'!
xlanspF2CWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'slansp_'( char * char * long * float * float * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A,  supplied in packed form.
"

	<cdecl: float 'slansp_'( char * char * long * float * float * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:33'!
xlansyF2CWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
"

	<cdecl: double 'slansy_'( char * char * long * float * long * float * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  real symmetric matrix A.
"

	<cdecl: float 'slansy_'( char * char * long * float * long * float * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:33'!
xlantpF2CWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  SLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'slantp_'( char * char * char * long * float * float * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  SLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: float 'slantp_'( char * char * char * long * float * float * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: 'nice 1/27/2017 22:34'!
xlantrF2CWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  SLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'slantr_'( char * char * char * long * long * float * long * float * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  SLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: float 'slantr_'( char * char * char * long * long * float * long * float * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  SLARNV returns a vector of n random real numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'slarnv_'( long * long * long * float * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SLASET initializes an m-by-n matrix A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'slaset_'( char * long * long * float * float * float * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xorghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'sorghr_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xorglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGLQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by SGELQF.
"

	<cdecl: long 'sorglq_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xorgqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGQL generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by SGEQLF.
"

	<cdecl: long 'sorgql_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xorgqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGQR generates an M-by-N real matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by SGEQRF.
"

	<cdecl: long 'sorgqr_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xorgrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  SORGRQ generates an M-by-N real matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by SGERQF.
"

	<cdecl: long 'sorgrq_'( long * long * long * float * long * float * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SPOTRF computes the Cholesky factorization of a real symmetric
*  positive definite matrix A.
*  The factorization has the form
*     A = U**T * U,  if UPLO = 'U', or
*     A = L  * L**T,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'spotrf_'( char * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work iwork: iwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a real symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by SSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'ssycon_'( char * long * float * long * long * float * float * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYEV computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A.
"

	<cdecl: long 'ssyev_'( char * char * long * float * long * float * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYEVD computes all eigenvalues and, optionally, eigenvectors of a
*  real symmetric matrix A. If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
*  Because of large use of BLAS of level 3, SSYEVD needs N**2 more
*  workspace than SSYEVX.
"

	<cdecl: long 'ssyevd_'( char * char * long * float * long * float * float * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix T.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, SSYEVR calls SSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  SSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : SSYEVR calls SSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  SSYEVR calls SSTEBZ and SSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of SSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'ssyevr_'( char * char * char * long * float * long * float * float * long * long * float * long * float * float * long * long * float * long * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsyevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A.  Eigenvalues and eigenvectors can be
*  selected by specifying either a range of values or a range of indices
*  for the desired eigenvalues.
"

	<cdecl: long 'ssyevx_'( char * char * char * long * float * long * float * float * long * long * float * long * float * float * long * float * long * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsygvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be symmetric and B is also
*  positive definite.
"

	<cdecl: long 'ssygv_'( long * char * char * long * float * long * float * long * float * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsygvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be symmetric and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'ssygvd_'( long * char * char * long * float * long * float * long * float * float * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsygvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a real generalized symmetric-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A
*  and B are assumed to be symmetric and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'ssygvx_'( long * char * char * char * long * float * long * float * long * float * float * long * long * float * long * float * float * long * float * long * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYSV computes the solution to a real system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'ssysv_'( char * long * long * float * long * long * float * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYTRF computes the factorization of a real symmetric matrix A using
*  the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with 
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'ssytrf_'( char * long * float * long * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYTRI computes the inverse of a real symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  SSYTRF.
"

	<cdecl: long 'ssytri_'( char * long * float * long * long * float * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  SSYTRS solves a system of linear equations A*X = B with a real
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by SSYTRF.
"

	<cdecl: long 'ssytrs_'( char * long * long * float * long * long * float * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  STGEXC reorders the generalized real Schur decomposition of a real
*  matrix pair (A,B) using an orthogonal equivalence transformation
*                 (A, B) = Q * (A, B) * Z',
*  so that the diagonal block of (A, B) with row index IFST is moved
*  to row ILST.
*  (A, B) must be in generalized real Schur canonical form (as returned
*  by SGGES), i.e. A is block upper triangular with 1-by-1 and 2-by-2
*  diagonal blocks. B is upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'stgexc_'( long * long * long * float * long * float * long * float * long * float * long * long * long * float * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alphar: alphar alphai: alphai beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  STGSEN reorders the generalized real Schur decomposition of a real
*  matrix pair (A, B) (in terms of an orthonormal equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the upper quasi-triangular
*  matrix A and the upper triangular B. The leading columns of Q and
*  Z form orthonormal bases of the corresponding left and right eigen-
*  spaces (deflating subspaces). (A, B) must be in generalized real
*  Schur canonical form (as returned by SGGES), i.e. A is block upper
*  triangular with 1-by-1 and 2-by-2 diagonal blocks. B is upper
*  triangular.
*  STGSEN also computes the generalized eigenvalues
*              w(j) = (ALPHAR(j) + i*ALPHAI(j))/BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, STGSEN computes the estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'stgsen_'( long * long * long * long * long * float * long * float * long * float * float * float * float * long * float * long * long * float * float * long * long * long * long * )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  STGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C                 (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with real entries. (A, D) and (B, E) must be in
*  generalized (real) Schur canonical form, i.e. A, B are upper quasi
*  triangular and D, E are upper triangular.
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1 is an output
*  scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve  Zx = scale b, where
*  Z is defined as
*             Z = [ kron(In, A)  -kron(B', Im) ]         (2)
*                 [ kron(In, D)  -kron(E', Im) ].
*  Here Ik is the identity matrix of size k and X' is the transpose of
*  X. kron(X, Y) is the Kronecker product between the matrices X and Y.
*  If TRANS = 'T', STGSYL solves the transposed system Z'*y = scale*b,
*  which is equivalent to solve for R and L in
*              A' * R  + D' * L   = scale *  C           (3)
*              R  * B' + L  * E'  = scale * (-F)
*  This case (TRANS = 'T') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using SLACON.
*  If IJOB >= 1, STGSYL computes a Frobenius norm-based estimate
*  of Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z. See [1-2] for more
*  information.
*  This is a level 3 BLAS algorithm.
"

	<cdecl: long 'stgsyl_'( char * long * long * long * float * long * float * long * float * long * float * long * float * long * float * long * float * float * float * long * long * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  STPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'stpcon_'( char * char * char * long * float * float * float * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  STPTRI computes the inverse of a real upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'stptri_'( char * char * long * float * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  STPTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'stptrs_'( char * char * char * long * long * float * float * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work iwork: iwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  STRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'strcon_'( char * char * char * long * float * long * float * float * long * long * long long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst work: work info: info length: lengthOfcompq 
	"
*  Purpose
*  =======
*  STREXC reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that the diagonal block of T with row index IFST is
*  moved to row ILST.
*  The real Schur form T is reordered by an orthogonal similarity
*  transformation Z**T*T*Z, and optionally the matrix Q of Schur vectors
*  is updated by postmultiplying it with Z.
*  T must be in Schur canonical form (as returned by SHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'strexc_'( char * long * float * long * float * long * long * long * float * long * long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq wr: wr wi: wi m: m s: s sep: sep work: work lwork: lwork iwork: iwork liwork: liwork info: info length: lengthOfjob length: lengthOfcompq 
	"
*  Purpose
*  =======
*  STRSEN reorders the real Schur factorization of a real matrix
*  A = Q*T*Q**T, so that a selected cluster of eigenvalues appears in
*  the leading diagonal blocks of the upper quasi-triangular matrix T,
*  and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
*  T must be in Schur canonical form (as returned by SHSEQR), that is,
*  block upper triangular with 1-by-1 and 2-by-2 diagonal blocks; each
*  2-by-2 diagonal block has its diagonal elemnts equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'strsen_'( char * char * long * long * float * long * float * long * float * float * long * float * float * float * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info length: lengthOftrana length: lengthOftranb 
	"
*  Purpose
*  =======
*  STRSYL solves the real Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**T, and  A and B are both upper quasi-
*  triangular. A is M-by-M and B is N-by-N; the right hand side C and
*  the solution X are M-by-N; and scale is an output scale factor, set
*  <= 1 to avoid overflow in X.
*  A and B must be in Schur canonical form (as returned by SHSEQR), that
*  is, block upper triangular with 1-by-1 and 2-by-2 diagonal blocks;
*  each 2-by-2 diagonal block has its diagonal elements equal and its
*  off-diagonal elements of opposite sign.
"

	<cdecl: long 'strsyl_'( char * char * long * long * long * float * long * float * long * float * long * float * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  STRTRI computes the inverse of a real upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'strtri_'( char * char * long * float * long * long * long long )>
	^self externalCallFailed! !

!LapackSLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  STRTRS solves a triangular system of the form
*     A * X = B  or  A**T * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'strtrs_'( char * char * char * long * long * float * long * float * long * long * long long long )>
	^self externalCallFailed! !

LapackLibrary subclass: #LapackZLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-External'!

!LapackZLibrary commentStamp: 'nice 7/29/2016 23:16' prior: 0!
LapackZLibrary holds LAPACK functions for the double precision complex arithmetic!

!LapackZLibrary methodsFor: 'accessing' stamp: ''!
cComplexPointerOn: aComplex 
	^self cDoubleComplexPointerOn: aComplex! !

!LapackZLibrary methodsFor: 'accessing' stamp: ''!
cElementPointerOn: aComplex 
	^self cComplexPointerOn: aComplex! !

!LapackZLibrary methodsFor: 'accessing' stamp: ''!
cRealPointerOn: aDouble 
	^self cDoublePointerOn: aDouble! !

!LapackZLibrary methodsFor: 'testing' stamp: ''!
isComplex
	^true! !

!LapackZLibrary methodsFor: 'testing' stamp: ''!
isDoublePrecision
	^true! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgebakWithjob: job side: side n: n ilo: ilo ihi: ihi scale: scale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  ZGEBAK forms the right or left eigenvectors of a complex general
*  matrix by backward transformation on the computed eigenvectors of the
*  balanced matrix output by ZGEBAL.
"

	<cdecl: long 'zgebak_'( char * char * long * long * long * double * long * "ExternalDoubleComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgebalWithjob: job n: n a: a lda: lda ilo: ilo ihi: ihi scale: scale info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  ZGEBAL balances a general complex matrix A.  This involves, first,
*  permuting A by a similarity transformation to isolate eigenvalues
*  in the first 1 to ILO-1 and last IHI+1 to N elements on the
*  diagonal; and second, applying a diagonal similarity transformation
*  to rows and columns ILO to IHI to make the rows and columns as
*  close in norm as possible.  Both steps are optional.
*  Balancing may reduce the 1-norm of the matrix, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors.
"

	<cdecl: long 'zgebal_'( char * long * "ExternalDoubleComplex"void * long * long * long * double * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeconWithnorm: norm n: n a: a lda: lda anorm: anorm rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm 
	"
*  Purpose
*  =======
*  ZGECON estimates the reciprocal of the condition number of a general
*  complex matrix A, in either the 1-norm or the infinity-norm, using
*  the LU factorization computed by ZGETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'zgecon_'( char * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * double * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeesWithjobvs: jobvs sort: sort select: select n: n a: a lda: lda sdim: sdim w: w vs: vs ldvs: ldvs work: work lwork: lwork rwork: rwork bwork: bwork info: info length: lengthOfjobvs length: lengthOfsort 
	"
*  Purpose
*  =======
*  ZGEES computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues, the Schur form T, and, optionally, the matrix of Schur
*  vectors Z.  This gives the Schur factorization A = Z*T*(Z**H).
*  Optionally, it also orders the eigenvalues on the diagonal of the
*  Schur form so that selected eigenvalues are at the top left.
*  The leading columns of Z then form an orthonormal basis for the
*  invariant subspace corresponding to the selected eigenvalues.
*  A complex matrix is in Schur form if it is upper triangular.
"

	<cdecl: long 'zgees_'( char * char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  ZGEEV computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
"

	<cdecl: long 'zgeev_'( char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda w: w vl: vl ldvl: ldvl vr: vr ldvr: ldvr scale: scale abnrm: abnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  ZGEEVX computes for an N-by-N complex nonsymmetric matrix A, the
*  eigenvalues and, optionally, the left and/or right eigenvectors.
*  Optionally also, it computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  SCALE, and ABNRM), reciprocal condition numbers for the eigenvalues
*  (RCONDE), and reciprocal condition numbers for the right
*  eigenvectors (RCONDV).
*  The right eigenvector v(j) of A satisfies
*                   A * v(j) = lambda(j) * v(j)
*  where lambda(j) is its eigenvalue.
*  The left eigenvector u(j) of A satisfies
*                u(j)**H * A = lambda(j) * u(j)**H
*  where u(j)**H denotes the conjugate transpose of u(j).
*  The computed eigenvectors are normalized to have Euclidean norm
*  equal to 1 and largest component real.
*  Balancing a matrix means permuting the rows and columns to make it
*  more nearly upper triangular, and applying a diagonal similarity
*  transformation D * A * D**(-1), where D is a diagonal matrix, to
*  make its rows and columns closer in norm and the condition numbers
*  of its eigenvalues and eigenvectors smaller.  The computed
*  reciprocal condition numbers correspond to the balanced matrix.
*  Permuting rows and columns will not change the condition numbers
*  (in exact arithmetic) but diagonal scaling will.  For further
*  explanation of balancing, see section 4.10.2 of the LAPACK
*  Users' Guide.
"

	<cdecl: long 'zgeevx_'( char * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * double * double * "ExternalDoubleComplex"void * long * double * long * long long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgehrdWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'zgehrd_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGELQF computes an LQ factorization of a complex M-by-N matrix A:
*  A = L * Q.
"

	<cdecl: long 'zgelqf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsWithtrans: trans m: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb work: work lwork: lwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  ZGELS solves overdetermined or underdetermined complex linear systems
*  involving an M-by-N matrix A, or its conjugate-transpose, using a QR
*  or LQ factorization of A.  It is assumed that A has full rank.
*  The following options are provided:
*  1. If TRANS = 'N' and m >= n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A*X ||.
*  2. If TRANS = 'N' and m < n:  find the minimum norm solution of
*     an underdetermined system A * X = B.
*  3. If TRANS = 'C' and m >= n:  find the minimum norm solution of
*     an undetermined system A**H * X = B.
*  4. If TRANS = 'C' and m < n:  find the least squares solution of
*     an overdetermined system, i.e., solve the least squares problem
*                  minimize || B - A**H * X ||.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
"

	<cdecl: long 'zgels_'( char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsdWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork iwork: iwork info: info 
	"
*  Purpose
*  =======
*  ZGELSD computes the minimum-norm solution to a real linear least
*  squares problem:
*      minimize 2-norm(| b - A*x |)
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The problem is solved in three steps:
*  (1) Reduce the coefficient matrix A to bidiagonal form with
*      Householder tranformations, reducing the original problem
*      into a 'bidiagonal least squares problem' (BLS)
*  (2) Solve the BLS using a divide and conquer approach.
*  (3) Apply back all the Householder tranformations to solve
*      the original least squares problem.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zgelsd_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * long * "ExternalDoubleComplex"void * long * double * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelssWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb s: s rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGELSS computes the minimum norm solution to a complex linear
*  least squares problem:
*  Minimize 2-norm(| b - A*x |).
*  using the singular value decomposition (SVD) of A. A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution matrix
*  X.
*  The effective rank of A is determined by treating as zero those
*  singular values which are less than RCOND times the largest singular
*  value.
"

	<cdecl: long 'zgelss_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsxWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work rwork: rwork info: info 
	"
*  Purpose
*  =======
*  This routine is deprecated and has been replaced by routine ZGELSY.
*  ZGELSX computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
"

	<cdecl: long 'zgelsx_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * double * long * "ExternalDoubleComplex"void * double * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgelsyWithm: m n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb jpvt: jpvt rcond: rcond rank: rank work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGELSY computes the minimum-norm solution to a complex linear least
*  squares problem:
*      minimize || A * X - B ||
*  using a complete orthogonal factorization of A.  A is an M-by-N
*  matrix which may be rank-deficient.
*  Several right hand side vectors b and solution vectors x can be
*  handled in a single call; they are stored as the columns of the
*  M-by-NRHS right hand side matrix B and the N-by-NRHS solution
*  matrix X.
*  The routine first computes a QR factorization with column pivoting:
*      A * P = Q * [ R11 R12 ]
*                  [  0  R22 ]
*  with R11 defined as the largest leading submatrix whose estimated
*  condition number is less than 1/RCOND.  The order of R11, RANK,
*  is the effective rank of A.
*  Then, R22 is considered to be negligible, and R12 is annihilated
*  by unitary transformations from the right, arriving at the
*  complete orthogonal factorization:
*     A * P = Q * [ T11 0 ] * Z
*                 [  0  0 ]
*  The minimum-norm solution is then
*     X = P * Z' [ inv(T11)*Q1'*B ]
*                [        0       ]
*  where Q1 consists of the first RANK columns of Q.
*  This routine is basically identical to the original xGELSX except
*  three differences:
*    o The permutation of matrix B (the right hand side) is faster and
*      more simple.
*    o The call to the subroutine xGEQPF has been substituted by the
*      the call to the subroutine xGEQP3. This subroutine is a Blas-3
*      version of the QR factorization with column pivoting.
*    o Matrix B (the right hand side) is updated with Blas-3.
"

	<cdecl: long 'zgelsy_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * double * long * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeqlfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGEQLF computes a QL factorization of a complex M-by-N matrix A:
*  A = Q * L.
"

	<cdecl: long 'zgeqlf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeqp3Withm: m n: n a: a lda: lda jpvt: jpvt tau: tau work: work lwork: lwork rwork: rwork info: info 
	"
*  Purpose
*  =======
*  ZGEQP3 computes a QR factorization with column pivoting of a
*  matrix A:  A*P = Q*R  using Level 3 BLAS.
"

	<cdecl: long 'zgeqp3_'( long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * double * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgeqrfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGEQRF computes a QR factorization of a complex M-by-N matrix A:
*  A = Q * R.
"

	<cdecl: long 'zgeqrf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgerqfWithm: m n: n a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGERQF computes an RQ factorization of a complex M-by-N matrix A:
*  A = R * Q.
"

	<cdecl: long 'zgerqf_'( long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgesddWithjobz: jobz m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork iwork: iwork info: info length: lengthOfjobz 
	"
*  Purpose
*  =======
*  ZGESDD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors, by using divide-and-conquer method. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns VT = V**H, not V.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zgesdd_'( char * long * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgesvWithn: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info 
	"
*  Purpose
*  =======
*  ZGESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N matrix and X and B are N-by-NRHS matrices.
*  The LU decomposition with partial pivoting and row interchanges is
*  used to factor A as
*     A = P * L * U,
*  where P is a permutation matrix, L is unit lower triangular, and U is
*  upper triangular.  The factored form of A is then used to solve the
*  system of equations A * X = B.
"

	<cdecl: long 'zgesv_'( long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgesvdWithjobu: jobu jobvt: jobvt m: m n: n a: a lda: lda s: s u: u ldu: ldu vt: vt ldvt: ldvt work: work lwork: lwork rwork: rwork info: info length: lengthOfjobu length: lengthOfjobvt 
	"
*  Purpose
*  =======
*  ZGESVD computes the singular value decomposition (SVD) of a complex
*  M-by-N matrix A, optionally computing the left and/or right singular
*  vectors. The SVD is written
*       A = U * SIGMA * conjugate-transpose(V)
*  where SIGMA is an M-by-N matrix which is zero except for its
*  min(m,n) diagonal elements, U is an M-by-M unitary matrix, and
*  V is an N-by-N unitary matrix.  The diagonal elements of SIGMA
*  are the singular values of A; they are real and non-negative, and
*  are returned in descending order.  The first min(m,n) columns of
*  U and V are the left and right singular vectors of A.
*  Note that the routine returns V**H, not V.
"

	<cdecl: long 'zgesvd_'( char * char * long * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgetrfWithm: m n: n a: a lda: lda ipiv: ipiv info: info 
	"
*  Purpose
*  =======
*  ZGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*  This is the right-looking Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'zgetrf_'( long * long * "ExternalDoubleComplex"void * long * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgetriWithn: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGETRI computes the inverse of a matrix using the LU factorization
*  computed by ZGETRF.
*  This method inverts U and then computes inv(A) by solving the system
*  inv(A)*L = inv(U) for inv(A).
"

	<cdecl: long 'zgetri_'( long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgetrsWithtrans: trans n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  ZGETRS solves a system of linear equations
*     A * X = B,  A**T * X = B,  or  A**H * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by ZGETRF.
"

	<cdecl: long 'zgetrs_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggbakWithjob: job side: side n: n ilo: ilo ihi: ihi lscale: lscale rscale: rscale m: m v: v ldv: ldv info: info length: lengthOfjob length: lengthOfside 
	"
*  Purpose
*  =======
*  ZGGBAK forms the right or left eigenvectors of a complex generalized
*  eigenvalue problem A*x = lambda*B*x, by backward transformation on
*  the computed eigenvectors of the balanced pair of matrices output by
*  ZGGBAL.
"

	<cdecl: long 'zggbak_'( char * char * long * long * long * double * double * long * "ExternalDoubleComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggbalWithjob: job n: n a: a lda: lda b: b ldb: ldb ilo: ilo ihi: ihi lscale: lscale rscale: rscale work: work info: info length: lengthOfjob 
	"
*  Purpose
*  =======
*  ZGGBAL balances a pair of general complex matrices (A,B).  This
*  involves, first, permuting A and B by similarity transformations to
*  isolate eigenvalues in the first 1 to ILO$-$1 and last IHI+1 to N
*  elements on the diagonal; and second, applying a diagonal similarity
*  transformation to rows and columns ILO to IHI to make the rows
*  and columns as close in norm as possible. Both steps are optional.
*  Balancing may reduce the 1-norm of the matrices, and improve the
*  accuracy of the computed eigenvalues and/or eigenvectors in the
*  generalized eigenvalue problem A*x = lambda*B*x.
"

	<cdecl: long 'zggbal_'( char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long * double * double * double * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggevWithjobvl: jobvl jobvr: jobvr n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr work: work lwork: lwork rwork: rwork info: info length: lengthOfjobvl length: lengthOfjobvr 
	"
*  Purpose
*  =======
*  ZGGEV computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B), the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right generalized eigenvector v(j) corresponding to the
*  generalized eigenvalue lambda(j) of (A,B) satisfies
*               A * v(j) = lambda(j) * B * v(j).
*  The left generalized eigenvector u(j) corresponding to the
*  generalized eigenvalues lambda(j) of (A,B) satisfies
*               u(j)**H * A = lambda(j) * u(j)**H * B
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'zggev_'( char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  ZGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'zggevx_'( char * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * double * double * double * double * "ExternalDoubleComplex"void * long * double * long * long * long long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggevxWithbalanc: balanc jobvl: jobvl jobvr: jobvr sense: sense n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta vl: vl ldvl: ldvl vr: vr ldvr: ldvr lscale: lscale rscale: rscale abnrm: abnrm bbnrm: bbnrm rconde: rconde rcondv: rcondv work: work lwork: lwork rwork: rwork iwork: iwork bwork: bwork info: info length: lengthOfbalanc length: lengthOfjobvl length: lengthOfjobvr length: lengthOfsense 
	"
*  Purpose
*  =======
*  ZGGEVX computes for a pair of N-by-N complex nonsymmetric matrices
*  (A,B) the generalized eigenvalues, and optionally, the left and/or
*  right generalized eigenvectors.
*  Optionally, it also computes a balancing transformation to improve
*  the conditioning of the eigenvalues and eigenvectors (ILO, IHI,
*  LSCALE, RSCALE, ABNRM, and BBNRM), reciprocal condition numbers for
*  the eigenvalues (RCONDE), and reciprocal condition numbers for the
*  right eigenvectors (RCONDV).
*  A generalized eigenvalue for a pair of matrices (A,B) is a scalar
*  lambda or a ratio alpha/beta = lambda, such that A - lambda*B is
*  singular. It is usually represented as the pair (alpha,beta), as
*  there is a reasonable interpretation for beta=0, and even for both
*  being zero.
*  The right eigenvector v(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   A * v(j) = lambda(j) * B * v(j) .
*  The left eigenvector u(j) corresponding to the eigenvalue lambda(j)
*  of (A,B) satisfies
*                   u(j)**H * A  = lambda(j) * u(j)**H * B.
*  where u(j)**H is the conjugate-transpose of u(j).
"

	<cdecl: long 'zggevx_'( char * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * double * double * double * double * "ExternalDoubleComplex"void * long * double * long * long * long * long long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggglmWithn: n m: m p: p a: a lda: lda b: b ldb: ldb d: d x: x y: y work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGGLM solves a general Gauss-Markov linear model (GLM) problem:
*          minimize || y ||_2   subject to   d = A*x + B*y
*              x
*  where A is an N-by-M matrix, B is an N-by-P matrix, and d is a
*  given N-vector. It is assumed that M <= N <= M+P, and
*             rank(A) = M    and    rank( A B ) = N.
*  Under these assumptions, the constrained equation is always
*  consistent, and there is a unique solution x and a minimal 2-norm
*  solution y, which is obtained using a generalized QR factorization
*  of A and B.
*  In particular, if matrix B is square nonsingular, then the problem
*  GLM is equivalent to the following weighted linear least squares
*  problem
*               minimize || inv(B)*(d-A*x) ||_2
*                   x
*  where inv(B) denotes the inverse of B.
"

	<cdecl: long 'zggglm_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgghrdWithcompq: compq compz: compz n: n ilo: ilo ihi: ihi a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz info: info length: lengthOfcompq length: lengthOfcompz 
	"
*  Purpose
*  =======
*  ZGGHRD reduces a pair of complex matrices (A,B) to generalized upper
*  Hessenberg form using unitary transformations, where A is a
*  general matrix and B is upper triangular.  The form of the
*  generalized eigenvalue problem is
*     A*x = lambda*B*x,
*  and B is typically made upper triangular by computing its QR
*  factorization and moving the unitary matrix Q to the left side
*  of the equation.
*  This subroutine simultaneously reduces A to a Hessenberg matrix H:
*     Q**H*A*Z = H
*  and transforms B to another upper triangular matrix T:
*     Q**H*B*Z = T
*  in order to reduce the problem to its standard form
*     H*y = lambda*T*y
*  where y = Z**H*x.
*  The unitary matrices Q and Z are determined as products of Givens
*  rotations.  They may either be formed explicitly, or they may be
*  postmultiplied into input matrices Q1 and Z1, so that
*       Q1 * A * Z1**H = (Q1*Q) * H * (Z1*Z)**H
*       Q1 * B * Z1**H = (Q1*Q) * T * (Z1*Z)**H
*  If Q1 is the unitary matrix from the QR factorization of B in the
*  original equation A*x = lambda*B*x, then ZGGHRD reduces the original
*  problem to generalized Hessenberg form.
"

	<cdecl: long 'zgghrd_'( char * char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xgglseWithm: m n: n p: p a: a lda: lda b: b ldb: ldb c: c d: d x: x work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGLSE solves the linear equality-constrained least squares (LSE)
*  problem:
*          minimize || c - A*x ||_2   subject to   B*x = d
*  where A is an M-by-N matrix, B is a P-by-N matrix, c is a given
*  M-vector, and d is a given P-vector. It is assumed that
*  P <= N <= M+P, and
*           rank(B) = P and  rank( ( A ) ) = N.
*                                ( ( B ) )
*  These conditions ensure that the LSE problem has a unique solution,
*  which is obtained using a GRQ factorization of the matrices B and A.
"

	<cdecl: long 'zgglse_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggqrfWithn: n m: m p: p a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGQRF computes a generalized QR factorization of an N-by-M matrix A
*  and an N-by-P matrix B:
*              A = Q*R,        B = Q*T*Z,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary matrix,
*  and R and T assume one of the forms:
*  if N >= M,  R = ( R11 ) M  ,   or if N < M,  R = ( R11  R12 ) N,
*                  (  0  ) N-M                         N   M-N
*                     M
*  where R11 is upper triangular, and
*  if N <= P,  T = ( 0  T12 ) N,   or if N > P,  T = ( T11 ) N-P,
*                   P-N  N                           ( T21 ) P
*                                                       P
*  where T12 or T21 is upper triangular.
*  In particular, if B is square and nonsingular, the GQR factorization
*  of A and B implicitly gives the QR factorization of inv(B)*A:
*               inv(B)*A = Z'*(inv(T)*R)
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of matrix Z.
"

	<cdecl: long 'zggqrf_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xggrqfWithm: m p: p n: n a: a lda: lda taua: taua b: b ldb: ldb taub: taub work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZGGRQF computes a generalized RQ factorization of an M-by-N matrix A
*  and a P-by-N matrix B:
*              A = R*Q,        B = Z*T*Q,
*  where Q is an N-by-N unitary matrix, Z is a P-by-P unitary
*  matrix, and R and T assume one of the forms:
*  if M <= N,  R = ( 0  R12 ) M,   or if M > N,  R = ( R11 ) M-N,
*                   N-M  M                           ( R21 ) N
*                                                       N
*  where R12 or R21 is upper triangular, and
*  if P >= N,  T = ( T11 ) N  ,   or if P < N,  T = ( T11  T12 ) P,
*                  (  0  ) P-N                         P   N-P
*                     N
*  where T11 is upper triangular.
*  In particular, if B is square and nonsingular, the GRQ factorization
*  of A and B implicitly gives the RQ factorization of A*inv(B):
*               A*inv(B) = (R*inv(T))*Z'
*  where inv(B) denotes the inverse of the matrix B, and Z' denotes the
*  conjugate transpose of the matrix Z.
"

	<cdecl: long 'zggrqf_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: 'nice 2/20/2009 03:46'!
xggsvdWithjobu: jobu jobv: jobv jobq: jobq m: m n: n p: p k: k l: l a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta u: u ldu: ldu v: v ldv: ldv q: q ldq: ldq work: work rwork: rwork iwork: iwork info: info length: lengthOfjobu length: lengthOfjobv length: lengthOfjobq 
	"
*  Purpose
*  =======
*  ZGGSVD computes the generalized singular value decomposition (GSVD)
*  of an M-by-N complex matrix A and P-by-N complex matrix B:
*        U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R )
*  where U, V and Q are unitary matrices, and Z' means the conjugate
*  transpose of Z.  Let K+L = the effective numerical rank of the
*  matrix (A',B')', then R is a (K+L)-by-(K+L) nonsingular upper
*  triangular matrix, D1 and D2 are M-by-(K+L) and P-by-(K+L) 'diagonal'
*  matrices and of the following structures, respectively:
*  If M-K-L >= 0,
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*                    K  L
*         D2 =   L ( 0  S )
*              P-L ( 0  0 )
*                  N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 )
*              L (  0    0   R22 )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*  If M-K-L < 0,
*                    K M-K K+L-M
*         D1 =   K ( I  0    0   )
*              M-K ( 0  C    0   )
*                      K M-K K+L-M
*         D2 =   M-K ( 0  S    0  )
*              K+L-M ( 0  0    I  )
*                P-L ( 0  0    0  )
*                     N-K-L  K   M-K  K+L-M
*    ( 0 R ) =     K ( 0    R11  R12  R13  )
*                M-K ( 0     0   R22  R23  )
*              K+L-M ( 0     0    0   R33  )
*  where
*    C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*    S = diag( BETA(K+1),  ... , BETA(M) ),
*    C**2 + S**2 = I.
*    (R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N), and R33 is stored
*    ( 0  R22 R23 )
*    in B(M-K+1:L,N+M-K-L+1:N) on exit.
*  The routine computes C, S, R, and optionally the unitary
*  transformation matrices U, V and Q.
*  In particular, if B is an N-by-N nonsingular matrix, then the GSVD of
*  A and B implicitly gives the SVD of A*inv(B):
*                       A*inv(B) = U*(D1*inv(D2))*V'.
*  If ( A',B')' has orthnormal columns, then the GSVD of A and B is also
*  equal to the CS decomposition of A and B. Furthermore, the GSVD can
*  be used to derive the solution of the eigenvalue problem:
*                       A'*A x = lambda* B'*B x.
*  In some literature, the GSVD of A and B is presented in the form
*                   U'*A*X = ( 0 D1 ),   V'*B*X = ( 0 D2 )
*  where U and V are orthogonal and X is nonsingular, and D1 and D2 are
*  ``diagonal''.  The former GSVD form can be converted to the latter
*  form by taking the nonsingular matrix X as
*                        X = Q*(  I   0    )
*                              (  0 inv(R) )
"

	<cdecl: long 'zggsvd_'( char * char * char * long * long * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xheconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHECON estimates the reciprocal of the condition number of a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by ZHETRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'zhecon_'( char * long * "ExternalDoubleComplex"void * long * long * double * double * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork info: info length: ljobz length: luplo 
	<cdecl: void 'zheev_'( char * char * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevdWithjobz: jobz uplo: uplo n: n a: a lda: lda w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHEEVD computes all eigenvalues and, optionally, eigenvectors of a
*  complex Hermitian matrix A.  If eigenvectors are desired, it uses a
*  divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zheevd_'( char * char * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevrWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz isuppz: isuppz work: work lwork: lwork rwork: rwork iwork: iwork info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHEEVR computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix T.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
*  Whenever possible, ZHEEVR calls ZSTEGR to compute the
*  eigenspectrum using Relatively Robust Representations.  ZSTEGR
*  computes eigenvalues by the dqds algorithm, while orthogonal
*  eigenvectors are computed from various 'good' L D L^T representations
*  (also known as Relatively Robust Representations). Gram-Schmidt
*  orthogonalization is avoided as far as possible. More specifically,
*  the various steps of the algorithm are as follows. For the i-th
*  unreduced block of T,
*     (a) Compute T - sigma_i = L_i D_i L_i^T, such that L_i D_i L_i^T
*          is a relatively robust representation,
*     (b) Compute the eigenvalues, lambda_j, of L_i D_i L_i^T to high
*         relative accuracy by the dqds algorithm,
*     (c) If there is a cluster of close eigenvalues, 'choose' sigma_i
*         close to the cluster, and go to step (a),
*     (d) Given the approximate eigenvalue lambda_j of L_i D_i L_i^T,
*         compute the corresponding eigenvector by forming a
*         rank-revealing twisted factorization.
*  The desired accuracy of the output can be specified by the input
*  parameter ABSTOL.
*  For more details, see 'A new O(n^2) algorithm for the symmetric
*  tridiagonal eigenvalue/eigenvector problem', by Inderjit Dhillon,
*  Computer Science Division Technical Report No. UCB//CSD-97-971,
*  UC Berkeley, May 1997.
*  Note 1 : ZHEEVR calls ZSTEGR when the full spectrum is requested
*  on machines which conform to the ieee-754 floating point standard.
*  ZHEEVR calls DSTEBZ and ZSTEIN on non-ieee machines and
*  when partial spectrum requests are made.
*  Normal execution of ZSTEGR may create NaNs and infinities and
*  hence may abort due to a floating point exception in environments
*  which do not handle NaNs and infinities in the ieee standard default
*  manner.
"

	<cdecl: long 'zheevr_'( char * char * char * long * "ExternalDoubleComplex"void * long * double * double * long * long * double * long * double * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * double * long * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xheevxWithjobz: jobz range: range uplo: uplo n: n a: a lda: lda vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHEEVX computes selected eigenvalues and, optionally, eigenvectors
*  of a complex Hermitian matrix A.  Eigenvalues and eigenvectors can
*  be selected by specifying either a range of values or a range of
*  indices for the desired eigenvalues.
"

	<cdecl: long 'zheevx_'( char * char * char * long * "ExternalDoubleComplex"void * long * double * double * long * long * double * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhegvWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHEGV computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.
*  Here A and B are assumed to be Hermitian and B is also
*  positive definite.
"

	<cdecl: long 'zhegv_'( long * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhegvdWithitype: itype jobz: jobz uplo: uplo n: n a: a lda: lda b: b ldb: ldb w: w work: work lwork: lwork rwork: rwork lrwork: lrwork iwork: iwork liwork: liwork info: info length: lengthOfjobz length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHEGVD computes all the eigenvalues, and optionally, the eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  If eigenvectors are desired, it uses a divide and conquer algorithm.
*  The divide and conquer algorithm makes very mild assumptions about
*  floating point arithmetic. It will work on machines with a guard
*  digit in add/subtract, or on those binary machines without guard
*  digits which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or
*  Cray-2. It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.
"

	<cdecl: long 'zhegvd_'( long * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * long * double * long * long * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhegvxWithitype: itype jobz: jobz range: range uplo: uplo n: n a: a lda: lda b: b ldb: ldb vl: vl vu: vu il: il iu: iu abstol: abstol m: m w: w z: z ldz: ldz work: work lwork: lwork rwork: rwork iwork: iwork ifail: ifail info: info length: lengthOfjobz length: lengthOfrange length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHEGVX computes selected eigenvalues, and optionally, eigenvectors
*  of a complex generalized Hermitian-definite eigenproblem, of the form
*  A*x=(lambda)*B*x,  A*Bx=(lambda)*x,  or B*A*x=(lambda)*x.  Here A and
*  B are assumed to be Hermitian and B is also positive definite.
*  Eigenvalues and eigenvectors can be selected by specifying either a
*  range of values or a range of indices for the desired eigenvalues.
"

	<cdecl: long 'zhegvx_'( long * char * char * char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * long * long * double * long * double * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhesvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHESV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N Hermitian matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**H,  if UPLO = 'U', or
*     A = L * D * L**H,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'zhesv_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhetrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHETRF computes the factorization of a complex Hermitian matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**H  or  A = L*D*L**H
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is Hermitian and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'zhetrf_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhetriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHETRI computes the inverse of a complex Hermitian indefinite matrix
*  A using the factorization A = U*D*U**H or A = L*D*L**H computed by
*  ZHETRF.
"

	<cdecl: long 'zhetri_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xhetrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZHETRS solves a system of linear equations A*X = B with a complex
*  Hermitian matrix A using the factorization A = U*D*U**H or
*  A = L*D*L**H computed by ZHETRF.
"

	<cdecl: long 'zhetrs_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlacgvWithn: n x: x incx: incx 
	"
*  Purpose
*  =======
*  ZLACGV conjugates a complex vector of length N.
"

	<cdecl: long 'zlacgv_'( long * "ExternalDoubleComplex"void * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlacpyWithuplo: uplo m: m n: n a: a lda: lda b: b ldb: ldb length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZLACPY copies all or part of a two-dimensional matrix A to another
*  matrix B.
"

	<cdecl: long 'zlacpy_'( char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlangeWithnorm: norm m: m n: n a: a lda: lda work: work length: lengthOfnorm 
	"
*  Purpose
*  =======
*  ZLANGE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex matrix A.
"

	<cdecl: double 'zlange_'( char * long * long * "ExternalDoubleComplex"void * long * double * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlanheWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZLANHE  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A.
"

	<cdecl: double 'zlanhe_'( char * char * long * "ExternalDoubleComplex"void * long * double * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlanhpWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZLANHP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex hermitian matrix A,  supplied in packed form.
"

	<cdecl: double 'zlanhp_'( char * char * long * "ExternalDoubleComplex"void * double * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlanspWithnorm: norm uplo: uplo n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZLANSP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A,  supplied in packed form.
"

	<cdecl: double 'zlansp_'( char * char * long * "ExternalDoubleComplex"void * double * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlansyWithnorm: norm uplo: uplo n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZLANSY  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  complex symmetric matrix A.
"

	<cdecl: double 'zlansy_'( char * char * long * "ExternalDoubleComplex"void * long * double * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlantpWithnorm: norm uplo: uplo diag: diag n: n ap: ap work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZLANTP  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  triangular matrix A, supplied in packed form.
"

	<cdecl: double 'zlantp_'( char * char * char * long * "ExternalDoubleComplex"void * double * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlantrWithnorm: norm uplo: uplo diag: diag m: m n: n a: a lda: lda work: work length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZLANTR  returns the value of the one norm,  or the Frobenius norm, or
*  the  infinity norm,  or the  element of  largest absolute value  of a
*  trapezoidal or triangular matrix A.
"

	<cdecl: double 'zlantr_'( char * char * char * long * long * "ExternalDoubleComplex"void * long * double * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlarnvWithidist: idist iseed: iseed n: n x: x 
	"
*  Purpose
*  =======
*  ZLARNV returns a vector of n random complex numbers from a uniform or
*  normal distribution.
"

	<cdecl: long 'zlarnv_'( long * long * long * "ExternalDoubleComplex"void * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xlasetWithuplo: uplo m: m n: n alpha: alpha beta: beta a: a lda: lda length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZLASET initializes a 2-D array A to BETA on the diagonal and
*  ALPHA on the offdiagonals.
"

	<cdecl: long 'zlaset_'( char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xpotrfWithuplo: uplo n: n a: a lda: lda info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZPOTRF computes the Cholesky factorization of a complex Hermitian
*  positive definite matrix A.
*  The factorization has the form
*     A = U**H * U,  if UPLO = 'U', or
*     A = L  * L**H,  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*  This is the block version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'zpotrf_'( char * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xspconWithuplo: uplo n: n ap: ap ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSPCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric packed matrix A using the
*  factorization A = U*D*U**T or A = L*D*L**T computed by ZSPTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'zspcon_'( char * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xspsvWithuplo: uplo n: n nrhs: nrhs ap: ap ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSPSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix stored in packed format and X
*  and B are N-by-NRHS matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, D is symmetric and block diagonal with 1-by-1
*  and 2-by-2 diagonal blocks.  The factored form of A is then used to
*  solve the system of equations A * X = B.
"

	<cdecl: long 'zspsv_'( char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsptrfWithuplo: uplo n: n ap: ap ipiv: ipiv info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSPTRF computes the factorization of a complex symmetric matrix A
*  stored in packed format using the Bunch-Kaufman diagonal pivoting
*  method:
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.
"

	<cdecl: long 'zsptrf_'( char * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsptriWithuplo: uplo n: n ap: ap ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSPTRI computes the inverse of a complex symmetric indefinite matrix
*  A in packed storage using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by ZSPTRF.
"

	<cdecl: long 'zsptri_'( char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsptrsWithuplo: uplo n: n nrhs: nrhs ap: ap ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSPTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A stored in packed format using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by ZSPTRF.
"

	<cdecl: long 'zsptrs_'( char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsyconWithuplo: uplo n: n a: a lda: lda ipiv: ipiv anorm: anorm rcond: rcond work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSYCON estimates the reciprocal of the condition number (in the
*  1-norm) of a complex symmetric matrix A using the factorization
*  A = U*D*U**T or A = L*D*L**T computed by ZSYTRF.
*  An estimate is obtained for norm(inv(A)), and the reciprocal of the
*  condition number is computed as RCOND = 1 / (ANORM * norm(inv(A))).
"

	<cdecl: long 'zsycon_'( char * long * "ExternalDoubleComplex"void * long * long * double * double * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsysvWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSYSV computes the solution to a complex system of linear equations
*     A * X = B,
*  where A is an N-by-N symmetric matrix and X and B are N-by-NRHS
*  matrices.
*  The diagonal pivoting method is used to factor A as
*     A = U * D * U**T,  if UPLO = 'U', or
*     A = L * D * L**T,  if UPLO = 'L',
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  1-by-1 and 2-by-2 diagonal blocks.  The factored form of A is then
*  used to solve the system of equations A * X = B.
"

	<cdecl: long 'zsysv_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsytrfWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work lwork: lwork info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSYTRF computes the factorization of a complex symmetric matrix A
*  using the Bunch-Kaufman diagonal pivoting method.  The form of the
*  factorization is
*     A = U*D*U**T  or  A = L*D*L**T
*  where U (or L) is a product of permutation and unit upper (lower)
*  triangular matrices, and D is symmetric and block diagonal with
*  with 1-by-1 and 2-by-2 diagonal blocks.
*  This is the blocked version of the algorithm, calling Level 3 BLAS.
"

	<cdecl: long 'zsytrf_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsytriWithuplo: uplo n: n a: a lda: lda ipiv: ipiv work: work info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSYTRI computes the inverse of a complex symmetric indefinite matrix
*  A using the factorization A = U*D*U**T or A = L*D*L**T computed by
*  ZSYTRF.
"

	<cdecl: long 'zsytri_'( char * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xsytrsWithuplo: uplo n: n nrhs: nrhs a: a lda: lda ipiv: ipiv b: b ldb: ldb info: info length: lengthOfuplo 
	"
*  Purpose
*  =======
*  ZSYTRS solves a system of linear equations A*X = B with a complex
*  symmetric matrix A using the factorization A = U*D*U**T or
*  A = L*D*L**T computed by ZSYTRF.
"

	<cdecl: long 'zsytrs_'( char * long * long * "ExternalDoubleComplex"void * long * long * "ExternalDoubleComplex"void * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtgexcWithwantq: wantq wantz: wantz n: n a: a lda: lda b: b ldb: ldb q: q ldq: ldq z: z ldz: ldz ifst: ifst ilst: ilst info: info 
	"
*  Purpose
*  =======
*  ZTGEXC reorders the generalized Schur decomposition of a complex
*  matrix pair (A,B), using an unitary equivalence transformation
*  (A, B) := Q * (A, B) * Z', so that the diagonal block of (A, B) with
*  row index IFST is moved to row ILST.
*  (A, B) must be in generalized Schur canonical form, that is, A and
*  B are both upper triangular.
*  Optionally, the matrices Q and Z of generalized Schur vectors are
*  updated.
*         Q(in) * A(in) * Z(in)' = Q(out) * A(out) * Z(out)'
*         Q(in) * B(in) * Z(in)' = Q(out) * B(out) * Z(out)'
"

	<cdecl: long 'ztgexc_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtgsenWithijob: ijob wantq: wantq wantz: wantz select: select n: n a: a lda: lda b: b ldb: ldb alpha: alpha beta: beta q: q ldq: ldq z: z ldz: ldz m: m dif: dif work: work lwork: lwork iwork: iwork liwork: liwork info: info 
	"
*  Purpose
*  =======
*  ZTGSEN reorders the generalized Schur decomposition of a complex
*  matrix pair (A, B) (in terms of an unitary equivalence trans-
*  formation Q' * (A, B) * Z), so that a selected cluster of eigenvalues
*  appears in the leading diagonal blocks of the pair (A,B). The leading
*  columns of Q and Z form unitary bases of the corresponding left and
*  right eigenspaces (deflating subspaces). (A, B) must be in
*  generalized Schur canonical form, that is, A and B are both upper
*  triangular.
*  ZTGSEN also computes the generalized eigenvalues
*           w(j)= ALPHA(j) / BETA(j)
*  of the reordered matrix pair (A, B).
*  Optionally, the routine computes estimates of reciprocal condition
*  numbers for eigenvalues and eigenspaces. These are Difu[(A11,B11),
*  (A22,B22)] and Difl[(A11,B11), (A22,B22)], i.e. the separation(s)
*  between the matrix pairs (A11, B11) and (A22,B22) that correspond to
*  the selected cluster and the eigenvalues outside the cluster, resp.,
*  and norms of 'projections' onto left and right eigenspaces w.r.t.
*  the selected cluster in the (1,1)-block.
"

	<cdecl: long 'ztgsen_'( long * long * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * double * "ExternalDoubleComplex"void * long * long * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtgsylWithtrans: trans ijob: ijob m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc d: d ldd: ldd e: e lde: lde f: f ldf: ldf dif: dif scale: scale work: work lwork: lwork iwork: iwork info: info length: lengthOftrans 
	"
*  Purpose
*  =======
*  ZTGSYL solves the generalized Sylvester equation:
*              A * R - L * B = scale * C            (1)
*              D * R - L * E = scale * F
*  where R and L are unknown m-by-n matrices, (A, D), (B, E) and
*  (C, F) are given matrix pairs of size m-by-m, n-by-n and m-by-n,
*  respectively, with complex entries. A, B, D and E are upper
*  triangular (i.e., (A,D) and (B,E) in generalized Schur form).
*  The solution (R, L) overwrites (C, F). 0 <= SCALE <= 1
*  is an output scaling factor chosen to avoid overflow.
*  In matrix notation (1) is equivalent to solve Zx = scale*b, where Z
*  is defined as
*         Z = [ kron(In, A)  -kron(B', Im) ]        (2)
*             [ kron(In, D)  -kron(E', Im) ],
*  Here Ix is the identity matrix of size x and X' is the conjugate
*  transpose of X. Kron(X, Y) is the Kronecker product between the
*  matrices X and Y.
*  If TRANS = 'C', y in the conjugate transposed system Z'*y = scale*b
*  is solved for, which is equivalent to solve for R and L in
*              A' * R + D' * L = scale * C           (3)
*              R * B' + L * E' = scale * -F
*  This case (TRANS = 'C') is used to compute an one-norm-based estimate
*  of Dif[(A,D), (B,E)], the separation between the matrix pairs (A,D)
*  and (B,E), using ZLACON.
*  If IJOB >= 1, ZTGSYL computes a Frobenius norm-based estimate of
*  Dif[(A,D),(B,E)]. That is, the reciprocal of a lower bound on the
*  reciprocal of the smallest singular value of Z.
*  This is a level-3 BLAS algorithm.
"

	<cdecl: long 'ztgsyl_'( char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtpconWithnorm: norm uplo: uplo diag: diag n: n ap: ap rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ztpcon_'( char * char * char * long * "ExternalDoubleComplex"void * double * "ExternalDoubleComplex"void * double * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtptriWithuplo: uplo diag: diag n: n ap: ap info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZTPTRI computes the inverse of a complex upper or lower triangular
*  matrix A stored in packed format.
"

	<cdecl: long 'ztptri_'( char * char * long * "ExternalDoubleComplex"void * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtptrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs ap: ap b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZTPTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
"

	<cdecl: long 'ztptrs_'( char * char * char * long * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrconWithnorm: norm uplo: uplo diag: diag n: n a: a lda: lda rcond: rcond work: work rwork: rwork info: info length: lengthOfnorm length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
"

	<cdecl: long 'ztrcon_'( char * char * char * long * "ExternalDoubleComplex"void * long * double * "ExternalDoubleComplex"void * double * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrexcWithcompq: compq n: n t: t ldt: ldt q: q ldq: ldq ifst: ifst ilst: ilst info: info length: lengthOfcompq 
	"
*  Purpose
*  =======
*  ZTREXC reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*  is moved to row ILST.
*  The Schur form T is reordered by a unitary similarity transformation
*  Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*  postmultplying it with Z.
"

	<cdecl: long 'ztrexc_'( char * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long * long * long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrsenWithjob: job compq: compq select: select n: n t: t ldt: ldt q: q ldq: ldq w: w m: m s: s sep: sep work: work lwork: lwork info: info length: lengthOfjob length: lengthOfcompq 
	"
*  Purpose
*  =======
*  ZTRSEN reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that a selected cluster of eigenvalues appears in
*  the leading positions on the diagonal of the upper triangular matrix
*  T, and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
"

	<cdecl: long 'ztrsen_'( char * char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * double * "ExternalDoubleComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrsylWithtrana: trana tranb: tranb isgn: isgn m: m n: n a: a lda: lda b: b ldb: ldb c: c ldc: ldc scale: scale info: info length: lengthOftrana length: lengthOftranb 
	"
*  Purpose
*  =======
*  ZTRSYL solves the complex Sylvester matrix equation:
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*  where op(A) = A or A**H, and A and B are both upper triangular. A is
*  M-by-M and B is N-by-N; the right hand side C and the solution X are
*  M-by-N; and scale is an output scale factor, set <= 1 to avoid
*  overflow in X.
"

	<cdecl: long 'ztrsyl_'( char * char * long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * double * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrtriWithuplo: uplo diag: diag n: n a: a lda: lda info: info length: lengthOfuplo length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZTRTRI computes the inverse of a complex upper or lower triangular
*  matrix A.
*  This is the Level 3 BLAS version of the algorithm.
"

	<cdecl: long 'ztrtri_'( char * char * long * "ExternalDoubleComplex"void * long * long * long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xtrtrsWithuplo: uplo trans: trans diag: diag n: n nrhs: nrhs a: a lda: lda b: b ldb: ldb info: info length: lengthOfuplo length: lengthOftrans length: lengthOfdiag 
	"
*  Purpose
*  =======
*  ZTRTRS solves a triangular system of the form
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
"

	<cdecl: long 'ztrtrs_'( char * char * char * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * long * long * long long long )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xunghrWithn: n ilo: ilo ihi: ihi a: a lda: lda tau: tau work: work lwork: lwork info: info 
	<cdecl: void 'zunghr_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xunglqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGLQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the first M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(k)' . . . H(2)' H(1)'
*  as returned by ZGELQF.
"

	<cdecl: long 'zunglq_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xungqlWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGQL generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the last N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(k) . . . H(2) H(1)
*  as returned by ZGEQLF.
"

	<cdecl: long 'zungql_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xungqrWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGQR generates an M-by-N complex matrix Q with orthonormal columns,
*  which is defined as the first N columns of a product of K elementary
*  reflectors of order M
*        Q  =  H(1) H(2) . . . H(k)
*  as returned by ZGEQRF.
"

	<cdecl: long 'zungqr_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !

!LapackZLibrary methodsFor: 'procedures' stamp: ''!
xungrqWithm: m n: n k: k a: a lda: lda tau: tau work: work lwork: lwork info: info 
	"
*  Purpose
*  =======
*  ZUNGRQ generates an M-by-N complex matrix Q with orthonormal rows,
*  which is defined as the last M rows of a product of K elementary
*  reflectors of order N
*        Q  =  H(1)' H(2)' . . . H(k)'
*  as returned by ZGERQF.
"

	<cdecl: long 'zungrq_'( long * long * long * "ExternalDoubleComplex"void * long * "ExternalDoubleComplex"void * "ExternalDoubleComplex"void * long * long * )>
	^self externalCallFailed! !
